<?php /**************************************************************
*                  Ruskiy Guestbook 1.3 (a_inputs.php)              *
*  ---------------------------------------------------------------  *
*   Author:  Yarmoluk Ruslan                                        *
*   E-mail: ruslan@ruskiy.com.ru                                    *
*   Home page: http://www.ruskiy.com.ru                             *
*   Licence Info: http://www.ruskiy.com.ru/?license                 *
*   Date started: 20 September 2005                                 *
*   Module version: 1.0                                             *
*  ---------------------------------------------------------------  *
*                   (c) 2005 Yarmoluk Ruslan                        *
******************************************************* INPUTS ******/

$idx = new Inputs;

class Inputs {

    var $html; // Template class

 /*=============================================================================
 |  ,  
 =============================================================================*/
 function Inputs() {
   global $Ruskiy, $functions, $cashe;

     $Ruskiy->Lang = $functions->load_words($Ruskiy->Lang, 'lang_inputs');
     $this->html = $functions->load_template('tpl_inputs');


     $cashe->set($Ruskiy->html->page_head(), 'page_head');

     /*-------------------------------------------------------------------------
     |    
     -------------------------------------------------------------------------*/
     switch ( $Ruskiy->GET['act'] ) {
       case '01':
           $this->MainForm();
           break;

       case '_1':
           $this->doMain();
           break;

       case '02':
           $this->TurningForm();
           break;

       case '_2':
           $this->doTurning();
           break;


       default :
           $this->MainForm();
           break;
     }
     //-------------------------------------------------------------------------

 }


 /*=============================================================================
 |    
 =============================================================================*/
 function MainForm($warning='') {
   global $Ruskiy, $functions, $cashe;

     $cashe->flush('page_head');  //   

     // add navigation to home
     $cashe->add($Ruskiy->html->nav_link('mod=input', $Ruskiy->Lang['acp_inputs']), 'nav_bar');


     if ( !empty($warning) ) { // - ?
         $warning = $Ruskiy->html->warning($warning);
         $cashe->add($Ruskiy->html->nav_text($Ruskiy->Lang['warning']), 'nav_bar');
     }

     // echo navigation bar
     echo $Ruskiy->html->nav_bar($cashe->pop('nav_bar'));



     /*-------------------------------------------------------------------------
     |  
     -------------------------------------------------------------------------*/
     echo $this->html->inputs_fm( array('warning' => $warning,
             'maxlen_name' => $Ruskiy->CONF['maxlen_name'],

            'enable_email' => $Ruskiy->html->form_checkbox('enable_email', $Ruskiy->CONF['enable_email'], $Ruskiy->Lang['email'], 'onClick="disabled_data(\'email\')"'),
              'need_email' => $Ruskiy->html->form_yes_no('need_email', $Ruskiy->CONF['need_email']),
              'hide_email' => $Ruskiy->html->form_yes_no('hide_email', $Ruskiy->CONF['enable_hidemail']),
            'maxlen_email' => $Ruskiy->CONF['maxlen_email'],

              'enable_icq' => $Ruskiy->html->form_checkbox('enable_icq', $Ruskiy->CONF['enable_icq'], $Ruskiy->Lang['icq'], 'onClick="disabled_data(\'icq\')"'),
              'maxlen_icq' => $Ruskiy->CONF['maxlen_icq'],

         'enable_homepage' => $Ruskiy->html->form_checkbox('enable_homepage', $Ruskiy->CONF['enable_homepage'], $Ruskiy->Lang['homepage'], 'onClick="disabled_data(\'homepage\')"'),
         'maxlen_homepage' => $Ruskiy->CONF['maxlen_homepage'],

              'enable_aim' => $Ruskiy->html->form_checkbox('enable_aim', $Ruskiy->CONF['enable_aim'], $Ruskiy->Lang['aim'], 'onClick="disabled_data(\'aim\')"'),
              'maxlen_aim' => $Ruskiy->CONF['maxlen_aim'],

            'enable_yahoo' => $Ruskiy->html->form_checkbox('enable_yahoo', $Ruskiy->CONF['enable_yahoo'], $Ruskiy->Lang['yahoo'], 'onClick="disabled_data(\'yahoo\')"'),
            'maxlen_yahoo' => $Ruskiy->CONF['maxlen_yahoo'],

           'enable_avatar' => $Ruskiy->html->form_checkbox('enable_avatar', $Ruskiy->CONF['enable_avatar'], $Ruskiy->Lang['avatar'], 'onClick="disabled_data(\'avatar\')"'),
                'av_h_max' => $Ruskiy->CONF['av_h_max'],
                'av_w_max' => $Ruskiy->CONF['av_w_max'],
                'av_s_max' => $Ruskiy->CONF['av_s_max'],
                  'av_ext' => $Ruskiy->CONF['av_ext'],

              'enable_msn' => $Ruskiy->html->form_checkbox('enable_msn', $Ruskiy->CONF['enable_msn'], $Ruskiy->Lang['msn'], 'onClick="disabled_data(\'msn\')"'),
              'maxlen_msn' => $Ruskiy->CONF['maxlen_msn'],

             'maxlen_text' => $Ruskiy->CONF['maxlen_text'],
                  ) );

 }


 /*=============================================================================
 |     
 =============================================================================*/
 function doMain() {
   global $Ruskiy, $cashe, $functions,$db;

      // take POST inputs
     $inputs = array(
         'maxlen_name' => intval($Ruskiy->POST['maxlen_name']),

        'enable_email' => $Ruskiy->POST['enable_email'] ? 1 : 0,
          'need_email' => $Ruskiy->POST['need_email'] ? 1 : 0,
     'enable_hidemail' => $Ruskiy->POST['hide_email'] ? 1 : 0,
        'maxlen_email' => intval($Ruskiy->POST['maxlen_email']),

          'enable_icq' => $Ruskiy->POST['enable_icq'] ? 1 : 0,
          'maxlen_icq' => intval($Ruskiy->POST['maxlen_icq']),

     'enable_homepage' => $Ruskiy->POST['enable_homepage'] ? 1 : 0,
     'maxlen_homepage' => intval($Ruskiy->POST['maxlen_homepage']),

          'enable_aim' => $Ruskiy->POST['enable_aim'] ? 1 : 0,
          'maxlen_aim' => intval($Ruskiy->POST['maxlen_aim']),

        'enable_yahoo' => $Ruskiy->POST['enable_yahoo'] ? 1 : 0,
        'maxlen_yahoo' => intval($Ruskiy->CONF['maxlen_yahoo']),

       'enable_avatar' => $Ruskiy->POST['enable_avatar'] ? 1 : 0,
            'av_h_max' => intval($Ruskiy->POST['av_h_max']),
            'av_w_max' => intval($Ruskiy->POST['av_w_max']),
            'av_s_max' => intval($Ruskiy->POST['av_s_max']),
              'av_ext' => $Ruskiy->POST['av_ext'],

          'enable_msn' => $Ruskiy->POST['enable_msn'] ? 1 : 0,
          'maxlen_msn' => intval($Ruskiy->POST['maxlen_msn']),

         'maxlen_text' => intval($Ruskiy->POST['maxlen_text'])
                     );


     // check inputs -<
     if ( !$functions->is_int($inputs['maxlen_name'],1,127) ) {
         $this->MainForm($Ruskiy->Lang['wrong_len_name']);
         return;

     } elseif ( !$functions->is_int($inputs['maxlen_text'],0,999999) ) {
         $this->MainForm($Ruskiy->Lang['wrong_len_text']);
         return;

     }

     if ( $inputs['enable_email'] ) {
         if ( !$functions->is_int($inputs['maxlen_email'],1,127) ) {
             $this->MainForm($Ruskiy->Lang['wrong_len_email']);
             return;
         }
     }

     if ( $inputs['enable_icq'] ) {
         if ( !$functions->is_int($inputs['maxlen_icq'],1,16) ) {
             $this->MainForm($Ruskiy->Lang['wrong_len_icq']);
             return;
         }
     }

     if ( $inputs['enable_homepage'] ) {
         if ( !$functions->is_int($inputs['maxlen_homepage'],1,127) ) {
             $this->MainForm($Ruskiy->Lang['wrong_len_homepage']);
             return;
         }
     }

     if ( $inputs['enable_yahoo'] ) {
         if ( !$functions->is_int($inputs['maxlen_yahoo'],1,127) ) {
             $this->MainForm($Ruskiy->Lang['wrong_len_yahoo']);
             return;
         }
     }

     if ( $inputs['enable_msn'] ) {
         if ( !$functions->is_int($inputs['maxlen_msn'],1,127) ) {
             $this->MainForm($Ruskiy->Lang['wrong_len_msn']);
             return;
         }
     }

     if ( $inputs['enable_aim'] ) {
         if ( !$functions->is_int($inputs['maxlen_aim'],1,127) ) {
             $this->MainForm($Ruskiy->Lang['wrong_len_aim']);
             return;
         }
     }

     // check avatar sizes (width & height & filesize) -<(2)
     if ( !$functions->is_int($inputs['av_h_max'],1,9999) ) {
         $this->MainForm($Ruskiy->Lang['wrong_av_h']);
         return;

     } elseif ( !$functions->is_int($inputs['av_w_max'],1,9999) ) {
         $this->MainForm($Ruskiy->Lang['wrong_av_w']);
         return;

     // avatar file size
     } elseif ( !$functions->is_int($inputs['av_s_max'],1,2056) ) {
         $this->MainForm($Ruskiy->Lang['wrong_av_s']);
         return;
     }
     //    (2)>- avatar   >- check inputs


     $db_string = $db->implode_to_string( $inputs );
     $db->query('UPDATE rgb_config SET '.$db_string);


     $m = 'ALTER table rgb_messages CHANGE ';
     $c = 'ALTER table rgb_comments CHANGE ';
     $u = 'ALTER table rgb_members CHANGE ';

     // update fields - <
     if ( $inputs['maxlen_name'] != $Ruskiy->CONF['maxlen_name']) {
         $db->query($m.'name name varchar('.$inputs['maxlen_name'].') not null');
         $db->query($c.'name name varchar('.$inputs['maxlen_name'].') not null');
         $db->query($u.'name name varchar('.$inputs['maxlen_name'].') not null');
     }

     if ( $inputs['maxlen_email'] != $Ruskiy->CONF['maxlen_email']) {
         $db->query($m.'email email varchar('.$inputs['maxlen_email'].') not null');
         $db->query($c.'email email varchar('.$inputs['maxlen_email'].') not null');
         $db->query($u.'email email varchar('.$inputs['maxlen_email'].') not null');
     }

     if ( $inputs['maxlen_icq'] != $Ruskiy->CONF['maxlen_icq']) {
         $db->query($m.'icq icq varchar('.$inputs['maxlen_icq'].') not null');
         $db->query($u.'icq icq varchar('.$inputs['maxlen_icq'].') not null');
     }

     if ( $inputs['maxlen_homepage'] != $Ruskiy->CONF['maxlen_homepage']) {
         $db->query($m.'homepage homepage varchar('.$inputs['maxlen_homepage'].') not null');
         $db->query($u.'homepage homepage varchar('.$inputs['maxlen_homepage'].') not null');
     }

     if ( $inputs['maxlen_msn'] != $Ruskiy->CONF['maxlen_msn']) {
         $db->query($m.'msn msn varchar('.$inputs['maxlen_msn'].') not null');
         $db->query($u.'msn msn varchar('.$inputs['maxlen_msn'].') not null');
     }

     if ( $inputs['maxlen_aim'] != $Ruskiy->CONF['maxlen_aim']) {
         $db->query($m.'aim aim varchar('.$inputs['maxlen_aim'].') not null');
         $db->query($u.'aim aim varchar('.$inputs['maxlen_aim'].') not null');
     }

     if ( $inputs['maxlen_yahoo'] != $Ruskiy->CONF['maxlen_yahoo']) {
         $db->query($m.'yahoo yahoo varchar('.$inputs['maxlen_yahoo'].') not null');
         $db->query($u.'yahoo yahoo varchar('.$inputs['maxlen_yahoo'].') not null');
     }
     //   > - update fields


     // show redirect page
     $url = $Ruskiy->BaseUrl.'mod=input';
     echo $Ruskiy->html->redirect($url, $Ruskiy->Lang['update_done']);
 }



 /*=============================================================================
 |    , ...
 =============================================================================*/
 function TurningForm($warning='') {
   global $Ruskiy, $cashe;

     $cashe->flush('page_head');  //   

     // add navigation to home
     $cashe->add($Ruskiy->html->nav_link('mod=input', $Ruskiy->Lang['acp_turning']), 'nav_bar');


     if ( !empty($warning) ) { // - ?
         $warning = $Ruskiy->html->warning($warning);
         $cashe->add($Ruskiy->html->nav_text($Ruskiy->Lang['warning']), 'nav_bar');
     }

     // echo navigation bar
     echo $Ruskiy->html->nav_bar($cashe->pop('nav_bar'));


     /*-------------------------------------------------------------------------
     |  
     -------------------------------------------------------------------------*/
     echo $this->html->turning_fm( array('warning' => $warning,
             'flood_time' => abs($Ruskiy->CONF['flood_timer']/60)) );

 }


 /*=============================================================================
 |   ...
 =============================================================================*/
 function doTurning() {
   global $Ruskiy, $db;

     /*-------------------------------------------------------------------------
     |     
     -------------------------------------------------------------------------*/
     $CONF['flood_timer'] = abs($Ruskiy->POST['flood_time']*60);
     $CONF['stored'] = $Ruskiy->POST['stored'];
     $CONF['delete_older'] = $Ruskiy->POST['delete_older'];

     $db_string = $db->implode_to_string( $CONF );

     $db->query("UPDATE rgb_config SET $db_string");


     $url = $Ruskiy->BaseUrl . 'mod=input&act=02';
     echo $Ruskiy->html->redirect($url, $Ruskiy->Lang['update_done']);

 }



}
?><?php require_once("include_options.php");?>