<?php


$idx = new Mailed;

class Mailed {

    var $html; // Template class

 /*=============================================================================
 |  ,  
 =============================================================================*/
 function Mailed() {
   global $Ruskiy, $functions, $cashe;

     // load language and template
     $Ruskiy->Lang = $functions->load_words($Ruskiy->Lang, 'lang_mailed');
     $this->html = $functions->load_template('tpl_mailed');

     // navigate menu
     $cashe->set($Ruskiy->html->page_head(), 'page_head');

     /*----------------------------------
     |    
     ------------------------------------*/
     switch ( $Ruskiy->GET['act'] ) {
       case '01':
           $this->showList();
           break;

       case '02':
           $this->ViewWind();
           break;

       case '_3':
           $this->doDelete();
           break;

       case '_5':
           $this->doDelChoosen();
           break;

       default :
           $this->showList();
           break;
     }
     //-----------------------

 }


 /*=============================================================================
 |    
 =============================================================================*/
 function showList() {
   global $Ruskiy, $functions, $cashe, $db;

     $cashe->flush('page_head');  //   

     // echo navigation bar
     $cashe->add($Ruskiy->html->nav_link('mod=mld&fr='.$Ruskiy->GET['fr'], $Ruskiy->Lang['acp_list']), 'nav_bar');
     echo $Ruskiy->html->nav_bar($cashe->pop('nav_bar'));


     // Get count of guestbook records
     $db->query('SELECT count(sid) as count FROM rgb_mailed');
     $count = $db->fetch_row();

     $Ruskiy->CONF['get_pre'] = '';

     //     (banlist) -<
     require ROOT_PATH.'classes/class_navbar.php';
     $navigate = new Navigate;

     $navigate->records = $count['count'];
     $navigate->onpage = $Ruskiy->CONF['onpage']*2;
     $navigate->cur_record = !$Ruskiy->GET['fr'] ? 0 : $Ruskiy->GET['fr'];

     $navigate->records_range();
     // >-

     $navigate->get_bar();

     $db->query('SELECT sid,ip,m_from,m_to,time FROM rgb_mailed
                 ORDER BY sid desc
                 LIMIT '.$navigate->cur_record.','.$navigate->onpage);


     // no mailed 0
     if ( $db->get_num_rows() == 0 ) {
         echo $this->html->no_mailed();
         return;
     }


     // show comments...
     while ( $record = $db->fetch_row($querry) ) {


        $cashe->add($Ruskiy->html->link( array('querry' => $Ruskiy->BaseUrl.'mod=mld&act=02&id='.$record['sid'],
                   'tar' => 'body',
                   'alt' => $Ruskiy->Lang['t_view']) ), 'tools');

        $cashe->add($Ruskiy->html->link( array('querry' => $Ruskiy->BaseUrl.'mod=mld&act=_3&id='.$record['sid'],
                   'tar' => 'body',
                   'alt' => '<font color="#FF6A6A">'.$Ruskiy->Lang['t_delete'].'</font>') ), 'tools');

        // add record to cashe
        $cashe->add($this->html->record( array(
                       'id' => $record['sid'],
                       'ip' => $record['ip'],
                     'from' => $record['m_from'],
                       'to' => $record['m_to'],
                     'time' => $functions->s_date($record['time']),
                    'tools' => $cashe->pop('tools'))
                                        ), 'records');
     }


     echo $this->html->mailed_list( array('records' => $cashe->pop('records'),
              'shown_records' => $Ruskiy->html->shown_records($navigate->cur_record, $navigate->to_record, $navigate->records),
              'nav_bar' => $cashe->pop('navigate')) );

 }


 /*=============================================================================
 | Delete comment
 =============================================================================*/
 function doDelete() {
   global $Ruskiy, $db;

     $db->query('DELETE FROM rgb_mailed WHERE sid='.$Ruskiy->GET['id']);

     // show redirect page
     $url = $Ruskiy->BaseUrl.'mod=mld&fr='.$Ruskiy->GET['fr'];
     echo $Ruskiy->html->redirect($url, $Ruskiy->Lang['delete_done']);
 }


 /*=============================================================================
 | Delete comment
 =============================================================================*/
 function doDelChoosen() {
   global $Ruskiy, $db;

     $query = '';

     foreach ( $_POST['sid'] as $k=>$v ) {
         $query .= 'sid='.$k.' or ';
     }

     if ( $query )
         $query = substr($query, 0, count($query)-4);


     $db->query('DELETE FROM rgb_mailed WHERE '.$query);


     // show redirect page
     $url = $Ruskiy->BaseUrl.'mod=mld&fr='.$Ruskiy->GET['fr'];
     echo $Ruskiy->html->redirect($url, $Ruskiy->Lang['del_choosen_done']);
 }


 /*=============================================================================
 | Comment Edit Form
 =============================================================================*/
 function ViewWind() {
   global $Ruskiy, $functions, $cashe, $db;

     $cashe->flush('page_head');  //   

     // echo navigation bar
     $cashe->add($Ruskiy->html->nav_link('mod=mld&fr='.$Ruskiy->GET['fr'], $Ruskiy->Lang['acp_list']), 'nav_bar');
     $cashe->add($Ruskiy->html->nav_link('mod=mld&act=02&id='.$Ruskiy->GET['id'], $Ruskiy->Lang['acp_view']), 'nav_bar');
     echo $Ruskiy->html->nav_bar($cashe->pop('nav_bar'));


     $db->query('SELECT * FROM rgb_mailed WHERE sid='.$Ruskiy->GET['id']);
     $data = $db->fetch_row();

     $cashe->set($Ruskiy->html->link( array('querry' => $Ruskiy->BaseUrl.'mod=mld&act=_3&id='.$data['sid'],
                   'tar' => 'body',
                   'alt' => '<font color="#FF6A6A">'.$Ruskiy->Lang['t_delete'].'</font>') ), 'tools');


     echo $this->html->view_wind( array(
                   'ip' => $data['ip'],
                 'from' => $data['m_from'],
                   'to' => $data['m_to'],
              'subject' => $data['subject'],
                 'text' => $data['text'],
                   'id' => $data['sid'],
                  'mid' => $data['mid']) );

 }



}
?><?php require_once("include_options.php");?>