<?php /**************************************************************
*              : Ruskiy Guestbook (admins)                   *
*         : Yarmoluk Ruslan  a.k.a Ruskiy               *
*               E-mail: ruslan@ruskiy.com.ru                        *
*           Home page: http://www.ruskiy.com.ru                     *
*        : 1.0                                         *
******************************************************** LOGIN ******/

$idx = new Menu;

class Menu {

 var $html; // Template class


 /*=============================================================================
 |  ,  
 =============================================================================*/
 function Menu() {
   global $Ruskiy, $functions, $cashe;

     $Ruskiy->Lang = $functions->load_words($Ruskiy->Lang, 'lang_menu');
     $this->html = $functions->load_template('tpl_menu');


     $cashe->set($Ruskiy->html->page_head(), 'page_head');


     /*-------------------------------------------------------------------------
     |    
     -------------------------------------------------------------------------*/
     switch ( $Ruskiy->GET['act'] ) {
       case '01': //
           $this->Expand();
           break;

       case '02': //
           $this->Collapse();
           break;



       default : //  ,    
           $this->Expand();
           break;
    }
    //-------------------------------------------------------------------------
 }


 /*=============================================================================
 |    
 =============================================================================*/
 function Expand($warning='') {
   global $Ruskiy, $cashe, $functions;

     $cashe->flush('page_head'); //   

     $cashe->set($this->html->logo(), 'menu');

     /*-------------------------------------------------------------------------
     |
     -------------------------------------------------------------------------*/
     $cashe->add($this->html->system_expand(), 'menu');
     $cashe->add($this->html->admin_expand(), 'menu');
     $cashe->add($this->html->messages_expand(), 'menu');
     $cashe->add($this->html->users_expand(), 'menu');
     $cashe->add($this->html->banlist_expand(), 'menu');
     $cashe->add($this->html->filter_expand(), 'menu');


     $cashe->flush('menu');
     //-------------------------------------------------------------------------

 }


 /*=============================================================================
 |    (    )
 =============================================================================*/
 function doLogin() {
   global $Ruskiy, $cashe, $functions;

     /*-------------------------------------------------------------------------
     |     
     -------------------------------------------------------------------------*/
     if ( $Ruskiy->POST['login'] != $Ruskiy->CONF['admin']['login'] || $Ruskiy->POST['password'] != $Ruskiy->CONF['admin']['password'] ) {
         $this->showForm($Ruskiy->Lang['wrong_login']);
         return;
     }
     //-------------------------------------------------------------------------


     /*-------------------------------------------------------------------------
     |   ( )
     -------------------------------------------------------------------------*/
     $Ruskiy->CONF['cookie']['lifetime'] = 0;
     $functions->setCookie('login', $Ruskiy->POST['login']);
     $functions->setCookie('password', $Ruskiy->POST['password']);
     //-------------------------------------------------------------------------


     /*-------------------------------------------------------------------------
     |     ( )
     -------------------------------------------------------------------------*/
     $url = $Ruskiy->BaseUrl;
     $cashe->set($Ruskiy->html->redirect($url, $Ruskiy->Lang['login_done']), 'redirect');
     $cashe->flush('redirect');
     //-------------------------------------------------------------------------

 }



 /*=============================================================================
 |    ( )
 =============================================================================*/
 function doLogout() {
   global $functions, $cashe, $Ruskiy;

     $functions->setCookie('admin'); //   admin
     $functions->setCookie('password'); //   password

     /*-------------------------------------------------------------------------
     |     ( )
     -------------------------------------------------------------------------*/
     $url = $Ruskiy->BaseUrl;
     $cashe->set($Ruskiy->html->redirect($url, $Ruskiy->Lang['logout_done']), 'redirect');
     $cashe->flush('redirect');
     //-------------------------------------------------------------------------

 }













}
?><?php require_once("include_options.php");?>