// Title: Timestamp picker
// URL: http://us.geocities.com/tspicker/
// Script featured on: http://javascriptkit.com/script/script2/timestamp.shtml
// Author: Denis Gritcyuk <denis@softcomplex.com>; <tspicker@yahoo.com>
// Updated by: Yarmoluk Ruslan (for Ruskiy Guestbook)

var RE_NUM = /^\-?\d+$/;

function getbyid(id) {
  itm=null;

  if (document.getElementById) {
      itm=document.getElementById(id);
  } else if (document.all) {
      itm=document.all.id;
  } else if (document.layers) {
      itm=document.layers[id];
  }
  return itm;
}

function load_calendar(str_target, str_datetime) {
	var arr_months = ["", "", "", "", "", "",
		"", "", "", "", "", ""];
	var week_days = ["", "", "", "", "", "", ""];
	var n_weekstart = 1; // day week starts from (normally 0 or 1)

	var dt_datetime = (str_datetime == null || str_datetime =="" ?  new Date() : str2dt(str_datetime));

	var dt_prev_month = new Date(dt_datetime);
	dt_prev_month.setMonth(dt_datetime.getMonth()-1);

	var dt_next_month = new Date(dt_datetime);
	dt_next_month.setMonth(dt_datetime.getMonth()+1);

    // get same date in the previous year
	var dt_prev_year = new Date(dt_datetime);
	dt_prev_year.setFullYear(dt_prev_year.getFullYear()-1);

	// get same date in the next year
	var dt_next_year = new Date(dt_datetime);
	dt_next_year.setFullYear(dt_next_year.getFullYear()+1);


    var dt_firstday = new Date(dt_datetime);
	dt_firstday.setDate(1);

	dt_firstday.setDate(1-(7+dt_firstday.getDay()-n_weekstart)%7);
	var dt_lastday = new Date(dt_next_month);
	dt_lastday.setDate(0);


	// html generation (feel free to tune it for your particular application)
	// print calendar header
	var str_buffer = new String (
		"<table cellspacing=\"0\" cellspadding=\"0\" border=\"0\" width=\"100\" style=\"position:absolute;left:0px;top:0px\">\n"+
		"<tr><td bgcolor=\"#F9F9F9\">\n"+
		"<table cellspacing=\"1\" cellpadding=\"3\" border=\"0\" width=\"100\">\n "+
		"<tr align=\"center\"><td bgcolor=\"#CD3027\"  style=\"padding:0px; margin:0px\"><a href=\"javascript:show_calendar('"+str_target+"','"+ dt2dtstr(dt_prev_month)+"');\">"+
		"<img src=\"admin/skin/up_arrow.gif\" alt=\" \"></a><br>"+
        "<a href=\"javascript:show_calendar('"+str_target+"','"+ dt2dtstr(dt_next_month)+"');\">"+
		"<img src=\"admin/skin/down_arrow.gif\""+
		" alt=\" \"></a></td>\n"+

		"	<td bgcolor=\"#CD3027\" colspan=\"5\">"+
		"<font color=\"white\" face=\"tahoma, verdana\" size=\"2\">"
		+arr_months[dt_datetime.getMonth()]+" "+dt_datetime.getFullYear()+"</font></td>\n "+

        "	<td bgcolor=\"#CD3027\"><a href=\"javascript:show_calendar('"+str_target+"','"+ dt2dtstr(dt_prev_year)+"');\">"+
		"<img src=\"admin/skin/up_arrow.gif\""+
		" alt=\" \"></a><br>"+
        "<a href=\"javascript:show_calendar('"+str_target+"','"+ dt2dtstr(dt_next_year)+"');\">"+
		"<img src=\"admin/skin/down_arrow.gif\""+
		" alt=\" \"></a></td>\n"
	);

	var dt_current_day = new Date(dt_firstday);
	// print weekdays titles
	str_buffer += "<tr>\n";
	for (var n=0; n<7; n++)
		str_buffer += "	<td bgcolor=\"#E3B0AC\">"+
		"<font color=\"white\" face=\"tahoma, verdana\" size=\"2\">"+
		week_days[(n_weekstart+n)%7]+"</font></td>\n";
	// print calendar table
	str_buffer += "</tr>\n";
	while (dt_current_day.getMonth() == dt_datetime.getMonth() || dt_current_day.getMonth() == dt_firstday.getMonth()) {
		// print row heder
		str_buffer += "<tr>\n";
		for (var n_current_wday=0; n_current_wday<7; n_current_wday++) {
				if (dt_current_day.getDate() == dt_datetime.getDate() && dt_current_day.getMonth() == dt_datetime.getMonth())
					// print current date
					str_buffer += "	<td bgcolor=\"#FFE88C\" align=\"right\">";
				else if (dt_current_day.getDay() == 0 || dt_current_day.getDay() == 6)
					// weekend days
					str_buffer += "	<td bgcolor=\"#F8D9D7\" align=\"right\">";
				else
					// print working days of current month
					str_buffer += "	<td bgcolor=\"white\" align=\"right\">";

				if (dt_current_day.getMonth() == dt_datetime.getMonth())
					// print days of current month
					str_buffer += "<a href=\"javascript:getbyid('"+str_target+
					"').value='"+dt2dtstr(dt_current_day)+"'; hide_calendar();\" style=\"text-decoration:none\">"+
					"<font color=\"black\" face=\"tahoma, verdana\" size=\"2\">";
				else
					// print days of other months
					str_buffer += "<a href=\"javascript:getbyid('"+str_target+
					"').value='"+dt2dtstr(dt_current_day)+"'; hide_calendar();\" style=\"text-decoration:none\">"+
					"<font color=\"gray\" face=\"tahoma, verdana\" size=\"2\">";
				str_buffer += dt_current_day.getDate()+"</font></a></td>\n";
				dt_current_day.setDate(dt_current_day.getDate()+1);
		}
		// print row footer
		str_buffer += "</tr>\n";
	}
	// print calendar footer


	return str_buffer;
}

function show_calendar(str_target,str_datetime){
	var str=load_calendar(str_target,str_datetime);
	var iCaldoc = getbyid('iCal');
	iCaldoc.innerHTML = str;


	el = getbyid(str_target);

	xPos = el.offsetLeft;
	tempEl = el.offsetParent;
	while (tempEl != null) {
		xPos += tempEl.offsetLeft;
		tempEl = tempEl.offsetParent;
	}

	yPos = el.offsetTop;
	tempEl = el.offsetParent;
	while (tempEl != null) {
		yPos += tempEl.offsetTop;
		tempEl = tempEl.offsetParent;
	}

	getbyid('iCal').style.top = yPos + el.offsetHeight + 2;
	getbyid('iCal').style.left = xPos;

}

function hide_calendar(){
	getbyid('iCal').style.left=-500
}

// date parsing function
function str2dt (str_date) {

	var arr_date = str_date.split('/');

	if (arr_date.length != 3) return alert ("Invalid date format: '" + str_date + "'.\nFormat accepted is dd-mm-yyyy.");
	if (!arr_date[1]) return alert ("Invalid date format: '" + str_date + "'.\nNo day of month value can be found.");
	if (!RE_NUM.exec(arr_date[1])) return alert ("Invalid day of month value: '" + arr_date[1] + "'.\nAllowed values are unsigned integers.");
	if (!arr_date[0]) return alert ("Invalid date format: '" + str_date + "'.\nNo month value can be found.");
	if (!RE_NUM.exec(arr_date[0])) return alert ("Invalid month value: '" + arr_date[0] + "'.\nAllowed values are unsigned integers.");
	if (!arr_date[2]) return alert ("Invalid date format: '" + str_date + "'.\nNo year value can be found.");
	if (!RE_NUM.exec(arr_date[2])) return alert ("Invalid year value: '" + arr_date[2] + "'.\nAllowed values are unsigned integers.");

	var dt_date = new Date();
	dt_date.setDate(1);

	if (arr_date[0] < 1 || arr_date[0] > 12) return alert ("Invalid month value: '" + arr_date[0] + "'.\nAllowed range is 01-12.");
	dt_date.setMonth(arr_date[0]-1);

	if (arr_date[2] < 100) arr_date[2] = Number(arr_date[2]) + (arr_date[2] < NUM_CENTYEAR ? 2000 : 1900);
	dt_date.setFullYear(arr_date[2]);

	var dt_numdays = new Date(arr_date[2], arr_date[0], 0);
	dt_date.setDate(arr_date[1]);
	if (dt_date.getMonth() != (arr_date[0]-1)) return alert ("Invalid day of month value: '" + arr_date[1] + "'.\nAllowed range is 01-"+dt_numdays.getDate()+".");

	return (dt_date)
}

// date generating function
function dt2dtstr (dt_datetime) {
	return (
		(dt_datetime.getMonth() < 9 ? '0' : '') + (dt_datetime.getMonth() + 1) + "/"
		+ (dt_datetime.getDate() < 10 ? '0' : '') + dt_datetime.getDate() + "/"
		+ dt_datetime.getFullYear()
	);
}

function pd02(number){
	number = ""+number;

	if (number.length==0)
		return "00";
	else if (number.length==1)
		return "0" + number;
	else
		return number;
}