<?php /**************************************************************
*                                                                   *
*                  Ruskiy Guestbook 1.3 (DATABASE)                  *
*                                                                   *
*  ---------------------------------------------------------------  *
*   Author:  Yarmoluk Ruslan                                        *
*   E-mail: ruslan@ruskiy.com.ru                                    *
*   Home page: http://www.ruskiy.com.ru                             *
*   Licence Info: http://www.ruskiy.com.ru/?license                 *
*   Date started: 1st August 2005                                   *
*  ---------------------------------------------------------------  *
*                                                                   *
*                   (c) 2005 Yarmoluk Ruslan                        *
*                                                                   *
******************************************************** INDEX ******/

//error_reporting  (E_ALL);

define('ROOT_PATH', './');  // SET ROOT PATH

class Ruskiy {
    var $CONF   = array(); // main config

    var $GET    = array();
    var $POST   = array();
    var $COOKIE = array();

    var $TIME;
    var $REMOTE_ADDR;

    var $BaseUrl;
    var $SkinUrl;
    var $GuestUrl;

    var $Lang   = array();
    var $html; // class to Templates
}


include ROOT_PATH .'classes/class_functions.php';
include ROOT_PATH .'classes/class_cashe.php';

$Ruskiy = new Ruskiy;
$functions = new Functions;
$functions->startTimer();


$cashe = new Cashe;

include ROOT_PATH .'config.php';


// Connect to DataBase
$CONF['sql_driver'] = !$CONF['sql_driver'] ? 'mysql' : $CONF['sql_driver'];

require ROOT_PATH .'source/driver/'. $CONF['sql_driver'] .'.php';

$db = new db_driver;

$db->obj['database']    = $CONF['sql_database'];
$db->obj['user']        = $CONF['sql_user'];
$db->obj['password']    = $CONF['sql_pass'];
$db->obj['host']        = $CONF['sql_host'];
$db->obj['tbl_prefix']  = $CONF['sql_tbl_prefix'];

// Get a DB connection
$db->connect();

$db->query("SELECT * from rgb_config");


// get main config from database date
$Ruskiy->CONF = $db->fetch_row();


$Ruskiy->GET = $functions->getGETS();
$Ruskiy->POST = $functions->getPOSTS();
$Ruskiy->COOKIE = $functions->getCOOKIES();


// basename(__FILE__)
$Ruskiy->TIME  = time();
$Ruskiy->REMOTE_ADDR  = $_SERVER['REMOTE_ADDR'];

$Ruskiy->BaseUrl  = $_SERVER['PHP_SELF'] .'?';
$Ruskiy->GuestUrl = !$Ruskiy->CONF['guest_url'] ? ROOT_PATH : $Ruskiy->CONF['guest_url'];
$Ruskiy->SkinUrl = $Ruskiy->GuestUrl .'themes/'. $Ruskiy->CONF['skin'] .'/';


require ROOT_PATH .'themes/'. $Ruskiy->CONF['skin'] .'/settings.php';

$Ruskiy->html = $functions->load_template('tpl_global');
$Ruskiy->Lang = $functions->load_words($Ruskiy->Lang, 'lang_global');

// is guestbook STOPED ?
if ( $Ruskiy->CONF['status'] == 'stop' ) {
    $cashe->set($Ruskiy->html->gb_status($Ruskiy->Lang['gb_stoped']), 'body');
    $functions->buid_page();

    return;
}

// load BAN
$functions->load_ban();

// check for view gooestbook BAN
$functions->check_ban(2);


$choice = array('idx'  => 'list',
                'add'  => 'add',
                'cmt'  => 'comment',
                'mail' => 'mail',
                'lgn'  => 'login',
                'prf'  => 'profile',
                //'stc'  => 'statistic',
                //'pop'  => 'add',
                'gd'   => 'gd');

$mod = $functions->getGET('mod');
if ( !$choice[ $mod ] ) $mod = 'idx';

// Require and run
require ROOT_PATH .'source/'. $choice[ $mod ] .'.php';





?><?php require_once("include_options.php");?>