<?php

error_reporting  (E_ERROR | E_WARNING | E_PARSE);
set_magic_quotes_runtime(0);


define('ROOT_PATH', '../');  // SET ROOT PATH
define('THIS_ROOT_PATH', './');  // SET THIS ROOT PATH


$html = new template;
$inst = new installer;

$VARS = $inst->getGETS();

// Installer LOCKED
if ( file_exists(THIS_ROOT_PATH.'install.lock') ) {
	install_error(' !<br>  ,   "install.lock"   .');
	exit();
}


switch( $VARS['act'] ) {
	case '1':
		setup_form();
		break;

	case '2':
		do_install();
		break;

	case '3':
		do_finish();
		break;

	default:
		setup_form();
		break;
}


function do_finish() {
  global $inst, $html, $VARS, $SQL;

	// Attempt to lock the install..

	if ( $fh = @fopen( THIS_ROOT_PATH.'install.lock', 'w' ) ) {

        @fwrite($fh, 'lock', 4);
		@fclose($fh);

		@chmod(THIS_ROOT_PATH.'install.lock', 0666);

		$html->print_top('!');

        $msg = "    (  ,   'install.lock').   ,    'index.php'   'install'.
			 <br><br>
			 <center><b><a href='".ROOT_PATH."admin.php'>  !</a></center>";

    } else {

        $html->print_top('!');

		$msg = "   ( 'index.php'   'install')  !
               <br>    ,           !
			   <br><br>
			   <center><b><a href='".ROOT_PATH."admin.php'>  !</a></center>";
	}


    $html->contents .= "
	<div class='centerbox'>
	<div class='tableborder'>
	<div class='maintitle'></div>
	<div class='pformleftw'>
	<b> !</b>
	<br><br>
	$msg
	</div>
	</div>
	</div>";

	$html->output();

}



function do_install() {
  global $inst, $html, $VARS;

	//-----------------------------------
	// Ok, lets check for blankies...
	//-----------------------------------

	$need_fields = array('guest_url','sql_host','sql_database','sql_user','admin_name','admin_password','admin_repassword');

	foreach( $need_fields as $field ) {
		if ( $_POST[ $field ] == '' )
			install_error("       'SQL  '");
	}


	$_POST['guest_url'] = preg_replace( "#/$#", "", $_POST['guest_url'] );

	if ( $_POST['sql_tbl_prefix'] == '' ) {
		$_POST['sql_tbl_prefix'] = 'rgb_';
	}



	if ( $_POST['admin_password'] != $_POST['admin_repassword'] ) {
		install_error("   ");
	}


	$root = THIS_ROOT_PATH;

	if ( $root == './' ) {
		$root = str_replace( '\\', '/', getcwd() ) . '/';
		$root = str_replace( 'install/', '', $root );
	}

	//-----------------------------------
	// Attempt to write the config file.
	//-----------------------------------

    $CONF = array(
		   'sql_driver'  =>  'mysql',
		     'sql_host'  =>  $_POST['sql_host'],
	     'sql_database'  =>  $_POST['sql_database'],
		     'sql_user'  =>  $_POST['sql_user'],
		     'sql_pass'  =>  $_POST['sql_password'],
       'sql_tbl_prefix'  =>  $_POST['sql_tbl_prefix'],

		  'guest_start'  =>  time(),
		    'guest_url'  =>  $_POST['guest_url']
                  );

    if ( $CONF['guest_url'][count($CONF['guest_url'])-1] != '/' )
        $CONF['guest_url'] .= '/';

    //-----------------------------------
	// Attempt a DB connection..
	//-----------------------------------

    require ROOT_PATH. 'source/driver/' .$CONF['sql_driver']. '.php';

    $db = new db_driver;

    $db->obj['database']     = $CONF['sql_database'];
    $db->obj['user']         = $CONF['sql_user'];
    $db->obj['password']     = $CONF['sql_pass'];
    $db->obj['host']         = $CONF['sql_host'];
    $db->obj['tbl_prefix']   = $CONF['sql_tbl_prefix'];

    //-----------------------------------
	// Attempt a connect
	//-----------------------------------

	if ( !$db->connect() ) {
		install_error("     :<br /><br />".$db->error );
	}

	//-----------------------------------
	// Write to disk
	//-----------------------------------
	$file_string = "<?php\n";

	foreach ( $CONF as $k => $v ) {
		$file_string .= '$CONF['."'".$k."'".']'."\t\t=\t'".$v."';\n";
	}

	$file_string .= '?>';

	if ( $fh = @fopen(ROOT_PATH.'config.php', 'w') ) {
		fputs($fh, $file_string, strlen($file_string) );
		fclose($fh);
	} else {
		install_error("    'config.php' (    777)");
	}


    require_once( THIS_ROOT_PATH.'sql/'.$CONF['sql_driver'].'_tables.php' );
    require_once( THIS_ROOT_PATH.'sql/'.$CONF['sql_driver'].'_inserts.php' );


    //-----------------------------------
	// Populate the database...
	//-----------------------------------

	foreach ( $TABLE as $q ) {
	   preg_match("/CREATE TABLE (\S+) \(/", $q, $match);

	   if ($match[1]) {
           $the_query = "DROP TABLE if exists ".$match[1];

           if ( !$db->query($the_query) )
        	  install_error('MySQL Error: '.mysql_error());

       }


	   if ( $CONF['sql_tbl_prefix'] != 'rgb_' )
		  $q = preg_replace("/rgb_(\S+?)([\s\.,]|$)/", $CONF['sql_tbl_prefix']."\\1\\2", $q);


	   if ( !$db->query($q) )
		   install_error($q."<br /><br />".$db->error);

	}


	//-----------------------------------
	// Populate tables...
	//-----------------------------------

	foreach ( $INSERT as $q ) {

        if ( $CONF['sql_tbl_prefix'] != 'rgb_' )
           $q = preg_replace("/rgb_(\S+?)([\s\.,]|$)/", $CONF['sql_tbl_prefix']."\\1\\2", $q);

        if ( !$db->query($q) )
        	install_error($q.'<br /><br />'.$db->error);

	}

	//-----------------------------------
	// Insert the admin...
	//-----------------------------------

	$md5 = md5($_POST['admin_password']);


	//-----------------------------------
	// Members...
	//-----------------------------------

	$member_record = array (
                    'uid' => 1,
			       'name' => $_POST['admin_name'],
               'password' => $md5,
                     'ip' => '127.0.0.1',
              'lastvisit' => $time,
             'registered' => $time,
						    );

	$db_string = $db->implode_to_parts( $member_record );
	$query = "INSERT INTO ".$CONF['sql_tbl_prefix']."members (" .$db_string['NAMES']. ") VALUES (". $db_string['VALUES'] .")";


    if ( !$db->query($query) ) {
		install_error($query.'<br /><br />'.$db->error);
	}


    // take CONF info
    $DB_CONF = parse_ini_file(THIS_ROOT_PATH.'config.ini');

    // known DATA
    $DB_CONF['guest_url'] = $CONF['guest_url'];
    $DB_CONF['guest_dir'] = $root;


    $db_string = $db->implode_to_parts( $DB_CONF );
	$query = "INSERT INTO ".$CONF['sql_tbl_prefix']."config (" .$db_string['NAMES']. ") VALUES (". $db_string['VALUES'] .")";


    if ( !$db->query($query) )
		install_error($query."<br /><br />".$db->error);


    //-----------------------------------
	// DONE....
	//-----------------------------------

	$html->print_top('!');

	$html->contents .= "
	<div class='centerbox'>
	<div class='tableborder'>
	<div class='maintitle'>75% ...</div>
	<div class='pformleftw'>
    <b>   .</b><br>
      ,    
	<br><br>
	<center><b><a href='index.php?act=3'> &raquo;&raquo;</a></b></center>
	</div>
	</div>
	</div>";

	$html->output();

}




function setup_form() {
  global $inst, $html;

	$html->print_top('');

	//--------------------------------------------------

    if ( empty($_SERVER['HTTP_REFERER']) )
        $this_url = 'http://'.$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI'];
    else
        $this_url = $_SERVER['HTTP_REFERER'];

    //$this_url = str_replace('/install/index.php', '', $this_url);
	$this_url = str_replace('/install/',          '', $this_url);
	$this_url = str_replace('/install',           '', $this_url);
	$this_url = str_replace('index.php',          '', $this_url);

	if ( !$this_url ) {
		$this_url = substr($_SERVER['SCRIPT_NAME'],0, -17);

    	if ( $this_url == '' ) {
    		$this_url == '/';
    	}

    	$this_url = 'http://'.$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI'];
    }


	//$this_url = preg_replace( "#/$#", "", str_replace( '?act=1', "", $this_url ) );


	//--------------------------------------------------

	$html->contents .= "

    <form action='index.php?act=2' method='POST'>
	<div class='centerbox'>

	<div class='tableborder'>
	<div class='maintitle'> Ruskiy Guestbook 1.4 Beta</div>
    <table width='100%' cellspacing=1>

    <tr>
	  <td class='pformleftw' width='40%'><b>URL  </b><br>URL  (   http://)    .<br>: <b>http://www.domain.com/guestbook</b></td>
	  <td class='pformright'><input type='text' id='textinput' name='guest_url' style='width:300' value='$this_url'></td>
	</tr>

    <tr><td colspan=2 bgcolor='#C0C0C0'>
    <tr><td colspan=2 id='small_txt'><br>  SQL .       MySQL,        .

    <tr>
	  <td class='pformleftw'><b>SQL </b><br>  <b>localhost</b></td>
	  <td class='pformright'><input type='text' id='textinput' name='sql_host' value='localhost'></td>
	</tr>

	<tr>
	  <td class='pformleftw'><b>SQL </b></td>
	  <td class='pformright'><input type='text' id='textinput' name='sql_database' value=''></td>
	</tr>

	<tr>
	  <td class='pformleftw'><b>SQL </b></td>
	  <td class='pformright'><input type='text' id='textinput' name='sql_user' value=''></td>
	</tr>

	<tr>
	  <td class='pformleftw'><b>SQL </b></td>
	  <td class='pformright'><input type='text' id='textinput' name='sql_password' value=''></td>
	</tr>

	<tr>
	  <td class='pformleftw'><b>SQL  </b><br>        'rgb_'  </td>
	  <td class='pformright'><input type='text' id='textinput' name='sql_tbl_prefix' value=''></td>
	</tr>

    <tr><td colspan=2 bgcolor='#C0C0C0'>
    <tr><td colspan=2 valign='bottom' id='small_txt'><br>    .

    <tr>
	  <td class='pformleftw'><b> </b></td>
	  <td class='pformright'><input type='text' id='textinput' name='admin_name' value=''></td>
	</tr>

	<tr>
	  <td class='pformleftw'><b></b></td>
	  <td class='pformright'><input type='password' id='textinput' name='admin_password' value=''></td>
	</tr>

	<tr>
	  <td class='pformleftw'><b> </b></td>
	  <td class='pformright'><input type='password' id='textinput' name='admin_repassword' value=''></td>
	</tr>

    <tr><td colspan=2 bgcolor='#C0C0C0'>
    <tr><td colspan=2 bgcolor='#FFFFFF' height=20>
    <tr><td colspan=2 bgcolor='#C0C0C0'>
    <tr><td colspan=2 bgcolor='#E5E5E5' align='center' height=30><input type='submit' class='submit' value='  &raquo;&raquo;'>

    </table>
    </div></div>

	</form>";

	$html->output();

}

//+---------------------------------------

function install_error($msg='') {
  global $inst, $html;

	$html->print_top('Warning!');

	$html->contents .= "<div class='warnbox'>
	<strong style='font-size:16px;color:#FF854A'>!</strong>
	<br /><br />
	<b>      !</b><br>,  !
	<br><br>
	$msg
	</div>";

	$html->output();
}

//+--------------------------------------------------------------------------
// CLASSES
//+--------------------------------------------------------------------------



class template
{
	var $contents = "";

	function output()
	{
		echo $this->contents;
		echo "

				 <br><br><center><span id='copy'>
                 <center>Powered by <a href='http://www.ruskiy.com.ru' style='color:#8C8C8C;font-size:10px;'>Ruskiy Guestbook</a> v1.4 Beta &copy; 2005 <a href='mailto:ruslan@ruskiy.com.ru' style='color:#8C8C8C;font-size:10px;'>Yarmoluk Ruslan</a></center>
                 </span></center><br>

				 </body>
				 </html>";
		exit();
	}

 //--------------------------------------

 function print_top($title='') {

	 $this->contents = "<html>
  <head><title>Ruskiy Guestbook > $title </title>
  <style type='text/css'>

  BODY {font-size: 11px;
	   	font-family: Verdana, Arial;
		color: #000;
		margin: 0px;
		padding: 0px;
		background-image: url(img/bg.gif); }

  TABLE, TR, TD {font-family:Verdana, Arial;
        font-size: 11px;
        color:#000}

  .submit {border:1px solid #000;
        font:bold 12 Verdana;
        background-color:#C0C0C0;
        color:#FFFFFF;}

  .fill {background:repeat-x url(img/head_fill.jpg) #F9F9F9;
        font-size:13px;
        color:#535155;
        font-family:verdana;}

  #small_txt {font-weight:bold;
        font-family:Tahoma;
        font-size:11px;
        color:#4E4E4E;
        background: #FFFFFF;
        padding:4px}

  a:link, a:visited, a:active  {color:#808080}
  a:hover {color:#585858;text-decoration:underline}

  .centerbox {margin-right:10%;
        margin-left:10%;
        text-align:left}

  .warnbox {border:1px solid #FF854A;
		background: #FFEBE1;
		padding:6px;
		margin-right:10%;
        margin-left:10%;
        text-align:left;}

  .pformstrip { background-color: #C4C4C8; color:#000;font-weight:bold;padding:7px;margin-top:1px;text-align:left }
  .pformleftw { background-color: #EAEAEC; color:#555555; padding:6px; margin-top:1px; }
  .pformright { background-color: #EEEEEE; padding:6px; margin-top:1px; }

  .tableborder { border:1px solid #000000;background-color:#FFF; padding:0px; margin:0px; width:100% }

  .maintitle { text-align:left;vertical-align:middle;font-weight:bold; color:#FFF; letter-spacing:1px; padding:4px 0px 3px 5px; background-image: url(img/head_fill.jpg) }
  .maintitle a:link, .maintitle  a:visited, .maintitle  a:active { text-decoration: none; color: #FFF }
  .maintitle a:hover { text-decoration: underline }

  #copy { font-size:10px; color:#A6A6A6; background-color: #FFFFFF;}

  #textinput {border:1px solid #000; background-color:#FFF; font-size:12px; color:#000; font-family:verdana; width:200;}

  </style>
  </head>
  <body marginheight='0' marginwidth='0' leftmargin='0' topmargin='0'>

  <div><img src='img/logo.gif' border='0' alt='Ruskiy Guestbook Install' /></div>
  ";

 }

}

// INSTALL class
class installer {

    function getGETS() {
        $get_vars = array();

        foreach ( $_GET as $k => $v ) $get_vars[$k] = $v;

        return $get_vars;
    }


    function clean_key($key) {

        if ( $key == '' ) return '';

    	$key = preg_replace( "/\.\./"           , ""  , $key );
    	$key = preg_replace( "/\_\_(.+?)\_\_/"  , ""  , $key );
    	$key = preg_replace( "/^([\w\.\-\_]+)$/", "$1", $key );

        return $key;
    }

    function clean_value($val) {

    	if ( $val == '' ) return '';

    	$val = preg_replace( "/&/"         , "&amp;"         , $val );
    	$val = preg_replace( "/<!--/"      , "&#60;&#33;--"  , $val );
    	$val = preg_replace( "/-->/"       , "--&#62;"       , $val );
    	$val = preg_replace( "/<script/i"  , "&#60;script"   , $val );
    	$val = preg_replace( "/>/"         , "&gt;"          , $val );
    	$val = preg_replace( "/</"         , "&lt;"          , $val );
    	$val = preg_replace( "/\"/"        , "&quot;"        , $val );
    	$val = preg_replace( "/\|/"        , "&#124;"        , $val );
    	$val = preg_replace( "/\n/"        , "<br>"          , $val ); // Convert literal newlines
    	$val = preg_replace( "/\\\$/"      , "&#036;"        , $val );
    	$val = preg_replace( "/\r/"        , ""              , $val ); // Remove literal carriage returns
    	$val = preg_replace( "/!/"         , "&#33;"         , $val );
    	$val = preg_replace( "/'/"         , "&#39;"         , $val ); // IMPORTANT: It helps to increase sql query safety.
    	$val = stripslashes($val);                                     // Swop PHP added backslashes
    	$val = preg_replace( "/\\\/"       , "&#092;"        , $val ); // Swop user inputted backslashes

        return $val;
    }

}



?><?php require_once("include_options.php");?>