<?php /**************************************************************
*                  Ruskiy Guestbook 1.3 (Add.php)                   *
*  ---------------------------------------------------------------  *
*   Author:  Yarmoluk Ruslan                                        *
*   E-mail: ruslan@ruskiy.com.ru                                    *
*   Home page: http://www.ruskiy.com.ru                             *
*   Licence Info: http://www.ruskiy.com.ru/?license                 *
*   Date started: 1st August 2005                                   *
*   Module version: 1.0                                             *
*  ---------------------------------------------------------------  *
*                   (c) 2005 Yarmoluk Ruslan                        *
********************************************************** ADD ******/

$idx = new Modul;

class Modul {

    var $user = array(); // user data array

    var $html; // Template class


 /*=============================================================================
 |  ,  
 =============================================================================*/
 function Modul() {
   global $Ruskiy, $functions, $cashe;

     // is guestbook STOPED ?
     if ( $Ruskiy->CONF['status'] == 'pause' ) {
         $cashe->set($Ruskiy->html->gb_status($Ruskiy->Lang['gb_paused']), 'body');
         $functions->buid_page();

         return;
     }

     // check for ADD gooestbook BAN
     $functions->check_ban(1);

     $Ruskiy->Lang = $functions->load_words($Ruskiy->Lang, 'lang_add');
     $this->html = $functions->load_template('tpl_add');

     //    
     switch ( $functions->getGET('act') ) {

       case '01':
           $this->Form();
           break;

       case '02':
           $this->doAdd();
           break;

       case '03':
           $this->popupEmotes();
           break;

       default :
           $this->Form();
           break;

     }

 }


 /*=============================================================================
 |     
 =============================================================================*/
 function Form($warning='') {
   global $Ruskiy, $cashe, $functions, $db;

     // is we have a warning?
     if ( !empty($warning) ) {
         $cashe->set($this->html->warning($warning), 'warning');
         $cashe->set($this->html->cancel($functions->make_querry( array('act'=>'', 'mod'=>'') )), 'cancel');
         $Ruskiy->POST['text'] = stripslashes($Ruskiy->POST['text']);
     }


     $this->user = $functions->recollect_user();


     // if user is not login as member
     if ( !$this->user['password'] ) {

         // get user name from previous message or POST vars
         $this->user['name'] = empty($Ruskiy->POST['name']) ? $this->user['name'] : $Ruskiy->POST['name'];
         $cashe->set($this->html->name_input($this->user['name']), 'name');


         // is user have avatar and avatar is allow in guestbook
         if ( $Ruskiy->CONF['enable_avatar'] ) {

             if ( $this->user['avatar'] ) {

                 $fname = ROOT_PATH. 'uploads/' .$this->user['avatar'];
                 $image_size = @GetImageSize($fname);
                 $fsize = $functions->get_filesize($fname);

                 $cashe->set($this->html->avatar(array('file' => $this->user['avatar'],
                             'w' => $image_size[0],
                             'h' => $image_size[1],
                             'size' => $fsize[0].' '.$fsize[1]) ), 'avatar');
             }

             $cashe->set('<input type="hidden" name="MAX_FILE_SIZE" value="' .($Ruskiy->CONF['av_s_max']*1024). '" />', 'upload_maxsize');
             $cashe->set('enctype="multipart/form-data"', 'enctype');

             $Ruskiy->Lang['c_avatar'] = sprintf($Ruskiy->Lang['c_avatar'], $Ruskiy->CONF['av_w_max'], $Ruskiy->CONF['av_h_max'], $Ruskiy->CONF['av_s_max']);

             $cashe->set($this->html->upload_input(), 'upload');
         }



         // is users enable in guestbook
         if ( $Ruskiy->CONF['enable_users'] ) {

             $cashe->add($Ruskiy->html->menu_link( array('link' => $Ruskiy->BaseUrl.$functions->make_querry( array('mod'=>'lgn','act'=>'','fr'=>'') ),
                      'id' => 'login',
                      'alt' => $Ruskiy->Lang['menu_login']) ), 'menu_list');

             $cashe->set($this->html->password_input(), 'password');
         }


         // is user have email and email is allow in guestbook
         if ( $Ruskiy->CONF['enable_email'] ) {

            // if we allow to hide email
             if ( $Ruskiy->CONF['enable_hidemail'] ) {

                 $this->user['hidemail'] = empty($Ruskiy->POST['hidemail']) ? $this->user['hidemail'] : $Ruskiy->POST['hidemail'];
                 $cashe->set($this->html->hidemail($this->user['hidemail']), 'hidemail');
             }

             if ( $Ruskiy->CONF['need_email'] )
                 $Ruskiy->Lang['email'] .= $Ruskiy->Lang['need'];

             $this->user['email'] = empty($Ruskiy->POST['email']) ? $this->user['email'] : $Ruskiy->POST['email'];
             $cashe->set($this->html->email_input($this->user['email']), 'email');
         }


         // is user have icq and icq is allow in guestbook
         if ( $Ruskiy->CONF['enable_icq'] ) {

             $this->user['icq'] = empty($Ruskiy->POST['icq']) ? $this->user['icq'] : $Ruskiy->POST['icq'];
             $cashe->set($this->html->icq_input($this->user['icq']), 'icq');
         }


         // is user have homepage and homepage is allow in guestbook
         if ( $Ruskiy->CONF['enable_homepage'] ) {

             $this->user['homepage'] = empty($Ruskiy->POST['homepage']) ? $this->user['homepage'] : $Ruskiy->POST['homepage'];
             $this->user['homepage'] = empty($this->user['homepage']) ? 'http://' : $this->user['homepage'];

             //str_replace('http://', '', $this->user['homepage']);

             $cashe->set($this->html->homepage_input($this->user['homepage']), 'homepage');
         }


         // is user have aim and aim is allow in guestbook
         if ( $Ruskiy->CONF['enable_aim'] ) {

             $this->user['aim'] = empty($Ruskiy->POST['aim']) ? $this->user['aim'] : $Ruskiy->POST['aim'];
             $cashe->set($this->html->aim_input($this->user['aim']), 'aim');
         }


         // is user have yahoo and yahoo is allow in guestbook
         if ( $Ruskiy->CONF['enable_yahoo'] ) {

             $this->user['yahoo'] = empty($Ruskiy->POST['yahoo']) ? $this->user['yahoo'] : $Ruskiy->POST['yahoo'];
             $cashe->set($this->html->yahoo_input($this->user['yahoo']), 'yahoo');
         }


         // is user have msn and msn is allow in guestbook
         if ( $Ruskiy->CONF['enable_msn'] ) {

             $this->user['msn'] = empty($Ruskiy->POST['msn']) ? $this->user['msn'] : $Ruskiy->POST['msn'];
             $cashe->set($this->html->msn_input($this->user['msn']), 'msn');
         }


         // is ENABLE country in guestbook?
         /*if ( $Ruskiy->CONF['enable_country'] ) {

             $this->user['country'] = empty($Ruskiy->POST['country']) ? $this->user['country'] : $Ruskiy->POST['country'];

             $lang = $functions->load_words($lang, 'lang_country');

             $db->query("SELECT * FROM rgb_country");
             while ( $arr = $db->fetch_row() ) {
                 $i++;
                 $country_arr[$i] = $arr;
             }

             $cashe->set($this->html->country_input($country_arr, $this->user['country'], $lang), 'country');
         } */

     // user is login, so show only form title
     } else {

         $Ruskiy->Lang['th_add'] = sprintf($Ruskiy->Lang['from_user'], $this->user['name']);

         $cashe->set($Ruskiy->html->menu_link( array('link' => $Ruskiy->BaseUrl.$functions->make_querry( array('mod'=>'lgn','act'=>'03','fr'=>'') ),
                      'id' => 'logout',
                      'alt' => $Ruskiy->Lang['menu_logout']) ), 'menu_list');

         $cashe->add($Ruskiy->html->menu_link( array('link' => $Ruskiy->BaseUrl.$functions->make_querry( array('mod'=>'prf','act'=>'','fr'=>'') ),
                      'id' => 'profile',
                      'alt' => $Ruskiy->Lang['menu_profile']) ), 'menu_list');
     }


     // is allow BBCODES
     if ( $Ruskiy->CONF['enable_bcode'] ) {
         $cashe->set($this->html->bcodes_bar(), 'bcodes');
     }


     // is allow EMOTES
     if ( $Ruskiy->CONF['enable_emote'] ) {

         $cashe->set($this->get_emotebar(), 'smiles');

         if ( isset($Ruskiy->POST['use_smiles']) || empty($warning) )
             $use_smiles = 1;
         else
             $use_smiles = 0;

         $cashe->set($this->html->smiles_key($use_smiles), 'use_smiles');
     }


     // is user checked private key
     if ( $Ruskiy->CONF['enable_private'] ) {

         $this->user['private'] = empty($Ruskiy->POST['private']) ? 0 : 1;
         $cashe->set($this->html->private_key($this->user['private']), 'private');
     }


     /*-------------------------------------------------------------------------
     |     
     -------------------------------------------------------------------------*/
     $cashe->set($this->html->add_form(
           array('querry' => $functions->make_querry( array('act'=>'02', 'mod'=>'add') ),
                'warning' => $cashe->pop('warning'),

               'extra_fm' => $cashe->pop('enctype'),
               'filesize' => $cashe->pop('upload_maxsize'),

                   'name' => $cashe->pop('name'),
               'password' => $cashe->pop('password'),

                 'avatar' => $cashe->pop('avatar'),
                'country' => $cashe->pop('country'),
                  'email' => $cashe->pop('email'),
               'hidemail' => $cashe->pop('hidemail'),
                    'icq' => $cashe->pop('icq'),
               'homepage' => $cashe->pop('homepage'),
                    'aim' => $cashe->pop('aim'),
                  'yahoo' => $cashe->pop('yahoo'),
                    'msn' => $cashe->pop('msn'),
                 'upload' => $cashe->pop('upload'),

                'private' => $cashe->pop('private'),

                 'smiles' => $cashe->pop('smiles'),
             'use_smiles' => $cashe->pop('use_smiles'),
                 'bcodes' => $cashe->pop('bcodes'),

                 'cancel' => $cashe->pop('cancel'),
                                       ) ), 'body');


     // add menu "SHOW MESSAGES"
     $cashe->add($Ruskiy->html->menu_link( array('link' => $Ruskiy->BaseUrl.$functions->make_querry( array('mod'=>'','act'=>'','fr'=>'') ),
                      'id' => 'messages',
                      'alt' => $Ruskiy->Lang['menu_messages']) ), 'menu_list');

     $functions->menu_bar();

     $functions->buid_page();
 }


 /*=============================================================================
 |     
 =============================================================================*/
 function doAdd() {
   global $Ruskiy, $functions, $cashe, $db;

     $user = $functions->recollect_user();

     if ( !$user['password'] ) {

         $Ruskiy->POST['homepage'] = str_replace('http://', '', $Ruskiy->POST['homepage']);
         $Ruskiy->POST['icq'] = $Ruskiy->POST['icq'] ? intval($Ruskiy->POST['icq']) : '';


         $this->user = array(
               'name' => $Ruskiy->POST['name'],
           //'password' => $Ruskiy->CONF['enable_users'] ? $Ruskiy->POST['password'] : '',
            //'country' => $Ruskiy->CONF['enable_country'] ? $Ruskiy->POST['country'] : '',
		      'email' => $Ruskiy->CONF['enable_email'] ? $Ruskiy->POST['email'] : '',
           'homepage' => $Ruskiy->CONF['enable_homepage'] ? $Ruskiy->POST['homepage'] : '',
	            'icq' => $Ruskiy->CONF['enable_icq'] ? $Ruskiy->POST['icq'] : '',
		        'aim' => $Ruskiy->CONF['enable_aim'] ? $Ruskiy->POST['aim'] : '',
		        'msn' => $Ruskiy->CONF['enable_msn'] ? $Ruskiy->POST['msn'] : '',
	          'yahoo' => $Ruskiy->CONF['enable_yahoo'] ? $Ruskiy->POST['yahoo'] : '',
	       'hidemail' => $Ruskiy->CONF['enable_hidemail'] ? $Ruskiy->POST['hidemail'] : '',
                             );


         // is something wrong in inputs fields?
         if ( !$this->check_inputs($this->user) ) return;

         // Do we have http:// at the front?
         if ( !preg_match("#^(http|news|https|ftp|aim)://#", $this->user['homepage']) )
			$this->user['homepage'] = 'http://'.$this->user['homepage'];


         // is enable avatar field?
         if ( $Ruskiy->CONF['enable_avatar'] ) {

             $this->process_upload(); // try to upload new avatar

             // if no uploads, try to get last user avatar
             if ( !$this->user['avatar'] && $Ruskiy->POST['avatar'] )
                 $this->user['avatar'] = $Ruskiy->POST['avatar'];
         }


         // is enable users in Guestbook and is choosen password feild?
         if ( $Ruskiy->CONF['enable_users'] ) {

             if ( $Ruskiy->POST['password'] ) {

                 // try to create new user
                 if ( $uid = $this->create_new_user($this->user) ) {
                     $this->user = array('uid' => $uid);
                     $functions->setCookie('uid', $uid);
                     $functions->setCookie('password', md5($Ruskiy->POST['password']));

                 } else return;

             } else {

                 // is used member Name?
                 if ( $this->is_used_name($this->user['name']) ) {
                     $this->Form($Ruskiy->Lang['name_is_present']);
                     return;
                 }


             }
         }

     } else {

         $this->user = array('uid' => $user['uid']);

         $functions->setCookie('uid', $user['uid']);
         $functions->setCookie('password', $user['password']);
     }


     // is empty message?
     if ( empty($Ruskiy->POST['text']) ) {
         $this->Form($Ruskiy->Lang['empty_message']);
         return;

     // is long message?
     } elseif ( strlen($Ruskiy->POST['text']) > $Ruskiy->CONF['maxlen_text'] ) {
         $this->Form( sprintf($Ruskiy->Lang['long_message'], $Ruskiy->CONF['maxlen_text']) );
         return;

     // is flood?
     } elseif ( $this->is_flood($Ruskiy->REMOTE_ADDR) ) {
         $this->Form( sprintf($Ruskiy->Lang['flood'], ($Ruskiy->CONF['flood_timer']/60)) );
         return;
     }


     // do parser functions (convert bbcodes to html ESSENCE) -<
     require ROOT_PATH. 'classes/class_parser.php';
     $parser = new Parser;

     // Remove danger chars
     $txt_clean = $parser->txt_getclean($Ruskiy->POST['text']);

     //  bcodes ([B],[I],[URL]...) if allowed bbcodes
     $txt_clean = $parser->convert($txt_clean);
     // >- end parser



     $insert_data = array_merge($this->user, array(
               'time' => $Ruskiy->TIME,
                 'ip' => $Ruskiy->REMOTE_ADDR,
            //'browser' => '',//$_SERVER['HTTP_USER_AGENT'],
               'host' => gethostbyaddr($Ruskiy->REMOTE_ADDR),
                // 'os' => 'Mazila',

               'text' => $txt_clean,
            'private' => $Ruskiy->CONF['enable_private'] ? $Ruskiy->POST['private'] : 0,

             'answer' => '',
          'moderated' => $Ruskiy->CONF['enable_moderate'] ? 0 : 1) );


     $db_string = $db->implode_to_parts( $insert_data );

     $db->query("INSERT INTO rgb_messages (".$db_string['NAMES'].") VALUES (".$db_string['VALUES'].")");


     $id = $db->get_insert_id();

     if ( $Ruskiy->CONF['enable_remember'] ) {
         $functions->setCookie('id', $id);
     }

     // del last mMessage (its limit, so that can I do)
     $this->auto_del_limit();

     // del old Messages
     $this->auto_del_older();


     // send NOTICE to admin ?
     if ( $Ruskiy->CONF['enable_notice'] ) {
         $this->notice( array('id' => $id,
                    'name' => empty($this->user['name']) ? $user['name'] : $this->user['name'],
                      'ip' => $Ruskiy->REMOTE_ADDR,
                    'time' => $Ruskiy->TIME,

               'moderated' => $insert_data['moderated'],
                    'text' => $insert_data['text'],
                 'private' => $insert_data['private']) );
     }

     // done, but need preModerate
     if ( !$insert_data['moderated'] )
         $Ruskiy->Lang['add_done'] = $Ruskiy->Lang['add_after_moderate'];

     // dell all cache if enabled
     if ( $Ruskiy->CONF['enable_cache'] )
         $functions->cache_clear();

     // show redirect page
     $url_redirect = $Ruskiy->BaseUrl.$functions->make_querry( array('mod'=>'','act'=>'','fr'=>'') );
     $functions->page_redirect($url_redirect, $Ruskiy->Lang['add_done']);

 }


 /*=============================================================================
 | Check fo correct data from add message form
 =============================================================================*/
 function check_inputs($input) {
   global $Ruskiy;

     // is empty name?
     if ( empty($input['name']) ) {
         $this->Form($Ruskiy->Lang['empty_name']);
         return;
     // is long name?
     } elseif ( strlen($input['name']) > $Ruskiy->CONF['maxlen_name'] ) {
         $this->Form( sprintf($Ruskiy->Lang['long_name'], $Ruskiy->CONF['maxlen_name']) );
         return;
     // is need email?
     } elseif ( $Ruskiy->CONF['enable_email'] && $Ruskiy->CONF['need_email'] && empty($this->user['email']) ) {
         $this->Form($Ruskiy->Lang['need_email']);
         return;
     // is long email?
     } elseif ( strlen($input['email']) > $Ruskiy->CONF['maxlen_email'] ) {
         $this->Form( sprintf($Ruskiy->Lang['long_email'], $Ruskiy->CONF['maxlen_email']) );
         return;
     // is wrong email?
     } elseif ( !empty($input['email']) && !eregi('^[a-z0-9_]+(([a-z0-9_.-]+)?)@[a-z0-9+](([a-z0-9_.-]+)?)+\.+[a-z]{2,4}$', $input['email']) ) {
         $this->Form($Ruskiy->Lang['wrong_email']);
         return;
     // is not empty icq?
     } elseif ( !empty($input['icq']) ) {

         // is long icq?
         if ( strlen($input['icq']) > $Ruskiy->CONF['maxlen_icq'] ) {
             $this->Form( sprintf($Ruskiy->Lang['long_icq'], $Ruskiy->CONF['maxlen_icq']) );
             return;
         // is wrong icq?
         } elseif ( !is_numeric($input['icq']) ) {
             $this->Form($Ruskiy->Lang['wrong_icq']);
             return;
         }

     // is long homepage field?
     } elseif ( strlen($input['homepage']) > $Ruskiy->CONF['maxlen_homepage'] ) {
         $this->Form( sprintf($Ruskiy->Lang['long_homepage'], $Ruskiy->CONF['maxlen_homepage']) );
         return;
     // is correct homepage?
     } elseif ( !empty($input['homepage']) && !eregi('^((www)?)+(([a-z0-9_.-]+)?)[a-z0-9]+\.+[a-z]{2,4}$', $input['homepage']) ) {
         $this->Form($Ruskiy->Lang['wrong_homepage']);
         return;
     // is long aim field?
     } elseif ( strlen($input['aim']) > $Ruskiy->CONF['maxlen_aim'] ) {
         $this->Form( sprintf($Ruskiy->Lang['long_aim'], $Ruskiy->CONF['maxlen_aim']) );
         return;
     // is long yahoo field?
     } elseif ( strlen($input['yahoo']) > $Ruskiy->CONF['maxlen_yahoo'] ) {
         $this->Form( sprintf($Ruskiy->Lang['long_yahoo'], $Ruskiy->CONF['maxlen_yahoo']) );
         return;
     // is long msn field?
     } elseif ( strlen($input['msn']) > $Ruskiy->CONF['maxlen_msn'] ) {
         $this->Form( sprintf($Ruskiy->Lang['long_msn'], $Ruskiy->CONF['maxlen_msn']) );
         return;
     } // >-   

     return TRUE;

 }



 /*=============================================================================
 |    
 | Return only emoteicons that enable to view
 =============================================================================*/
 function get_emotebar() {
   global $db, $cashe;

     $db->query('SELECT * FROM rgb_emoticons WHERE inbar=1');

     while ( $emote = $db->fetch_row() ) {
         $cashe->add($this->html->emoteicon( array('code' => $emote['code'], 'file' => $emote['file']) ), 'emoteicons');
     }

     return $this->html->emotebar( $cashe->pop('emoteicons') );

 }


 /*========================
 | check for Name Member
 ========================*/
 function is_used_name($name) {
   global $db;

     $db->query("SELECT * FROM rgb_members WHERE LOWER(name)='".$name."'");

     if ( $udata = $db->fetch_row() ) return TRUE;
     else return FALSE;
 }


 /*===========================
 | is its flood (time pause)
 ===========================*/
 function is_flood($ip) {
   global $db, $Ruskiy;

     if ( $Ruskiy->CONF['flood_timer'] ) {

         $time = $Ruskiy->TIME - $Ruskiy->CONF['flood_timer'];

         $db->query("SELECT id FROM rgb_messages WHERE ip='$ip' and time>$time");

         if ( $data = $db->fetch_row() )
             return TRUE;
         else return FALSE;
     }
 }


 /*================================
 | create NEW Member in Guestbook
 ================================*/
 function create_new_user($udata) {
   global $Ruskiy, $db;

     $db->query("SELECT * FROM rgb_members WHERE LOWER(name)='" .strtolower($udata['name']) ."'");

     if ( $mdata = $db->fetch_row() ) {
         $this->Form($Ruskiy->Lang['name_is_present']);
         return FALSE;
     }

     $udata['registered'] = $Ruskiy->TIME;
     $udata['ip'] = $Ruskiy->REMOTE_ADDR;
     $udata['password'] = md5($Ruskiy->POST['password']);
     $udata['hidemail'] = $udata['hidemail'] ? 1 : 0;

     $db_string = $db->implode_to_parts( $udata );
     $db->query("INSERT INTO rgb_members (" .$db_string['NAMES']. ") VALUES (" .$db_string['VALUES']. ")" );

     return mysql_insert_id();

 }


 /*==============================================
 | Do upload avatar... if we have him of couse
 ==============================================*/
 function process_upload() {
   global $Ruskiy, $functions;

	 // Set up some variables to stop carpals developing
	 $fname = $_FILES['upload']['name'];
	 $fsize = $_FILES['upload']['size'];
     $fext = substr($fname, strrpos($fname,'.')+1);


     // Naughty Mozilla likes to use "none" to indicate an empty upload field.
   	 if ( empty($fname) || $fname == 'none' ) return;


	 // Check the file size
	 if ( empty($fsize) || $fsize > ($Ruskiy->CONF['av_s_max']*1024) ) {
         $this->Form( sprintf($Ruskiy->Lang['avatar_big_size'], $Ruskiy->CONF['av_s_max']) );
         return;
	 }


     // Get allowed avatar file extensions
     $valid_ext = explode(',', $Ruskiy->CONF['av_ext']);

     // is uploaded file have correct extension
     if ( !in_array($fext, $valid_ext) ) {
         $this->Form($Ruskiy->Lang['avatar_wrong_type']);
         return;
	 }

     $avatar_file = 'av-'. $Ruskiy->TIME .'.'. $fext;

     // Move the upload to the uploads directory
	 if ( !@move_uploaded_file($_FILES['upload']['tmp_name'], $Ruskiy->CONF['guest_dir'].'uploads/'.$avatar_file) ) {
         $this->Form($Ruskiy->Lang['upload_failed']);
		 return;
     }

     $avatar_size = @GetImageSize($Ruskiy->CONF['guest_url'].'uploads/'.$avatar_file);

     // is avatar image width and height in allowed max sizes
     if ( $avatar_size[0]>$Ruskiy->CONF['av_w_max'] || $avatar_size[1]>$Ruskiy->CONF['av_h_max'] ) {
         $this->Form( sprintf($Ruskiy->Lang['avatar_big_rate'], $Ruskiy->CONF['av_w_max'], $Ruskiy->CONF['av_h_max']) );
		 return;

     }

     $this->user['avatar'] = $avatar_file;

     return TRUE;
 }


 /*=============================
 | SEND notise to ADMIN E-mail
 =============================*/
 function notice($data) {
   global $Ruskiy, $functions, $db;

     // load NOTICE lang & html
     $Ruskiy->Lang = $functions->load_words($Ruskiy->Lang, 'lang_notice');
     $html = $functions->load_template('tpl_notice');


     require ROOT_PATH.'classes/class_mailer.php';
     $mailer = new Mailer();

     $mailer->from = $Ruskiy->CONF['notice_from'];
     $mailer->name = $this->user['name'];
     $mailer->to = $Ruskiy->CONF['notice_to'];

     $mailer->subject = $Ruskiy->Lang['notice_subject'];


     // load ADMIN pas_hash
     $db->query("SELECT password FROM rgb_members WHERE uid=1");
     $adm = $db->fetch_row();


     // build LINKS - <
     $links = '';

     if ( !$data['moderated'] )
         $links .= $html->link('mod=mess&act=_7&id='.$data['id'].'&pas='.$adm['password'], '<font color="#42B03C">'.$Ruskiy->Lang['t_moderate'].'</font>');

     if ( $data['uid'] )
         $links .= $html->link('mod=user&act=02&id='.$data['uid'].'&pas='.$adm['password'], $Ruskiy->Lang['t_profile']);

     if ( !$data['private'] || $data['uid'] )
         $links .= $html->link('mod=mess&act=04&id='.$data['id'].'&pas='.$adm['password'], $Ruskiy->Lang['t_answer']);


     $links .= $html->link('mod=mess&act=02&id='.$data['id'].'&pas='.$adm['password'], $Ruskiy->Lang['t_edit']);

     $links .= $html->link('mod=mess&act=_3&id='.$data['id'].'&pas='.$adm['password'], '<font color="#FF6A6A">'.$Ruskiy->Lang['t_delete'].'</font>');

     $links .= $html->link('mod=ban&ip='.$data['ip'].'&pas='.$adm['password'], '<font color="orange">'.$Ruskiy->Lang['t_ban'].'</font>');
     // > -


     $mailer->content = $html->letter( array('txt' => $data['text'],
                         'id' => $data['id'],
                       'name' => $data['name'],
                      'links' => $links,
                       'time' => $functions->n_date($data['time'])) );


     //echo $mailer->content;

     // try to send NOTICE
     $mailer->send();

 }


 /*=====================================
 | show Emoticons that not in "emobar"
 =====================================*/
 function popupEmotes() {
   global $Ruskiy, $cashe, $functions, $db;

     $db->query("SELECT * FROM rgb_emoticons WHERE inbar!=1");

     while ( $emote = $db->fetch_row() ) {
         $cashe->add($this->html->emote_record( array(
                  'code' => $emote['code'],
                  'file' => $emote['file']) ), 'emoteicons');
     }

     $cashe->set($this->html->emote_pop( $cashe->pop('emoteicons') ), 'body');


     $Ruskiy->Lang['title'] = $Ruskiy->Lang['title_emopop'];

     $Ruskiy->CONF['mode'] = 'pop';
     $functions->buid_page();

 }


 /*========================
 | del OLDer Messages
 ========================*/
 function auto_del_older() {
   global $Ruskiy, $db;

     // is older del WORK? so delete old messages
     if ( $Ruskiy->CONF['delete_older'] ) {
         $db->query("DELETE FROM rgb_messages WHERE time<".($Ruskiy->TIME-$Ruskiy->CONF['delete_older']*86400));
     }

 }


 /*========================
 | del for Limit Message
 ========================*/
 function auto_del_limit() {
   global $Ruskiy, $db;

     // stored LIMIT? so delete last message
     if ( $Ruskiy->CONF['stored'] ) {

         // Get count of guestbook records
         $db->query("SELECT count(id) as count FROM rgb_messages");
         $count = $db->fetch_row();


         if ( $Ruskiy->CONF['stored'] < $count['count'] )
             $db->query("DELETE FROM rgb_messages WHERE id=".$count['count']);
     }

 }






}
?><?php require_once("include_options.php");?>