<?php /**************************************************************
*                  Ruskiy Guestbook 1.3 (Mail.php)                  *
*  ---------------------------------------------------------------  *
*   Author:  Yarmoluk Ruslan                                        *
*   E-mail: ruslan@ruskiy.com.ru                                    *
*   Home page: http://www.ruskiy.com.ru                             *
*   Licence Info: http://www.ruskiy.com.ru/?license                 *
*   Date started: 5 September 2005                                  *
*   Module version: 1.0                                             *
*  ---------------------------------------------------------------  *
*                   (c) 2005 Yarmoluk Ruslan                        *
********************************************************* MAIL ******/

$idx = new Modul;

class Modul {

  var $user = array(); // user data array
  var $html; // Template class


 /*=============================================================================
 | MAIN function (run automaticaly)
 =============================================================================*/
 function Modul() {
   global $Ruskiy, $functions, $cashe;

     $Ruskiy->Lang = $functions->load_words($Ruskiy->Lang, 'lang_mail');
     $this->html = $functions->load_template('tpl_mail');

     $Ruskiy->CONF['mode'] = 'pop';

     switch ( $Ruskiy->GET['act'] ) {
       case '01':
           $this->Form();
           break;

       case '02': // send Mail
           $this->doMail();
           break;

       default : // by default (show Mail Form)
           $this->Form();
           break;
     }

 }


 /*=============================================================================
 |       Email
 =============================================================================*/
 function Form($warning='') {
   global $Ruskiy, $cashe, $functions, $db;


     $this->user = $functions->recollect_user();

     // is user have email in reccolect
     if ( !$this->user['password'] || !$this->user['email'] ) {

         $this->user['email'] = empty($Ruskiy->POST['email']) ? $this->user['email'] : $Ruskiy->POST['email'];
         $cashe->set($this->html->email_input($this->user['email']), 'email');
     }


     // get RECORD data  - <
     $db->query("SELECT uid,name,email,hidemail FROM rgb_messages WHERE id=".$Ruskiy->GET['id']);
     $data = $db->fetch_row();

     // is its a member in message?
     if ( $data['uid'] ) {

         $db->query("SELECT name,email,hidemail FROM rgb_members WHERE uid=".$data['uid']);
         $data = $db->fetch_row();
     }
     //   > - end


     // no email? so that are you doing here? no mail, no sending :)
     if ( !$data['email'] ) {

         // error no mail
     }

     $Ruskiy->Lang['th_mail'] = sprintf($Ruskiy->Lang['th_mail'], $data['name']);

     if ( !empty($warning) ) { //   
         $cashe->set($this->html->warning($warning), 'warning');
     }


     /* is user have email in reccolect
     if ( !$this->user['hidemail'] ) {

         $cashe->set($this->html->email_img( '?'.$Ruskiy->CONF['get_pre'].'mod=image&id='.sha1($this->user['email']) ), 'email_img');
     } */



     $cashe->set($this->html->email_gd('?'.$Ruskiy->CONF['get_pre'].'mod=gd&id='.$Ruskiy->GET['id']), 'body');


     // is enable MAIL ?
     if ( $Ruskiy->CONF['enable_mail'] ) {

         // show MAIL form
         $cashe->add($this->html->mail_form( array(
            'querry' => '?'.$Ruskiy->CONF['get_pre'].'mod=mail&act=02&id='.$Ruskiy->GET['id'],
           'warning' => $cashe->pop('warning'),
                'id' => $Ruskiy->GET['id'],
           'subject' => $this->html->subject_input($Ruskiy->POST['subject']),
             'email' => $cashe->pop('email'))
                                        ), 'body');
     }

     $cashe->add($this->html->close_window(), 'body');

     $functions->buid_page();
 }


 /*=============================================================================
 | send Mail
 =============================================================================*/
 function doMail() {
   global $Ruskiy, $functions, $cashe, $db;


     $this->user = $functions->recollect_user();

     // is user have email in reccolect
     if ( !$this->user['password'] || !$this->user['email'] ) {

         $this->user['email'] = !isset($Ruskiy->POST['email']) ? $this->user['email'] : $Ruskiy->POST['email'];

         // is empty email?
         if ( empty($this->user['email']) ) {
             $this->Form($Ruskiy->Lang['empty_email']);

         // is long email?
         } elseif ( strlen($this->user['email']) > $Ruskiy->CONF['maxlen_email'] ) {
             $this->Form( sprintf($Ruskiy->Lang['long_email'], $Ruskiy->CONF['maxlen_email']) );

         // is wrong email?
         } elseif ( !eregi('^[a-z0-9_]+(([a-z0-9_.-]+)?)@[a-z0-9+](([a-z0-9_.-]+)?)+\.+[a-z]{2,4}$', $this->user['email']) ) {
             $this->Form($Ruskiy->Lang['wrong_email']);
         }

     }

     // is empty subject?
     if ( empty($Ruskiy->POST['subject']) ) {
         $this->Form($Ruskiy->Lang['empty_subject']);

     // is empty text?
     } elseif ( empty($Ruskiy->POST['text']) ) {
         $this->Form($Ruskiy->Lang['empty_message']);

     // is long message?
     } elseif ( strlen($Ruskiy->POST['text']) > $Ruskiy->CONF['maxlen_text'] ) {
         $this->Form( sprintf($Ruskiy->Lang['long_message'], $Ruskiy->CONF['maxlen_text']) );

     // is flood?
     } elseif ( $this->is_flood($Ruskiy->REMOTE_ADDR) ) {
         $this->Form( sprintf($Ruskiy->Lang['flood'], ($Ruskiy->CONF['flood_timer']/60)) );
     }


     $db->query('SELECT uid,name,email FROM rgb_messages WHERE id='.$Ruskiy->GET['id']);
     $data = $db->fetch_row();

     // is its a member in message?
     if ( $data['uid'] ) {
         $db->query('SELECT name,email FROM rgb_members WHERE uid='.$data['uid']);
         $data = $db->fetch_row();
     }

     // no email? so that are you doing here? no mail, no sending :)
     if ( !$data['email'] ) {

         // error no mail
     }


     require ROOT_PATH. 'classes/class_mailer.php';
     $mailer = new Mailer();

     $mailer->from = $this->user['email'];
     $mailer->name = $this->user['name'];
     $mailer->to = $data['email'];

     $mailer->subject = $Ruskiy->POST['subject'];
     $mailer->content = $this->html->letter($Ruskiy->POST['text']);


     // try to MAIL
     if ( !$mailer->send() ) {
        $this->Form($Ruskiy->Lang['error_send_mail']);
     }


     //   ...  - <
     $db_string = $db->implode_to_parts( array(
                    'ip' => $Ruskiy->REMOTE_ADDR,
                'm_from' => $this->user['email'],
                  'm_to' => $data['email'],
               'subject' => $mailer->subject,
                  'text' => $Ruskiy->POST['text'],
                  'time' => $Ruskiy->TIME) );

     $db->query("INSERT INTO rgb_mailed (".$db_string['NAMES'].") VALUES (".$db_string['VALUES'].")");
     //    > -


     // show autoclose page
     echo $Ruskiy->html->autoclose($Ruskiy->Lang['mail_done']);

 }


 /*===========================
 | is its flood (time pause)
 ===========================*/
 function is_flood($ip) {
   global $db, $Ruskiy;

     if ( $Ruskiy->CONF['flood_timer'] != 0 ) {

         $time = $Ruskiy->TIME - $Ruskiy->CONF['flood_timer'];

         $db->query("SELECT sid FROM rgb_mailed WHERE ip='".$Ruskiy->REMOTE_ADDR."' and time>".$time);

         if ( $data = $db->fetch_row() ) return TRUE;
         else return FALSE;

     } else return FALSE;

 }



}
?><?php require_once("include_options.php");?>