<?php /**************************************************************
*                                                                   *
*                  Ruskiy Guestbook 1.3 (DATABASE)                  *
*                                                                   *
*  ---------------------------------------------------------------  *
*   Author:  Yarmoluk Ruslan                                        *
*   E-mail: ruslan@ruskiy.com.ru                                    *
*   Home page: http://www.ruskiy.com.ru                             *
*   Licence Info: http://www.ruskiy.com.ru/?license                 *
*   Date started: 9 September 2005                                  *
*  ---------------------------------------------------------------  *
*                                                                   *
*                   (c) 2005 Yarmoluk Ruslan                        *
*                                                                   *
******************************************************** ADMIN ******/

define( 'ROOT_PATH', './' );  // SET ROOT PATH

class Ruskiy {
    var $CONF       = array(); // main config (from ini file)

    var $GET    = array();
    var $POST   = array();
    var $COOKIE = array();

	var $Lang       = array();

    var $BaseUrl;
    var $LangPath;
    var $SkinPath;

    var $html; // class to Templates
}

include ROOT_PATH. 'classes/class_afunctions.php';
include ROOT_PATH. 'classes/class_cashe.php';

$Ruskiy = new Ruskiy;
$cashe = new Cashe;

$functions = new Functions;
$functions->time = time();


include ROOT_PATH. 'config.php';

// Connect to DataBase
$CONF['sql_driver'] = !$CONF['sql_driver'] ? 'mysql' : $CONF['sql_driver'];

require ROOT_PATH. 'source/driver/' .$CONF['sql_driver']. '.php';

$db = new db_driver;

$db->obj['database']    = $CONF['sql_database'];
$db->obj['user']        = $CONF['sql_user'];
$db->obj['password']    = $CONF['sql_pass'];
$db->obj['host']        = $CONF['sql_host'];
$db->obj['tbl_prefix']  = $CONF['sql_tbl_prefix'];

// Get a DB connection
$db->connect();

$db->query('SELECT * from rgb_config');

// get main config from database date
$Ruskiy->CONF = $db->fetch_row();



$Ruskiy->GET = $functions->getGETS();
$Ruskiy->POST = $functions->getPOSTS();
$Ruskiy->COOKIE = $functions->getCOOKIES();


// basename(__FILE__)
$Ruskiy->BaseUrl  = $_SERVER['PHP_SELF']. '?';
$Ruskiy->GuestUrl = !$Ruskiy->CONF['guest_url'] ? ROOT_PATH : $Ruskiy->CONF['guest_url'];
$Ruskiy->SkinUrl = $Ruskiy->GuestUrl. 'admin/skin/';


$Ruskiy->html = $functions->load_template('tpl_global');
$Ruskiy->Lang = $functions->load_words($Ruskiy->Lang, 'lang_global');



// CHECK FOR ADMINs LOGIN   - <
$db->query('SELECT password FROM rgb_members WHERE uid=1');
$admin = $db->fetch_row();

if ( $admin['password'] != $functions->getCookie('password') ) {

    //login from NOTICE Mail ?
    if ( $Ruskiy->GET['pas'] == $admin['password'] ) {
        $Ruskiy->CONF['cookie_time'] = 300;
        $functions->setCookie('password', $admin['password']);

    } elseif ( $Ruskiy->GET['mod'] != 'log' ) {
        unset($Ruskiy->GET['act']);
        $Ruskiy->GET['mod'] = 'log';
    }
}
// > -   END LOGIN CHECK


$choice = array( 'log' => 'login',
                 'idx' => 'doframes',
                'menu' => 'menu',
               'index' => 'index', // index need and temporary is messages
                 'sys' => 'system',

                'mess' => 'messages',
                'cmts' => 'comments',
                'user' => 'members',
               'input' => 'inputs',

                 'adm' => 'admin',
                 'emo' => 'emoteicon',
                 'ftr' => 'filter',
                 'ban' => 'ban',

                 'pop' => 'popup',

               'mld' => 'mailed',
                  'gd' => 'gd' );


//if ( !$functions->getGET('mod') ) $functions->setGET('mod', 'idx');
if ( !isset($choice[ $Ruskiy->GET['mod'] ]) ) $Ruskiy->GET['mod'] = 'idx';

if ( $Ruskiy->GET['mod'] == 'idx' ) {
    echo $Ruskiy->html->frameset();
    exit;
}

// Require and run
require ROOT_PATH. 'admin/a_' .$choice[ $Ruskiy->GET['mod'] ]. '.php';



?>