<?php /**************************************************************
*                  Ruskiy Guestbook 1.3 (a_admin.php)               *
*  ---------------------------------------------------------------  *
*   Author:  Yarmoluk Ruslan                                        *
*   E-mail: ruslan@ruskiy.com.ru                                    *
*   Home page: http://www.ruskiy.com.ru                             *
*   Licence Info: http://www.ruskiy.com.ru/?license                 *
*   Date started: 27 September 2005                                 *
*   Module version: 1.0                                             *
*  ---------------------------------------------------------------  *
*                   (c) 2005 Yarmoluk Ruslan                        *
******************************************************** ADMIN ******/

$idx = new Admin;

class Admin {

    var $html; // Template class


 /*=============================================================================
 |  ,  
 =============================================================================*/
 function Admin() {
   global $Ruskiy, $functions, $cashe;

     $Ruskiy->Lang = $functions->load_words($Ruskiy->Lang, 'lang_admin');
     $this->html = $functions->load_template('tpl_admin');


     $cashe->set($Ruskiy->html->page_head(), 'page_head');

     /*-------------------------------------------------------------------------
     |    
     -------------------------------------------------------------------------*/
     switch ( $Ruskiy->GET['act'] ) {
       case '01':
           $this->NoticeForm();
           break;
       case '_1':
           $this->doNotice();
           break;

       case '02':
           $this->ChPasswordForm();
           break;
       case '_2':
           $this->doChPassword();
           break;

       default :
           $this->NoticeForm();
           break;
     }
     //-------------------------------------------------------------------------

 }


 /*=============================================================================
 |      
 =============================================================================*/
 function ChPasswordForm($warning='') {
   global $Ruskiy, $functions, $cashe;

     $cashe->flush('page_head');  //   

     // add navigation to home
     $cashe->add($Ruskiy->html->nav_link('mod=adm&act=02', $Ruskiy->Lang['acp_password']), 'nav_bar');


     if ( !empty($warning) ) { // - ?
         $warning = $Ruskiy->html->warning($warning);
         $cashe->add($Ruskiy->html->nav_text($Ruskiy->Lang['warning']), 'nav_bar');
     }

     // echo navigation bar
     echo $Ruskiy->html->nav_bar($cashe->pop('nav_bar'));


     /*-------------------------------------------------------------------------
     |      
     -------------------------------------------------------------------------*/
     echo $this->html->chpass_fm($warning);

 }

 /*=============================================================================
 |     
 =============================================================================*/
 function doChPassword() {
   global $Ruskiy, $db;

     // Form verifine <
     if ( empty($Ruskiy->POST['password']) ) {
         $this->ChPasswordForm($Ruskiy->Lang['empty_password']);
         return;
     } elseif ( $Ruskiy->POST['password'] != $Ruskiy->POST['repassword'] ) {
         $this->ChPasswordForm($Ruskiy->Lang['not_equal']);
         return;
     } // > End verifine Form


     /*-------------------------------------------------------------------------
     |     
     -------------------------------------------------------------------------*/
     $inputs['password'] = md5($Ruskiy->POST['password']);


     // update password in database
     $db_string = $db->implode_to_string( $inputs );
     $db->query('UPDATE rgb_members SET '.$db_string.' WHERE uid=1');


     $url = $Ruskiy->BaseUrl.'mod=adm&act=02';
     echo $Ruskiy->html->redirect($url, $Ruskiy->Lang['change_done']);

 }


 /*=============================================================================
 |     NOTICE
 =============================================================================*/
 function NoticeForm($warning='') {
   global $Ruskiy, $functions, $cashe;

     $cashe->flush('page_head');  //   

     // add navigation to home
     $cashe->add($Ruskiy->html->nav_link('mod=adm&act=01', $Ruskiy->Lang['acp_notice']), 'nav_bar');

     if ( !empty($warning) ) { // - ?
         $warning = $Ruskiy->html->warning($warning);
         $cashe->add($Ruskiy->html->nav_text($Ruskiy->Lang['warning']), 'nav_bar');
     }

     // echo navigation bar
     echo $Ruskiy->html->nav_bar($cashe->pop('nav_bar'));


     /*-------------------------------------------------------------------------
     | NOTICE FORM
     -------------------------------------------------------------------------*/
     echo $this->html->notice_fm( array('warning' => $warning,
               'enable_notice' => $Ruskiy->html->form_checkbox('enable_notice', $Ruskiy->CONF['enable_notice'], $Ruskiy->Lang['enable_notice'], 'onClick="disabled_data(\'notice\')"'),

                 //'adl_checked' => $Ruskiy->CONF['admin']['show_enter'] ? 'checked' : '',
                                 ) );

 }


 /*=============================================================================
 |     NOTICE
 =============================================================================*/
 function doNotice() {
   global $Ruskiy, $db;


     // if checked enable notice
     if ( $Ruskiy->POST['enable_notice'] ) {

         // is empty email for notice?
         if ( empty($Ruskiy->POST['notice_to']) ) {
             $this->NoticeForm($Ruskiy->Lang['empty_notice_to']);
             return;
         // is wrong email?
         } elseif ( !eregi('^[a-z0-9_]+(([a-z0-9_.-]+)?)@[a-z0-9+](([a-z0-9_.-]+)?)+\.+[a-z]{2,4}$', $Ruskiy->POST['notice_to']) ) {
             $this->NoticeForm($Ruskiy->Lang['wrong_notice_to']);
             return;
         }
     }

     /*-------------------------------------------------------------------------
     |     
     -------------------------------------------------------------------------*/
     $CONF['mail_charset'] = $Ruskiy->POST['mail_charset'];

     $CONF['notice_to'] = $Ruskiy->POST['notice_to'];
     $CONF['notice_from'] = $Ruskiy->POST['notice_from'];
     $CONF['enable_notice'] = $Ruskiy->POST['enable_notice'] ? 1 : 0;
     //------------------

     $db_string = $db->implode_to_string( $CONF );
     $db->query('UPDATE rgb_config SET '.$db_string);


     $url = $Ruskiy->BaseUrl. 'mod=adm';
     echo $Ruskiy->html->redirect($url, $Ruskiy->Lang['update_done']);
 }


}
?>