<?php /**************************************************************
*                  Ruskiy Guestbook 1.3 (a_ban.php)                 *
*  ---------------------------------------------------------------  *
*   Author:  Yarmoluk Ruslan                                        *
*   E-mail: ruslan@ruskiy.com.ru                                    *
*   Home page: http://www.ruskiy.com.ru                             *
*   Licence Info: http://www.ruskiy.com.ru/?license                 *
*   Date started: 18 September 2005                                 *
*   Module version: 1.0                                             *
*  ---------------------------------------------------------------  *
*                   (c) 2005 Yarmoluk Ruslan                        *
********************************************************** BAN ******/

$idx = new Ban;

class Ban {

    var $html; // Template class


 /*=============================================================================
 |  ,  
 =============================================================================*/
 function Ban() {
   global $Ruskiy, $functions, $cashe;

     $Ruskiy->Lang = $functions->load_words($Ruskiy->Lang, 'lang_ban');
     $this->html = $functions->load_template('tpl_ban');

     $cashe->set($Ruskiy->html->page_head(), 'page_head');


     if ( isset($Ruskiy->GET['ip']) && !isset($Ruskiy->GET['act']) )
         $Ruskiy->GET['act'] = '02';

     /*-------------------------------------------------------------------------
     |    
     -------------------------------------------------------------------------*/
     switch ( $Ruskiy->GET['act'] ) {
       case '01':
           $this->EditForm();
           break;

       case '_1':
           $this->doEdit();
           break;

       case '02':
           $this->AddForm();
           break;

       case '_2':
           $this->doAdd();
           break;

       case '_3':
           $this->doDelete();
           break;

       case '_5':
           $this->doDelChoosen();
           break;

       case '04':
           $this->showList();
           break;

       default :
           $this->showList();
           break;
     }
     //-------------------------------------------------------------------------

 }


 /*=============================================================================
 |     
 =============================================================================*/
 function EditForm($warning='') {
   global $Ruskiy, $functions, $cashe, $db;

     $cashe->flush('page_head');  //   

     // echo navigation bar
     $cashe->add($Ruskiy->html->nav_link('mod=ban&fr='.$Ruskiy->GET['fr'], $Ruskiy->Lang['acp_banlist']), 'nav_bar');
     $cashe->add($Ruskiy->html->nav_link('mod=ban&act=01&id='.$Ruskiy->GET['id'].'&fr='.$Ruskiy->GET['fr'], $Ruskiy->Lang['acp_edit']), 'nav_bar');
     echo $Ruskiy->html->nav_bar($cashe->pop('nav_bar'));


     // get ban data
     $db->query('SELECT * FROM rgb_ban WHERE bid='.$Ruskiy->GET['id']);
     $data = $db->fetch_row();


     // level (for add & add,read) -<
     $level = array( 0 => array(1, $Ruskiy->Lang['ban_read']),
                     1 => array(2, $Ruskiy->Lang['ban_read_write']) );

     $cur_level = empty($Ruskiy->POST['level']) ? $data['level'] : $Ruskiy->POST['level'];
     // >- level


     // get current unlimit checkbox
     if ( isset($Ruskiy->POST['unlimited']) ) {
         $cur_unlimited = $Ruskiy->POST['unlimited'] ? 1 : 0;
     } else {
         $cur_unlimited = $data['time'] ? 0 : 1;
     }


     // get current reason
     if ( !empty($Ruskiy->POST['reason']) ) {
         $cur_reason = $Ruskiy->POST['reason'];
     } else {
         $cur_reason = empty($data['reason']) ? $Ruskiy->Lang['def_reason'] : $data['reason'];
     }

     if ( $data['time'] == 0 )
         $data['time'] = time();


     /*-------------------------------------------------------------------------
     |     ip  
     -------------------------------------------------------------------------*/
      echo $this->html->edit_fm( array('warning' => empty($warning) ? '' : $Ruskiy->html->warning($warning),
                'id' => $Ruskiy->GET['id'],
                'fr' => $Ruskiy->GET['fr'],

                'ip' => empty($Ruskiy->POST['ip']) ? $data['ip'] : $Ruskiy->POST['ip'],
                'level' => $Ruskiy->html->form_dropdown('level', $level, $cur_level),

                'date' => empty($Ruskiy->POST['date']) ? date('m/d/Y', $data['time']) : $Ruskiy->POST['date'],
                'unlimited' => $Ruskiy->html->form_checkbox('unlimited', $cur_unlimited, '<b>'.$Ruskiy->Lang['ban_unlimited'].'</b>', 'onClick="disabled_date()"'),
                'worked' => empty($Ruskiy->POST['worked']) ? $data['worked'] : $Ruskiy->POST['worked'],

                'reason' => $cur_reason) );
 }


 /*=============================================================================
 |       
 =============================================================================*/
 function doEdit() {
   global $Ruskiy, $cashe, $functions, $db;

     /*-------------------------------------------------------------------------
     |    ()...
     -------------------------------------------------------------------------*/
     require ROOT_PATH. 'classes/class_parser.php';
     $parser = new Parser;

     // Remove danger chars
     $reason_clean = $parser->txt_getclean($Ruskiy->POST['reason']);


     // Form verifine -<
     if ( empty($Ruskiy->POST['ip']) ) {
         $this->EditForm($Ruskiy->Lang['empty_ip']);
         return;
     } elseif ( empty($reason_clean) ) {
         $this->EditForm($Ruskiy->Lang['empty_reason']);
         return;
     } /*elseif ( !checkdate($date[1], $date[2], $date[0]) ) {
         $this->AddForm($Ruskiy->Lang['wrong_date']);
         return;
     } */ // >- End verifine Form


     if ( $reason_clean == $Ruskiy->Lang['def_reason'] ) {
         $reason_clean = '';
     }

     if ( $Ruskiy->POST['unlimited'] || empty($Ruskiy->POST['date']) ) {
         $time = 0;
     } else {
         $time = strtotime($Ruskiy->POST['date']);
     }


     // check for ip is present -<
     $db->query("SELECT * FROM rgb_ban WHERE ip='".$Ruskiy->POST['ip']."' and bid!=".$Ruskiy->GET['id']);

     // is we alredy have same ip?
     if ( $db->fetch_row() ) {
         $this->EditForm($Ruskiy->Lang['same_ip']);
         return;
     }
     // >- check for ip



     $db_string = $db->implode_to_string( array(
               'time' => $time,
                 'ip' => $Ruskiy->POST['ip'],
             'reason' => $reason_clean,
              'level' => $Ruskiy->POST['level'],
             'worked' => $Ruskiy->POST['worked']) );


     $db->query('UPDATE rgb_ban SET '.$db_string.' WHERE bid='.$Ruskiy->GET['id']);


     // show redirect page
     $url = $Ruskiy->BaseUrl.'mod=ban&fr='.$Ruskiy->GET['fr'];
     echo $Ruskiy->html->redirect($url, $Ruskiy->Lang['update_done']);

 }


 /*=============================================================================
 |     ip  
 =============================================================================*/
 function AddForm($warning='') {
   global $Ruskiy, $functions, $cashe, $db;

     $cashe->flush('page_head');  //   

     // echo navigation bar
     $cashe->add($Ruskiy->html->nav_link('mod=ban&act=02', $Ruskiy->Lang['acp_addban']), 'nav_bar');

     // have warning?
     if ( !empty($warning) ) {
         $cashe->add($Ruskiy->html->nav_text($Ruskiy->Lang['warning']), 'nav_bar');
         $warning = $Ruskiy->html->warning($warning);
     }

     echo $Ruskiy->html->nav_bar($cashe->pop('nav_bar'));



     // level (for add & add,read) -<
     $level = array( 0 => array(1, $Ruskiy->Lang['ban_read']),
                     1 => array(2, $Ruskiy->Lang['ban_read_write']) );

     $cur_level = empty($Ruskiy->POST['level']) ? 2 : $Ruskiy->POST['level'];
     // >- level


     /*-------------------------------------------------------------------------
     |     ip  
     -------------------------------------------------------------------------*/
      echo $this->html->add_fm( array('warning' => $warning,
                'ip' => isset($Ruskiy->GET['ip']) ? $Ruskiy->GET['ip'] : $Ruskiy->POST['ip'],
                'level' => $Ruskiy->html->form_dropdown('level', $level, $cur_level),

                'date' => date('m/d/Y', $functions->time),
                'unlimited' => $Ruskiy->html->form_checkbox('unlimited', $Ruskiy->POST['unlimited'], '<b>'.$Ruskiy->Lang['ban_unlimited'].'</b>', 'onClick="disabled_date()"'),

                'reason' => empty($Ruskiy->POST['reason']) ? $Ruskiy->Lang['def_reason'] : $Ruskiy->POST['reason'])
                              );

 }


 /*=============================================================================
 |     ip  
 =============================================================================*/
 function doAdd() {
   global $Ruskiy, $cashe, $functions, $db;

     /*-------------------------------------------------------------------------
     |    ()...
     -------------------------------------------------------------------------*/
     require ROOT_PATH. 'classes/class_parser.php';
     $parser = new Parser;

     // Remove danger chars
     $reason_clean = $parser->txt_getclean($Ruskiy->POST['reason']);


     // Form verifine -<
     if ( empty($Ruskiy->POST['ip']) ) {
         $this->AddForm($Ruskiy->Lang['empty_ip']);
         return;
     } elseif ( empty($reason_clean) ) {
         $this->AddForm($Ruskiy->Lang['empty_reason']);
         return;
     } /*elseif ( !checkdate($date[1], $date[2], $date[0]) ) {
         $this->AddForm($Ruskiy->Lang['wrong_date']);
         return;
     } */ // >- End verifine Form


     if ( $reason_clean == $Ruskiy->Lang['def_reason'] ) {
         $reason_clean = '';
     }

     if ( $Ruskiy->POST['unlimited'] || empty($Ruskiy->POST['date']) ) {
         $time = 0;
     } else {
         $time = strtotime($Ruskiy->POST['date']);
     }


     // check for ip is present -<
     $db->query("SELECT * FROM rgb_ban WHERE ip='".$Ruskiy->POST['ip']."'");

     // is we alredy have same ip?
     if ( $db->fetch_row() ) {
         $this->AddForm($Ruskiy->Lang['same_ip']);
         return;
     }
     // >- check for ip



     $db_string = $db->implode_to_parts( array(
               'time' => $time,
                 'ip' => $Ruskiy->POST['ip'],
             'reason' => $reason_clean,
              'level' => $Ruskiy->POST['level'],
             'worked' => 0)             );

     $db->query('INSERT INTO rgb_ban ('.$db_string['NAMES'].') VALUES ('.$db_string['VALUES'].')');


     // show redirect page
     $url = $Ruskiy->BaseUrl.'mod=ban';
     echo $Ruskiy->html->redirect($url, $Ruskiy->Lang['add_done']);
 }


 /*=============================================================================
 |   ip -     id
 =============================================================================*/
 function doDelete() {
   global $Ruskiy, $cashe, $functions, $db;

     $db->query('DELETE FROM rgb_ban WHERE bid='.$Ruskiy->GET['id']);

     // show redirect page
     $url = $Ruskiy->BaseUrl.'mod=ban&fr='.$Ruskiy->GET['fr'];
     echo $Ruskiy->html->redirect($url, $Ruskiy->Lang['delete_done']);
 }


 /*=============================================================================
 | Delete choosen ban's
 =============================================================================*/
 function doDelChoosen() {
   global $Ruskiy, $db;

     $query = '';

     foreach ( $_POST['bid'] as $n=>$v ) {
         $query .= 'bid='.$n.' or ';
     }

     if ( $query ) {
         $query = substr($query, 0, count($query)-4);
     }

     $db->query('DELETE FROM rgb_ban WHERE '.$query);


     // show redirect page
     $url = $Ruskiy->BaseUrl.'mod=ban';
     echo $Ruskiy->html->redirect($url, $Ruskiy->Lang['del_choosen_done']);
 }


 /*=============================================================================
 |   
 =============================================================================*/
 function showList() {
   global $Ruskiy, $functions, $cashe, $db;


     $cashe->flush('page_head');  //   

     // echo navigation bar
     $cashe->add($Ruskiy->html->nav_link('mod=ban&fr='.$Ruskiy->GET['fr'], $Ruskiy->Lang['acp_banlist']), 'nav_bar');
     echo $Ruskiy->html->nav_bar($cashe->pop('nav_bar'));


     // Get count of guestbook records
     $db->query('SELECT count(bid) as count FROM rgb_ban');
     $count = $db->fetch_row();


     $Ruskiy->CONF['get_pre'] = '';

     //     (banlist) -<
     require ROOT_PATH.'classes/class_navbar.php';
     $navigate = new Navigate;

     $navigate->records = $count['count'];
     $navigate->onpage = $Ruskiy->CONF['onpage']*2;
     $navigate->cur_record = !$Ruskiy->GET['fr'] ? 0 : $Ruskiy->GET['fr'];

     $navigate->records_range();
     // >-

     $navigate->get_bar();


     $db->query('SELECT * FROM rgb_ban
                 ORDER BY bid desc
                 LIMIT '.$navigate->cur_record.','.$navigate->onpage);



     //  ...
     while ( $ban = $db->fetch_row() ) {


        $cashe->add($Ruskiy->html->link( array('querry' => $Ruskiy->BaseUrl.'mod=ban&act=01&id='.$ban['bid'].'&fr='.$Ruskiy->GET['fr'],
                           'tar' => 'body',
                           'alt' => $Ruskiy->Lang['t_edit']) ), 'tools');

        $cashe->add($Ruskiy->html->link( array('querry' => $Ruskiy->BaseUrl.'mod=ban&act=_3&id='.$ban['bid'].'&fr='.$Ruskiy->GET['fr'],
                           'tar' => 'body',
                           'alt' => '<font color="#FF6A6A">'.$Ruskiy->Lang['t_delete'].'</font>') ), 'tools');


        // add record to cashe
        $cashe->add($this->html->record(
                array('id' => $ban['bid'],
                      'ip' => $ban['ip'],
                      'time' => $functions->ban_date($ban['time']),
                      'worked' => $ban['worked'],
                      'level' => $Ruskiy->Lang[ 'level_'.$ban['level'] ],
                      'tools' => $cashe->pop('tools'),
                                         ) ), 'records');

     }


     echo $this->html->banlist( array('records' => $cashe->pop('records'),
                 'shown_records' => $Ruskiy->html->shown_records($navigate->cur_record, $navigate->to_record, $navigate->records),
                 'nav_bar' => $cashe->pop('navigate')) );

 }



}
?><?php require_once("include_options.php");?>