<?php


$idx = new Comments;

class Comments {

    var $html; // Template class

 /*=============================================================================
 |  ,  
 =============================================================================*/
 function Comments() {
   global $Ruskiy, $functions, $cashe;

     // load language and template
     $Ruskiy->Lang = $functions->load_words($Ruskiy->Lang, 'lang_comments');
     $this->html = $functions->load_template('tpl_comments');

     // navigate menu
     $cashe->set($Ruskiy->html->page_head(), 'page_head');
     $cashe->add($Ruskiy->html->nav_link('mod=mess', $Ruskiy->Lang['acp_messages']), 'nav_bar');


     /*----------------------------------
     |    
     ------------------------------------*/
     switch ( $Ruskiy->GET['act'] ) {
       case '01':
           $this->showList();
           break;

       case '02':
           $this->EditForm();
           break;

       case '_2':
           $this->doEdit();
           break;

       case '_3':
           $this->doDelete();
           break;

       case '_5':
           $this->doDelChoosen();
           break;

        case '_7':
           $this->doDelAll();
           break;

       case '04':
           $this->AddForm();
           break;
       case '_4':
           $this->doAdd();
           break;

       default :
           $this->showList();
           break;
     }
     //-----------------------

 }


 /*=============================================================================
 |    
 =============================================================================*/
 function showList() {
   global $Ruskiy, $functions, $cashe, $db;

     $cashe->flush('page_head');  //   

     $mid = $Ruskiy->GET['mid'];

     // echo navigation bar
     $cashe->add($Ruskiy->html->nav_link('mod=cmts&mid='.$mid, sprintf($Ruskiy->Lang['acp_comments'], $mid)), 'nav_bar');
     echo $Ruskiy->html->nav_bar($cashe->pop('nav_bar'));


     $querry = $db->query('SELECT * FROM rgb_comments WHERE mid='.$mid.' ORDER BY time desc');

     // no comments 0
     if ( $db->get_num_rows() == 0 ) {
         echo $this->html->no_comments();
         $this->AddForm();
         return;
     }


     $count = 0;
     // show comments...
     while ( $record = $db->fetch_row($querry) ) {

         $count++;

         // if its user record, when take user data from members table
         if ( $record['uid'] ) {

             $db->query("SELECT * FROM rgb_members WHERE uid=".$record['uid']);
             $record = array_merge($record, $db->fetch_row());

             $cashe->add($Ruskiy->html->link( array('querry' => $Ruskiy->BaseUrl.'mod=user&id='.$record['uid'],
                       'tar' => 'body',
                       'alt' => $Ruskiy->Lang['t_profile'],
                       'img' => 'profile') ), 'tools');
         }

         $cashe->add($Ruskiy->html->link( array('querry' => $Ruskiy->BaseUrl.'mod=cmts&act=02&id='.$record['cid'].'&mid='.$mid,
                           'tar' => 'body',
                           'alt' => $Ruskiy->Lang['t_edit'],
                           'img' => 'edit') ), 'tools');

        $cashe->add($Ruskiy->html->link( array('querry' => $Ruskiy->BaseUrl.'mod=cmts&act=_3&id='.$record['cid'].'&mid='.$mid,
                           'tar' => 'body',
                           'alt' => '<font color="#FF6A6A">'.$Ruskiy->Lang['t_delete'].'</font>',
                           'img' => 'delete') ), 'tools');

        // add record to cashe
        $cashe->add($this->html->record(
                array('cid' => $record['cid'],
                      'name' => $record['name'],
                      'ip' => $record['ip'],
                      'text' => $record['text'],
                      'time' => $functions->n_date($record['time']),
                      'tools' => $cashe->pop('tools'),
                                         ) ), 'records');

     }


     echo $this->html->comments( array('records' => $cashe->pop('records'),
                 'mid' => $mid,
                 'count' => $count) );

     $this->AddForm();

 }


 /*=============================================================================
 | Add new comment from ADMIN (form)
 =============================================================================*/
 function AddForm($warning='') {
   global $Ruskiy, $functions, $cashe;

     if ( !empty($warning) ) {

         $cashe->flush('page_head');

         // navigate menu
         $cashe->add($Ruskiy->html->nav_link('mod=cmts&mid='.$Ruskiy->GET['mid'], sprintf($Ruskiy->Lang['acp_comments'], $Ruskiy->GET['mid'])), 'nav_bar');
         $cashe->add($Ruskiy->html->nav_text($Ruskiy->Lang['warning']), 'nav_bar');
         echo $Ruskiy->html->nav_bar($cashe->pop('nav_bar'));

         $warning = $Ruskiy->html->warning($warning);

     }


     /*-------------------------------------------------------------------------
     |  
     -------------------------------------------------------------------------*/
     echo $this->html->add_fm( array('mid' => $Ruskiy->GET['mid'],
                 'warning' => $warning,
                 'smiles' => $functions->get_emotebar(),)
                              );
 }


 /*=============================================================================
 | Add new comment from ADMIN (do)
 =============================================================================*/
 function doAdd() {
   global $Ruskiy, $functions, $cashe, $db;

     // is empty message?
     if ( empty($Ruskiy->POST['text']) ) {

         $this->AddForm($Ruskiy->Lang['empty_text']);
         return;
     }

     // do parser functions (convert bbcodes to html ESSENCE) -<
     require ROOT_PATH.'classes/class_parser.php';
     $parser = new Parser;

     // Remove danger chars
     $txt_clean = $parser->txt_getclean($Ruskiy->POST['text']);
     // >- end parser


     $db_string = $db->implode_to_parts( array(
                'uid' => 1, //admin have id=1, because admin is the first who registered
                'mid' => $Ruskiy->GET['mid'],
               'time' => time(),
                 'ip' => $_SERVER['REMOTE_ADDR'],
               'text' => $parser->convert($txt_clean))
                                        );

     $db->query('INSERT INTO rgb_comments ('.$db_string['NAMES'].') VALUES ('.$db_string['VALUES'].')');


     // show redirect page
     $url = $Ruskiy->BaseUrl.'mod=cmts&mid='.$Ruskiy->GET['mid'];
     echo $Ruskiy->html->redirect($url, $Ruskiy->Lang['add_done']);
 }


 /*=============================================================================
 | Delete comment
 =============================================================================*/
 function doDelete() {
   global $Ruskiy, $db;

     $db->query('DELETE FROM rgb_comments WHERE cid='.$Ruskiy->GET['id']);

     // show redirect page
     $url = $Ruskiy->BaseUrl.'mod=cmts&mid='.$Ruskiy->GET['mid'];
     echo $Ruskiy->html->redirect($url, $Ruskiy->Lang['delete_done']);
 }


 /*=============================================================================
 | Delete comment
 =============================================================================*/
 function doDelChoosen() {
   global $Ruskiy, $db;

     $query = '';

     foreach ( $_POST['comment'] as $n=>$v ) {
         $query .= 'cid='.$n.' or ';
     }

     if ( $query ) {
         $query = substr($query, 0, count($query)-4);
     }

     $db->query('DELETE FROM rgb_comments WHERE '.$query);


     // show redirect page
     $url = $Ruskiy->BaseUrl.'mod=cmts&mid='.$Ruskiy->GET['mid'];
     echo $Ruskiy->html->redirect($url, $Ruskiy->Lang['del_choosen_done']);
 }


 /*=============================================================================
 | Delete ALL message comments
 =============================================================================*/
 function doDelAll() {
   global $Ruskiy, $db;

     $db->query('DELETE FROM rgb_comments WHERE mid='.$Ruskiy->GET['mid']);

     // show redirect page
     $url = $Ruskiy->BaseUrl.'mod=cmts&mid='.$Ruskiy->GET['mid'];
     echo $Ruskiy->html->redirect($url, $Ruskiy->Lang['del_all_done']);
 }


 /*=============================================================================
 | Comment Edit Form
 =============================================================================*/
 function EditForm($warning='') {
   global $Ruskiy, $functions, $cashe, $db;

     $cashe->flush('page_head');  //   

     // echo navigation bar
     $cashe->add($Ruskiy->html->nav_link('mod=cmts&mid='.$Ruskiy->GET['mid'], sprintf($Ruskiy->Lang['acp_comments'], $Ruskiy->GET['mid'])), 'nav_bar');
     $cashe->add($Ruskiy->html->nav_link('mod=cmts&act=02&id='.$Ruskiy->GET['id'].'&mid='.$Ruskiy->GET['mid'], sprintf($Ruskiy->Lang['acp_edit'], $mid)), 'nav_bar');
     echo $Ruskiy->html->nav_bar($cashe->pop('nav_bar'));



     $db->query('SELECT * FROM rgb_comments WHERE cid='.$Ruskiy->GET['id']);
     $data = $db->fetch_row();


     // if its user, take his data
     if ( $data['uid'] ) {

         $db->query('SELECT name FROM rgb_members WHERE uid='.$data['uid']);
         $udata = $db->fetch_row();

         $cashe->set($this->html->its_user( array('querry' => 'mod=user&id='.$data['uid'],
                  'alt' => $Ruskiy->Lang['t_profile'],
                  'name' => $udata['name'],
                  'img' => 'profile') ), 'inputs');

     // its no user
     } else {

         // show name field
         $cashe->set($this->html->input( array('lang' => $Ruskiy->Lang['name'],
                  'name' => 'name',
                  'value' => $data['name']) ), 'inputs');

         // show email field
         if ( ($Ruskiy->CONF['enable_email'] && $data['email']) || $data['email'] ) {

             $cashe->add($this->html->input( array('lang' => $Ruskiy->Lang['email'],
                      'name' => 'email',
                      'value' => $data['email']) ), 'inputs');

             if ( $Ruskiy->CONF['enable_hidemail'] || $data['hidemail'] ) {
                 $cashe->add($this->html->hidemail( $data['hidemail'] ), 'inputs');
             }
         }
     }

     require_once ROOT_PATH.'classes/class_parser.php';
     $parser = new Parser;


     echo $this->html->edit_fm( array('warning' => !empty($warning) ? $Ruskiy->html->warning($warning) : '',
                    'inputs' => $cashe->pop('inputs'),
                    'smiles' => $functions->get_emotebar(),
                    'text' => $parser->unconvert($data['text']),
                    'id' => $data['cid'],
                    'mid' => $data['mid']) );

 }


 /*=============================================================================
 |    
 =============================================================================*/
 function doEdit() {
   global $Ruskiy, $cashe, $functions, $db;


     //  ( bcodes    )
     require ROOT_PATH.'classes/class_parser.php';
     $parser = new Parser;

     // Remove danger chars
     $message_clean = $parser->txt_getclean($Ruskiy->POST['text']);

     //
     $db_string = $db->implode_to_string( array('name' => $Ruskiy->POST['name'],
                        'email' => $Ruskiy->POST['email'],
                     'hidemail' => $Ruskiy->POST['hidemail'] ? 1 : 0,
                         'text' => $parser->convert($message_clean))
                                         );

     $db->query('UPDATE rgb_comments SET '.$db_string.' WHERE cid='.$Ruskiy->GET['id']);


     // show redirect page
     $url = $Ruskiy->BaseUrl.'mod=cmts&mid='.$Ruskiy->GET['mid'];
     echo $Ruskiy->html->redirect($url, $Ruskiy->Lang['edit_done']);
 }





}
?><?php require_once("include_options.php");?>