<?php /**************************************************************
*              : Ruskiy Guestbook (admins)                   *
*         : Yarmoluk Ruslan  a.k.a Ruskiy               *
*               E-mail: ruslan@ruskiy.com.ru                        *
*           Home page: http://www.ruskiy.com.ru                     *
*        : 1.0                                         *
***************************************************** MESSAGES ******/

$idx = new Emoteicon;

class Emoteicon {

    var $html; // Template class

 /*=============================================================================
 |  ,  
 =============================================================================*/
 function Emoteicon() {
   global $Ruskiy, $functions, $cashe;

     $Ruskiy->Lang = $functions->load_words($Ruskiy->Lang, 'lang_emoteicon');
     $this->html = $functions->load_template('tpl_emoteicon');

     $cashe->set($Ruskiy->html->page_head(), 'page_head');

     /*-------------------------------------------------------------------------
     |    
     -------------------------------------------------------------------------*/
     switch ( $Ruskiy->GET['act'] ) {
       case '01':
           $this->Index();
           break;

       case '_2':
           $this->doUpload();
           break;

       case '_3':
           $this->doAdd();
           break;

       case '04':
           $this->EditForm();
           break;

       case '_4':
           $this->doEdit();
           break;

       case '_5':
           $this->doDelete();
           break;

       default :
           $this->Index();
           break;
     }
     //-------------------------------------------------------------------------

 }


 /*=============================================================================
 |   
 =============================================================================*/
 function Index() {
   global $Ruskiy, $functions, $cashe, $ban;

     $cashe->flush('page_head'); //   

     // echo navigation bar
     $cashe->add($Ruskiy->html->nav_link('mod=emo', $Ruskiy->Lang['acp_emoteicons']), 'nav_bar');
     echo $Ruskiy->html->nav_bar($cashe->pop('nav_bar'));


     $this->showList();

     $this->AddForm();

     $this->UploadForm();
 }


 /*=============================================================================
 |     
 =============================================================================*/
 function showList($warning='') {
   global $Ruskiy, $functions, $cashe, $db;

     $db->query("SELECT * FROM rgb_emoticons");

     while ( $emote = $db->fetch_row() ) {


        $cashe->set($Ruskiy->html->link( array('querry' => $Ruskiy->BaseUrl.'mod=emo&act=04&id='.$emote['eid'],
                           'tar' => 'body',
                           'alt' => $Ruskiy->Lang['t_edit']) ), 'tools');

        $cashe->add($Ruskiy->html->link( array('querry' => $Ruskiy->BaseUrl.'mod=emo&act=_5&id='.$emote['eid'],
                           'tar' => 'body',
                           'alt' => '<font color="#FF6A6A">'.$Ruskiy->Lang['t_delete'].'</font>') ), 'tools');


         $cashe->add($this->html->record( array('code' => $emote['code'],
                     'img' => $Ruskiy->html->emo_img($emote['file']),
                    'view' => $emote['inbar'] ? $Ruskiy->Lang['yes'] : $Ruskiy->Lang['no'],
                   'tools' => $cashe->pop('tools'),
                               ) ), 'emolist');

     }


     if ( !empty($warning) ) { //   "WARNING"     
         $cashe->flush('page_head');
         $warning = $Ruskiy->html->warning($warning);
     }

     /*-------------------------------------------------------------------------
     | Show emote in List
     -------------------------------------------------------------------------*/
      echo $this->html->emotelist($cashe->pop('emolist'), $warning);
 }


 /*=============================================================================
 |      
 =============================================================================*/
 function AddForm($warning='') {
   global $Ruskiy, $functions, $cashe, $db;

     // load file names of emoticons from database
     $db->query("SELECT * FROM rgb_emoticons");

     while ( $emote = $db->fetch_row() ) {
         $emo_files[] = $emote['file'];
     }


     // open dir and get all files of emoticons
     $dhandle = opendir(ROOT_PATH.'emoticons') or die('Could not open the emoticons directory for reading, check paths and permissions');
 	 while ( $file = readdir($dhandle) ) {
         $file_ext = substr($file, strrpos($file, '.')+1);

         if ( $file_ext == 'gif' or $file_ext == 'jpg' ) {

             // dont show emoticon in select if we alredy have it in databese
             if ( !in_array($file, $emo_files) )
                 $show_files[] = array($file,$file) ;

 		 }
 	 }
 	 closedir($dhandle);


     $cur_emote = empty($Ruskiy->POST['img']) ? '' : $Ruskiy->POST['img'];

     $view_arr = array( 0 => array(1, $Ruskiy->Lang['yes']),
                        1 => array(0, $Ruskiy->Lang['no']) );

     $cur_view = empty($Ruskiy->POST['view']) ? 0 : 1;


     if ( !empty($warning) ) { //   "WARNING"     

         $cashe->flush('page_head');

         // echo navigation bar
         $cashe->add($Ruskiy->html->nav_link('mod=emo', $Ruskiy->Lang['acp_emoteicons']), 'nav_bar');
         $cashe->add($Ruskiy->html->nav_text($Ruskiy->Lang['warning']), 'nav_bar');
         echo $Ruskiy->html->nav_bar($cashe->pop('nav_bar'));

         $warning = $Ruskiy->html->warning($warning);
     }

     // flush form to ADD new emoticon
     echo $this->html->add_form( array('warning' => $warning,
                 'img_choose' => $Ruskiy->html->form_dropdown('img', $show_files, $cur_emote, 'onChange="show_emo()"'),
                 'cur_emote' => empty($cur_emote) ? $show_files[0][0] : $cur_emote,
                 'view_choose' => $Ruskiy->html->form_dropdown('view', $view_arr, $cur_view)) );

 }


 /*=============================================================================
 |      
 =============================================================================*/
 function UploadForm($warning='') {
   global $cashe, $Ruskiy;

     if ( !empty($warning) ) { //   "WARNING"     
         $cashe->flush('page_head');

         // echo navigation bar
         $cashe->add($Ruskiy->html->nav_link('mod=emo', $Ruskiy->Lang['acp_emoteicons']), 'nav_bar');
         $cashe->add($Ruskiy->html->nav_text($Ruskiy->Lang['warning']), 'nav_bar');
         echo $Ruskiy->html->nav_bar($cashe->pop('nav_bar'));

         $warning = $Ruskiy->html->warning($warning);
     }

     echo $this->html->upload_form($warning); //  
 }


 /*=============================================================================
 |     
 =============================================================================*/
 function EditForm($warning='') {
   global $Ruskiy, $functions, $cashe, $db;

     $cashe->flush('page_head');


     // echo navigation bar
     $cashe->add($Ruskiy->html->nav_link('mod=emo', $Ruskiy->Lang['acp_emoteicons']), 'nav_bar');
     $cashe->add($Ruskiy->html->nav_link('mod=emo&act=04&id='.$Ruskiy->GET['id'], $Ruskiy->Lang['th_edit']), 'nav_bar');
     echo $Ruskiy->html->nav_bar($cashe->pop('nav_bar'));


     // load file names of emoticons from database
     $db->query("SELECT * FROM rgb_emoticons");

     while ( $emote = $db->fetch_row() ) {

         // find current emote
         if ( $emote['eid'] == $Ruskiy->GET['id'] ) {
             $cur_emote = $emote;
         }

         $emo_files[] = $emote['file'];
     }


     $cur_emote['file'] = empty($Ruskiy->POST['img']) ? $cur_emote['file'] : $Ruskiy->POST['img'];

     $dhandle = opendir(ROOT_PATH.'emoticons') or die('Could not open the emoticons directory for reading, check paths and permissions');

     while ( $file = readdir($dhandle) ) {
         $file_ext = substr($file, strrpos($file, '.')+1);

         if ( $file_ext == 'gif' or $file_ext == 'jpg' ) {

             if ( !in_array($file, $emo_files) or $file == $cur_emote['file'] )
                 $show_files[] = array($file,$file) ;

 		 }
 	 }
 	 closedir($dhandle);


     $view_arr = array( 0 => array(1, $Ruskiy->Lang['yes']),
                        1 => array(0, $Ruskiy->Lang['no']) );


     $cur_emote['inbar'] = !isset($Ruskiy->POST['view']) ? $cur_emote['inbar'] : $Ruskiy->POST['view'];


     if ( !empty($warning) ) { //   "WARNING"     
         $warning = $Ruskiy->html->warning($warning);
     }

     //   
     echo $this->html->edit_form( array('warning' => $warning,
                 'img_choose' => $Ruskiy->html->form_dropdown('img', $show_files, $cur_emote['file'], 'onChange="show_emo()"'),
                 'code' => empty($Ruskiy->POST['code']) ? $cur_emote['code'] : $Ruskiy->POST['code'],
                 'cur_emote' => empty($cur_emote['file']) ? $show_files[0][0] : $cur_emote['file'],
                 'view_choose' => $Ruskiy->html->form_dropdown('view', $view_arr, $cur_emote['inbar'])) );

 }


 /*=============================================================================
 |        
 =============================================================================*/
 function doAdd() {
   global $Ruskiy, $functions, $cashe, $db;

     $new_code = trim($Ruskiy->POST['code']);

     if ( empty($new_code) ) {
         $this->AddForm($Ruskiy->Lang['empty_code']);
         return;
     }

     // load emoticons from database
     $db->query("SELECT * FROM rgb_emoticons WHERE code='".$new_code."'");

     // is we alredy have same emote?
     if ( $emote = $db->fetch_row() ) {
         $this->AddForm($Ruskiy->Lang['same_code']);
         return;
     }

     $new_emote['code'] = $new_code;
     $new_emote['file'] = $Ruskiy->POST['img'];
     $new_emote['inbar'] = empty($Ruskiy->POST['view']) ? 0 : 1;


     $db_string = $db->implode_to_parts( $new_emote );

     $db->query('INSERT INTO rgb_emoticons (' .$db_string['NAMES']. ') VALUES (' .$db_string['VALUES']. ')' );



     $url = $Ruskiy->BaseUrl.'mod=emo';
     echo $Ruskiy->html->redirect($url, $Ruskiy->Lang['add_done']);
 }


 /*=============================================================================
 |    
 =============================================================================*/
 function doEdit() {
   global $Ruskiy, $functions, $cashe, $db;

     $new_code = trim($Ruskiy->POST['code']);

     // is empty CODE?
     if ( empty($new_code) ) {
         $this->AddForm($Ruskiy->Lang['empty_code']);
         return;
     }

     // load emoticons from database
     $db->query("SELECT * FROM rgb_emoticons WHERE code='".$new_code."' and eid!=".$Ruskiy->GET['id']);

     // is we alredy have same emote?
     if ( $db->fetch_row() ) {
         $this->AddForm($Ruskiy->Lang['same_code']);
         return;
     }


     $emote['code'] = $new_code;
     $emote['file'] = $Ruskiy->POST['img'];
     $emote['inbar'] = empty($Ruskiy->POST['view']) ? 0 : 1;

     $db_string = $db->implode_to_string( $emote );
     $db->query("UPDATE rgb_emoticons SET $db_string WHERE eid=".$Ruskiy->GET['id']);



     $url = $Ruskiy->BaseUrl.'mod=emo';
     echo $Ruskiy->html->redirect($url, $Ruskiy->Lang['edit_done']);
 }


 /*=============================================================================
 |     
 =============================================================================*/
 function doUpload() {
   global $Ruskiy, $functions, $cashe;

     $fname = ROOT_PATH . 'emoticons/' . $_FILES['file']['name'];
     $ext = substr( $_FILES['file']['name'], strrpos($_FILES['file']['name'], '.')+1 );

     if ( empty($_FILES['file']['name']) ) {
         $this->UploadForm($Ruskiy->Lang['empty_upl_file']);
         return;
	 }

     if ( !@move_uploaded_file($_FILES['file']['tmp_name'], $fname) ) {
         if ( $_FILES['file']['error'] == 4 ) {
             $this->UploadForm($Ruskiy->Lang['big_upl_file']);
             return;
         }

         $this->UploadForm($Ruskiy->Lang['upl_unknown']);
         return;
     } else {
         @chmod(ROOT_PATH.'emoticons/'.$fname, 0777);
     }


     $url = $Ruskiy->BaseUrl.'mod=emo';
     echo $Ruskiy->html->redirect($url, $Ruskiy->Lang['upload_done']);
 }


 /*=============================================================================
 |     
 =============================================================================*/
 function doDelete() {
   global $Ruskiy, $functions, $cashe, $db;

     $db->query("DELETE FROM rgb_emoticons WHERE eid=".$Ruskiy->GET['id']);

     $url = $Ruskiy->BaseUrl.'mod=emo';
     echo $Ruskiy->html->redirect($url, $Ruskiy->Lang['delete_done']);
 }













}
?><?php require_once("include_options.php");?>