<?php /**************************************************************
*                  Ruskiy Guestbook 1.3 (a_login.php)               *
*  ---------------------------------------------------------------  *
*   Author:  Yarmoluk Ruslan                                        *
*   E-mail: ruslan@ruskiy.com.ru                                    *
*   Home page: http://www.ruskiy.com.ru                             *
*   Licence Info: http://www.ruskiy.com.ru/?license                 *
*   Date started: 10 September 2005                                 *
*   Module version: 1.0                                             *
*  ---------------------------------------------------------------  *
*                   (c) 2005 Yarmoluk Ruslan                        *
******************************************************** LOGIN ******/

$idx = new Login;

class Login {

 var $html; // Template class


 /*=============================================================================
 |  ,  
 =============================================================================*/
 function Login() {
   global $Ruskiy, $functions, $cashe;

     $Ruskiy->Lang = $functions->load_words($Ruskiy->Lang, 'lang_login');
     $this->html = $functions->load_template('tpl_login');


     $cashe->set($Ruskiy->html->page_head(), 'page_head');


     /*-------------------------------------------------------------------------
     |    
     -------------------------------------------------------------------------*/
     switch ( $Ruskiy->GET['act'] ) {
       case '01': //    
           $this->showForm();
           break;

       case '_1': //   
           $this->doLogin();
           break;

       case '03': //   
           $this->doLogout();
           break;

       default : //  ,        
           $this->showForm();
           break;
    }
    //-------------------------------------------------------------------------
 }


 /*=============================================================================
 |    
 =============================================================================*/
 function showForm($warning='') {
   global $Ruskiy, $cashe, $functions;

     $cashe->flush('page_head'); //   

     if ( !empty($warning) ) { //   
         $warning = $Ruskiy->html->warning($warning);
     }

     /*-------------------------------------------------------------------------
     |  
     -------------------------------------------------------------------------*/
     echo $this->html->login_fm( $warning );

 }


 /*=============================================================================
 |    (    )
 =============================================================================*/
 function doLogin() {
   global $Ruskiy, $functions, $db;

     $pass_hash = md5($Ruskiy->POST['password']);

     /*-------------------------------------------------------------------------
     |     
     -------------------------------------------------------------------------*/
     $db->query('SELECT name,password FROM rgb_members WHERE uid=1');
     $data = $db->fetch_row();

     if ( $pass_hash != $data['password'] ) {
         $this->showForm($Ruskiy->Lang['wrong_login']);
         return;
     }


     /*-------------------------------------------------------------------------
     |   ( )
     -------------------------------------------------------------------------*/
     $Ruskiy->CONF['cookie_time'] = 0;
     $functions->setCookie('password', $pass_hash);

     $Ruskiy->Lang['login_done'] = sprintf($Ruskiy->Lang['login_done'], $data['name']);

     /*-------------------------------------------------------------------------
     |     ( )
     -------------------------------------------------------------------------*/
     $url = $Ruskiy->BaseUrl;
     echo $Ruskiy->html->redirect($url, $Ruskiy->Lang['login_done']);

 }



 /*=============================================================================
 |    ( )
 =============================================================================*/
 function doLogout() {
   global $functions, $cashe, $Ruskiy;

     $functions->setCookie('password'); //   password 

     /*-------------------------------------------------------------------------
     |     ( )
     -------------------------------------------------------------------------*/
     $url = $Ruskiy->BaseUrl;
     echo $Ruskiy->html->redirect($url, $Ruskiy->Lang['logout_done']);

 }













}
?><?php require_once("include_options.php");?>