<?php


$idx = new Members;

class Members {

    var $html; // Template class

 /*=============================================================================
 |  ,  
 =============================================================================*/
 function Members() {
   global $Ruskiy, $functions, $cashe;

     $Ruskiy->Lang = $functions->load_words($Ruskiy->Lang, 'lang_members');
     $this->html = $functions->load_template('tpl_members');

     $cashe->set($Ruskiy->html->page_head(), 'page_head');

     /*----------------------------------
     |    
     ------------------------------------*/
     switch ( $Ruskiy->GET['act'] ) {
       case '01':
           $this->showList();
           break;

       case '02':
           $this->EditForm();
           break;
       case '_2':
           $this->doEdit();
           break;

       case '_3':
           $this->doDelete();
           break;

       case '04':
           $this->AddForm();
           break;
       case '_4':
           $this->doAdd();
           break;

       default :
           $this->showList();
           break;
     }
     //-----------------------

 }


 /*=============================================================================
 |     
 =============================================================================*/
 function showList() {
   global $Ruskiy, $functions, $cashe, $db;

     $cashe->flush('page_head');  //   

     // echo navigation bar
     $cashe->add($Ruskiy->html->nav_link('mod=user&fr='.$Ruskiy->GET['fr'], $Ruskiy->Lang['acp_members']), 'nav_bar');
     echo $Ruskiy->html->nav_bar($cashe->pop('nav_bar'));


     // Get count of Registered Members
     $db->query('SELECT count(uid) as count FROM rgb_members;');
     $count = $db->fetch_row();


     $Ruskiy->CONF['get_pre'] = '';

     //       -<
     require ROOT_PATH. 'classes/class_navbar.php';
     $navigate = new Navigate;

     $navigate->records = $count['count'];
     $navigate->onpage = $Ruskiy->CONF['onpage']*2;
     $navigate->cur_record = !$Ruskiy->GET['fr'] ? 0 : $Ruskiy->GET['fr'];

     $navigate->records_range();
     // >-

     $navigate->get_bar();


     $query = $db->query('SELECT * FROM rgb_members
                          ORDER BY registered desc
                          LIMIT '.$navigate->cur_record.','.$navigate->onpage.';');


     // Show Members
     while ( $record = $db->fetch_row($query) ) {

        $cashe->add($Ruskiy->html->link( array('querry' => $Ruskiy->BaseUrl.'mod=user&act=02&id='.$record['uid'].'&fr='.$Ruskiy->GET['fr'],
                           'tar' => 'body',
                           'alt' => $Ruskiy->Lang['t_edit']) ), 'tools');

        // check for ADMIN
        if ( $record['uid'] == 1 ) {
            $record['name'] = '<font color="#FF6A6A">'.$record['name'].'</font>';
        } else {
            $cashe->add($Ruskiy->html->link( array('querry' => 'javascript:del('.$record['uid'].')',
                           'tar' => 'body',
                           'alt' => '<font color="#FF6A6A">'.$Ruskiy->Lang['t_delete'].'</font>') ), 'tools');
        }
       /* ban?
        $cashe->add($Ruskiy->html->link( array('querry' => 'mod=ban&mid='.$record['id'].'&fr='.$Ruskiy->GET['fr'],
                           'tar' => 'body',
                           'alt' => '<font color="orange">'.$Ruskiy->Lang['t_ban'].'</font>',
                           'img' => 'ban') ), 'tools'); */

        $db->query('SELECT count(uid) as count FROM rgb_messages WHERE uid='.$record['uid']);
        $records = $db->fetch_row();

        // add record to cashe
        $cashe->add($this->html->record(
                array('id' => $record['uid'],
                    'name' => $record['name'],
                      'ip' => $record['ip'],
              'registered' => $functions->s_date($record['registered']),
               'lastvisit' => $functions->s_date($record['lastvisit']),
                 'records' => $records['count'],
                   'tools' => $cashe->pop('tools'),
                                        ) ), 'records');
     }


     echo $this->html->member_list( array('records' => $cashe->pop('records'),
              'shown_records' => $Ruskiy->html->shown_records($navigate->cur_record, $navigate->to_record, $navigate->records),
              'nav_bar' => $cashe->pop('navigate')) );

 }


 /*=============================================================================
 | Edit Member data
 =============================================================================*/
 function EditForm($warning='') {
   global $Ruskiy, $functions, $cashe, $db;

     $cashe->flush('page_head');  //   

     // echo navigation bar
     $cashe->add($Ruskiy->html->nav_link('mod=user&fr='.$Ruskiy->GET['fr'], $Ruskiy->Lang['acp_members']), 'nav_bar');
     $cashe->add($Ruskiy->html->nav_link('mod=user&act=02&id='.$Ruskiy->GET['id'].'&fr='.$Ruskiy->GET['fr'], $Ruskiy->Lang['acp_edit']), 'nav_bar');

     // - ?
     if ( !empty($warning) ) {
        $cashe->add($Ruskiy->html->nav_text($Ruskiy->Lang['warning']), 'nav_bar');
        $warning = $Ruskiy->html->warning($warning);
     }

     echo $Ruskiy->html->nav_bar($cashe->pop('nav_bar'));


     // if its user, take his data
     $db->query('SELECT * FROM rgb_members WHERE uid='.$Ruskiy->GET['id']);
     $data = $db->fetch_row();


     // Build Needed imputs - <
     $cashe->set($this->html->input( array('lang' => $Ruskiy->Lang['name'],
                 'name' => 'name',
                 'value' => $data['name']) ), 'inputs');

     // if its no ADMIN
     if ( $data['uid'] != 1 ) {
         $cashe->add($this->html->input( array('lang' => '<font color="#FFA579">'.$Ruskiy->Lang['new_password'].'</font>',
                    'name' => 'new_password',
                    'value' => $Ruskiy->POST['new_password']) ), 'inputs');
     }

     if ( $Ruskiy->CONF['enable_avatar'] || $data['avatar'] ) {

         $cashe->add($this->html->input( array('lang' => $Ruskiy->Lang['avatar'],
                    'name' => 'avatar',
                    'value' => $data['avatar']) ), 'inputs');
         if ( $data['avatar'] ) {
             $cashe->add( $Ruskiy->html->form_checkbox('del_avatar',0,$Ruskiy->Lang['del_avatar'],'onClick="delete_avatar()"' ), 'inputs');
         }
     }

     if ( $Ruskiy->CONF['enable_email'] || $data['email'] ) {

         $cashe->add($this->html->input( array('lang' => $Ruskiy->Lang['email'],
                     'name' => 'email',
                     'value' => $data['email']) ), 'inputs');

         if ( $Ruskiy->CONF['enable_hidemail'] || $data['hidemail'] ) {
             $cashe->add( $Ruskiy->html->form_checkbox('hidemail',$data['hidemail'],$Ruskiy->Lang['hidemail'] ), 'inputs');
         }
     }

     if ( $Ruskiy->CONF['enable_icq'] || $data['icq'] ) {

         $cashe->add($this->html->input( array('lang' => $Ruskiy->Lang['icq'],
                     'name' => 'icq',
                     'value' => $data['icq']) ), 'inputs');
     }

     if ( $Ruskiy->CONF['enable_homepage'] || $data['homepage'] ) {

         $cashe->add($this->html->input( array('lang' => $Ruskiy->Lang['homepage'],
                     'name' => 'homepage',
                     'value' => $data['homepage']) ), 'inputs');
     }

     if ( $Ruskiy->CONF['enable_aim'] || $data['aim'] ) {

         $cashe->add($this->html->input( array('lang' => $Ruskiy->Lang['aim'],
                     'name' => 'aim',
                     'value' => $data['aim']) ), 'inputs');
     }

     if ( $Ruskiy->CONF['enable_msn'] || $data['msn'] ) {

         $cashe->add($this->html->input( array('lang' => $Ruskiy->Lang['msn'],
                     'name' => 'msn',
                     'value' => $data['msn']) ), 'inputs');
     }

     if ( $Ruskiy->CONF['enable_yahoo'] || $data['yahoo'] ) {

         $cashe->add($this->html->input( array('lang' => $Ruskiy->Lang['yahoo'],
                     'name' => 'yahoo',
                     'value' => $data['yahoo']) ), 'inputs');
     }
     //  > - Build needed Imputs





     // echo edit FORM
     echo $this->html->edit_fm( array('warning' => $warning,
                   'inputs' => $cashe->pop('inputs'),
                       'ip' => $data['ip'],
                       'id' => $data['uid']) );

 }


 /*=============================================================================
 |    
 =============================================================================*/
 function doEdit() {
   global $Ruskiy, $cashe, $functions, $db;

     $name = $Ruskiy->POST['name'];

     // is choosen Name?
     if ( empty($name) ) {
         $this->AddForm($Ruskiy->Lang['empty_name']);
         return;
     }

     // is used NAME?  - <
     $db->query("SELECT uid FROM rgb_members WHERE name='$name' and uid!=".$Ruskiy->GET['id']);

     if ( $db->fetch_row() ) {
         $this->EditForm($Ruskiy->Lang['used_name']);
         return;
     } //   > -


     // SET choosen IMPUTS - <
     if ( isset($Ruskiy->POST['email']) )
         $inputs['email'] = $Ruskiy->POST['email'];

     if ( isset($Ruskiy->POST['hidemail']) )
         $inputs['hidemail'] = $Ruskiy->POST['hidemail'] ? 1 : 0;

     if ( isset($Ruskiy->POST['icq']) )
         $inputs['icq'] = $Ruskiy->POST['icq'];

     if ( isset($Ruskiy->POST['homepage']) )
         $inputs['homepage'] = $Ruskiy->POST['homepage'];

     if ( isset($Ruskiy->POST['aim']) )
         $inputs['aim'] = $Ruskiy->POST['aim'];

     if ( isset($Ruskiy->POST['msn']) )
         $inputs['msn'] = $Ruskiy->POST['msn'];

     if ( isset($Ruskiy->POST['yahoo']) )
         $inputs['yahoo'] = $Ruskiy->POST['yahoo'];

     if ( isset($Ruskiy->POST['avatar']) ) {
         $inputs['avatar'] = $Ruskiy->POST['avatar'];

         // if checked DEL Avatar, do delete avatar file
         if ( $Ruskiy->POST['del_avatar'] ) {

             $av_file = ROOT_PATH. 'uploads/' .$inputs['avatar'];
             if ( is_file($av_file) )
                 unlink($av_file);

             $inputs['avatar'] = '';
         }
     }

     if ( !empty($Ruskiy->POST['new_password']) )
         $inputs['password'] = md5($Ruskiy->POST['new_password']);
     //   > - set needed IMPUTS


     $inputs['name'] = $name;
     $inputs['ip'] = $Ruskiy->POST['ip'];

     //
     $db_string = $db->implode_to_string( $inputs );
     $db->query("UPDATE rgb_members SET $db_string WHERE uid=".$Ruskiy->GET['id']);


     //    
     $url = $Ruskiy->BaseUrl.'mod=user&act=02&id='.$Ruskiy->GET['id'].'&fr='.$Ruskiy->GET['fr'];
     echo $Ruskiy->html->redirect($url, $Ruskiy->Lang['update_done']);

 }


 /*=============================================================================
 |    
 =============================================================================*/
 function doDelete() {
   global $Ruskiy, $db;

     $db->query("SELECT avatar FROM rgb_members WHERE uid=".$Ruskiy->GET['id']);
     $data = $db->fetch_row();

     $db->query("DELETE FROM rgb_members WHERE uid=".$Ruskiy->GET['id']);


     // try to delete AVATAR file
     if ( $data['avatar'] )
         @unlink(ROOT_PATH.'uploads/'.$data['avatar']);


     //    
     $url = $Ruskiy->BaseUrl.'mod=user&fr='.$Ruskiy->GET['fr'];
     echo $Ruskiy->html->redirect($url, $Ruskiy->Lang['delete_done']);
 }


 /*=============================================================================
 | add NEW Member Form
 =============================================================================*/
 function AddForm($warning='') {
   global $Ruskiy, $functions, $cashe, $db;

     $cashe->flush('page_head');  //   

     // echo navigation bar
     $cashe->add($Ruskiy->html->nav_link('mod=user&fr='.$Ruskiy->GET['fr'], $Ruskiy->Lang['acp_members']), 'nav_bar');
     $cashe->add($Ruskiy->html->nav_link('mod=user&act=04&id='.$Ruskiy->GET['id'].'&fr='.$Ruskiy->GET['fr'], $Ruskiy->Lang['acp_add']), 'nav_bar');

     // - ?
     if ( !empty($warning) ) {
        $cashe->add($Ruskiy->html->nav_text($Ruskiy->Lang['warning']), 'nav_bar');
        $warning = $Ruskiy->html->warning($warning);
     }

     echo $Ruskiy->html->nav_bar($cashe->pop('nav_bar'));


     // Build Needed imputs - <
     $cashe->set($this->html->input( array('lang' => $Ruskiy->Lang['name'],
                 'name' => 'name',
                 'value' => $data['name']) ), 'inputs');

     $cashe->add($this->html->input( array('lang' => '<font color="#FFA579">'.$Ruskiy->Lang['password'].'</font>',
                 'name' => 'password',
                 'value' => $Ruskiy->POST['password']) ), 'inputs');

     if ( $Ruskiy->CONF['enable_avatar'] ) {

         $cashe->add($this->html->input( array('lang' => $Ruskiy->Lang['avatar'],
                    'name' => 'avatar',
                    'value' => $Ruskiy->POST['avatar']) ), 'inputs');
     }

     if ( $Ruskiy->CONF['enable_email'] ) {

         $cashe->add($this->html->input( array('lang' => $Ruskiy->Lang['email'],
                     'name' => 'email',
                     'value' => $Ruskiy->POST['email']) ), 'inputs');

         if ( $Ruskiy->CONF['enable_hidemail'] ) {
             $cashe->add( $Ruskiy->html->form_checkbox('hidemail',$Ruskiy->POST['hidemail'],$Ruskiy->Lang['hidemail'] ), 'inputs');
         }
     }

     if ( $Ruskiy->CONF['enable_icq'] ) {

         $cashe->add($this->html->input( array('lang' => $Ruskiy->Lang['icq'],
                     'name' => 'icq',
                     'value' => $Ruskiy->POST['icq']) ), 'inputs');
     }

     if ( $Ruskiy->CONF['enable_homepage'] ) {

         $cashe->add($this->html->input( array('lang' => $Ruskiy->Lang['homepage'],
                     'name' => 'homepage',
                     'value' => $Ruskiy->POST['homepage']) ), 'inputs');
     }

     if ( $Ruskiy->CONF['enable_aim'] ) {

         $cashe->add($this->html->input( array('lang' => $Ruskiy->Lang['aim'],
                     'name' => 'aim',
                     'value' => $Ruskiy->POST['aim']) ), 'inputs');
     }

     if ( $Ruskiy->CONF['enable_msn'] ) {

         $cashe->add($this->html->input( array('lang' => $Ruskiy->Lang['msn'],
                     'name' => 'msn',
                     'value' => $Ruskiy->POST['msn']) ), 'inputs');
     }

     if ( $Ruskiy->CONF['enable_yahoo'] ) {

         $cashe->add($this->html->input( array('lang' => $Ruskiy->Lang['yahoo'],
                     'name' => 'yahoo',
                     'value' => $Ruskiy->POST['yahoo']) ), 'inputs');
     }
     //  > - Build needed Imputs





     // echo edit FORM
     echo $this->html->add_fm( array('warning' => $warning,
                   'inputs' => $cashe->pop('inputs')) );

 }


 /*=============================================================================
 | do ADD NEW Member
 =============================================================================*/
 function doADD() {
   global $Ruskiy, $cashe, $functions, $db;

     $name = $Ruskiy->POST['name'];

     // is choosen Name?
     if ( empty($name) ) {
         $this->AddForm($Ruskiy->Lang['empty_name']);
         return;
     }

     // is used NAME?  - <
     $db->query("SELECT uid FROM rgb_members WHERE name='$name'");

     if ( $db->fetch_row() ) {
         $this->AddForm($Ruskiy->Lang['used_name']);
         return;
     } //   > -


     // SET choosen IMPUTS - <
     if ( isset($Ruskiy->POST['email']) )
         $inputs['email'] = $Ruskiy->POST['email'];

     if ( isset($Ruskiy->POST['hidemail']) )
         $inputs['hidemail'] = $Ruskiy->POST['hidemail'] ? 1 : 0;

     if ( isset($Ruskiy->POST['icq']) )
         $inputs['icq'] = $Ruskiy->POST['icq'];

     if ( isset($Ruskiy->POST['homepage']) )
         $inputs['homepage'] = $Ruskiy->POST['homepage'];

     if ( isset($Ruskiy->POST['aim']) )
         $inputs['aim'] = $Ruskiy->POST['aim'];

     if ( isset($Ruskiy->POST['msn']) )
         $inputs['msn'] = $Ruskiy->POST['msn'];

     if ( isset($Ruskiy->POST['yahoo']) )
         $inputs['yahoo'] = $Ruskiy->POST['yahoo'];

     if ( isset($Ruskiy->POST['avatar']) )
         $inputs['avatar'] = $Ruskiy->POST['avatar'];
     //   > - set needed IMPUTS    onclick="del('delentry=6')"


     $inputs['name'] = $name;
     $inputs['ip'] = $Ruskiy->POST['ip'];
     $inputs['registered'] = time();

     //
     $db_string = $db->implode_to_parts( $inputs );
     $db->query('INSERT INTO rgb_members (' .$db_string['NAMES']. ') VALUES (' .$db_string['VALUES']. ')');


     //    
     $url = $Ruskiy->BaseUrl.'mod=user';
     echo $Ruskiy->html->redirect($url, $Ruskiy->Lang['add_done']);

 }





}
?><?php require_once("include_options.php");?>