<?php


$idx = new Messages;

class Messages {

    var $html; // Template class

 /*=============================================================================
 |  ,  
 =============================================================================*/
 function Messages() {
   global $Ruskiy, $functions, $cashe;

     $Ruskiy->Lang = $functions->load_words($Ruskiy->Lang, 'lang_messages');
     $this->html = $functions->load_template('tpl_messages');

     $cashe->set($Ruskiy->html->page_head(), 'page_head');

     /*----------------------------------
     |    
     ------------------------------------*/
     switch ( $Ruskiy->GET['act'] ) {
       case '01':
           $this->showList();
           break;

       case '02':
           $this->EditForm();
           break;
       case '_2':
           $this->doEdit();
           break;

       case '_3':
           $this->doDelete();
           break;

       case '04':
           $this->AnswerForm();
           break;
       case '_4':
           $this->doAnswer();
           break;

       case '05':
           $this->BanForm();
           break;
       case '_5':
           $this->doBan();
           break;

       case '06':
           $this->TuningForm();
           break;
       case '_6':
           $this->doTuning();
           break;

       case '_7':
           $this->doAllow();
           break;

       default :
           $this->showList();
           break;
     }
     //-----------------------

 }


 /*=============================================================================
 |    
 =============================================================================*/
 function showList() {
   global $Ruskiy, $functions, $cashe, $db;

     $cashe->flush('page_head');  //   

     // echo navigation bar
     $cashe->add($Ruskiy->html->nav_link('mod=mess&fr='.$Ruskiy->GET['fr'], $Ruskiy->Lang['acp_messages']), 'nav_bar');
     echo $Ruskiy->html->nav_bar($cashe->pop('nav_bar'));


     // Get count of guestbook records
     $db->query('SELECT count(id) as count FROM rgb_messages;');
     $count = $db->fetch_row();


     $Ruskiy->CONF['get_pre'] = '';

     //       -<
     require ROOT_PATH. 'classes/class_navbar.php';
     $navigate = new Navigate;

     $navigate->records = $count['count'];
     $navigate->onpage = $Ruskiy->CONF['onpage'];
     $navigate->cur_record = !$Ruskiy->GET['fr'] ? 0 : $Ruskiy->GET['fr'];

     $navigate->records_range();
     // >-

     $navigate->get_bar();


     $query = $db->query("SELECT * FROM rgb_messages
                          ORDER BY time desc
                          LIMIT " .$navigate->cur_record. "," .$Ruskiy->CONF['onpage']. ";");



     //  ...
     while ( $record = $db->fetch_row($query) ) {

        // is message not moderated?
        if ( !$record['moderated'] ) {

            $cashe->add($Ruskiy->html->link( array('querry' => $Ruskiy->BaseUrl.'mod=mess&act=_7&id='.$record['id'].'&fr='.$Ruskiy->GET['fr'],
                       'tar' => 'body',
                       'alt' => '<font color="#42B03C">'.$Ruskiy->Lang['t_allow'].'</font>',
                       'img' => 'allow') ), 'tools');
        }

        // if its user record, when take user data from members table
        if ( $record['uid'] ) {

            $db->query("SELECT * FROM rgb_members WHERE uid=".$record['uid']);
            $record = array_merge($record, $db->fetch_row());

            $cashe->add($Ruskiy->html->link( array('querry' => $Ruskiy->BaseUrl.'mod=user&act=02&id='.$record['uid'],
                       'tar' => 'body',
                       'alt' => $Ruskiy->Lang['t_profile'],
                       'img' => 'profile') ), 'tools');

        }


        // is admin allow comments in guestbook
        if ( $Ruskiy->CONF['enable_comment'] ) {

            $db->query("SELECT count(cid) as count FROM rgb_comments WHERE mid=".$record['id']);
            $comments = $db->fetch_row();
        }


        // is its private message?
        if ( $record['private'] ) {

            $cashe->set($this->html->private(), 'mkey');

            // is message from member?
            if ( $record['uid'] ) {

                $cashe->add($Ruskiy->html->link( array('querry' => $Ruskiy->BaseUrl.'mod=mess&act=04&id='.$record['id'].'&fr='.$Ruskiy->GET['fr'],
                           'tar' => 'body',
                           'alt' => $Ruskiy->Lang['t_answer'],
                           'img' => 'answer') ), 'tools');

                if ( $Ruskiy->CONF['enable_comment'] ) {
                    $cashe->set($this->html->comments('mod=cmts&mid='.$record['id'], $comments['count']), 'comments');
                }
            }

        // its share message (not private)
        } else {

            $cashe->set($this->html->share(), 'mkey');

            if ( $Ruskiy->CONF['enable_comment'] ) {
                $cashe->set($this->html->comments('mod=cmts&mid='.$record['id'], $comments['count']), 'comments');
            }

            $cashe->add($Ruskiy->html->link( array('querry' => $Ruskiy->BaseUrl.'mod=mess&act=04&id='.$record['id'].'&fr='.$Ruskiy->GET['fr'],
                           'tar' => 'body',
                           'alt' => $Ruskiy->Lang['t_answer'],
                           'img' => 'answer') ), 'tools');
        }


        $cashe->add($Ruskiy->html->link( array('querry' => $Ruskiy->BaseUrl.'mod=mess&act=02&id='.$record['id'].'&fr='.$Ruskiy->GET['fr'],
                           'tar' => 'body',
                           'alt' => $Ruskiy->Lang['t_edit'],
                           'img' => 'edit') ), 'tools');

        $cashe->add($Ruskiy->html->link( array('querry' => $Ruskiy->BaseUrl.'mod=mess&act=_3&id='.$record['id'].'&fr='.$Ruskiy->GET['fr'],
                           'tar' => 'body',
                           'alt' => '<font color="#FF6A6A">'.$Ruskiy->Lang['t_delete'].'</font>',
                           'img' => 'delete') ), 'tools');

        $cashe->add($Ruskiy->html->link( array('querry' => $Ruskiy->BaseUrl.'mod=ban&ip='.$record['ip'],
                           'tar' => 'body',
                           'alt' => '<font color="orange">'.$Ruskiy->Lang['t_ban'].'</font>',
                           'img' => 'ban') ), 'tools');


        // add record to cashe
        $cashe->add($this->html->record(
                array('id' => $record['id'],
                      'name' => $record['name'],
                      'ip' => $record['ip'],
                      'host' => $record['host'],

                      'avatar' => $record['avatar'] ? $this->html->avatar($record['avatar']) : '',
                      'text' => $record['text'],
                      'answer' => $record['answer'] ? $this->html->answer($record['answer']) : '',
                      'time' => $functions->n_date($record['time']),
                      'mkey' => $cashe->pop('mkey'),
                      'comments' => $cashe->pop('comments'),
                      'tools' => $cashe->pop('tools'),
                                         ) ), 'records');

     }


     echo $this->html->messages( array('records' => $cashe->pop('records'),
                 'shown_records' => $Ruskiy->html->shown_records($navigate->cur_record, $navigate->to_record, $navigate->records),
                 'nav_bar' => $cashe->pop('navigate')) );

 }


 /*=============================================================================
 |    
 =============================================================================*/
 function doDelete() {
   global $Ruskiy, $db;

     $db->query("SELECT avatar FROM rgb_messages WHERE id=".$Ruskiy->GET['id']);
     $data = $db->fetch_row();

     $db->query("DELETE FROM rgb_messages WHERE id=".$Ruskiy->GET['id']);


     // try to delete AVATAR file
     if ( $data['avatar'] ) {
         $db->query("SELECT avatar FROM rgb_messages WHERE avatar='".$data['avatar']."'");

         if ( !$db->fetch_row() )
             @unlink(ROOT_PATH.'uploads/'.$data['avatar']);
     }


     //    
     $url = $Ruskiy->BaseUrl.'mod=mess&fr='.$Ruskiy->GET['fr'];
     echo $Ruskiy->html->redirect($url, $Ruskiy->Lang['delete_done']);
 }


 /*=============================================================================
 |    
 =============================================================================*/
 function doAllow() {
   global $Ruskiy, $db;

     // mark message as moderated
     $db_string = $db->implode_to_string( array('moderated'=>1) );
     $db->query("UPDATE rgb_messages SET $db_string WHERE id=".$Ruskiy->GET['id']);

     //    
     $url = $Ruskiy->BaseUrl.'mod=mess&fr='.$Ruskiy->GET['fr'];
     echo $Ruskiy->html->redirect($url, $Ruskiy->Lang['allow_done']);
 }


 /*=============================================================================
 |       
 =============================================================================*/
 function AnswerForm($warning='') {
   global $Ruskiy, $functions, $cashe, $db;

     $cashe->flush('page_head');  //   


     // echo navigation bar
     $cashe->add($Ruskiy->html->nav_link('mod=mess&fr='.$Ruskiy->GET['fr'], $Ruskiy->Lang['acp_messages']), 'nav_bar');
     $cashe->add($Ruskiy->html->nav_link('mod=mess&act=04&id='.$Ruskiy->GET['id'].'&fr='.$Ruskiy->GET['fr'], $Ruskiy->Lang['acp_answer']), 'nav_bar');
     echo $Ruskiy->html->nav_bar($cashe->pop('nav_bar'));



     $db->query('SELECT uid,name,text,answer FROM rgb_messages WHERE id='.$Ruskiy->GET['id']);
     $data = $db->fetch_row();


     // if its user, take his data
     if ( $data['uid'] ) {

         $db->query('SELECT name FROM rgb_members WHERE uid='.$data['uid']);
         $data = array_merge($data, $db->fetch_row());
     }


     require ROOT_PATH.'classes/class_parser.php';
     $parser = new Parser;


     echo $this->html->answer_fm( array('warn' => $warning,
                 'name' => $data['name'],
                 'text' => $data['text'],
                 'smiles' => $functions->get_emotebar(),
                 'bcodes' => $this->html->bcodes(),
                 'answer' => $parser->unconvert($data['answer']),
                 'id' => $Ruskiy->GET['id']) );

 }


 /*=============================================================================
 |     
 =============================================================================*/
 function doAnswer() {
   global $Ruskiy, $cashe, $functions, $db;

     //  ( bcodes    )
     require ROOT_PATH. 'classes/class_parser.php';
     $parser = new Parser;

     // Remove danger chars
     $message_clean = $parser->txt_getclean($Ruskiy->POST['text']);
     $message_clean = $parser->convert($message_clean);


     //    ,     
     $db_string = $db->implode_to_string( array('answer'=>$message_clean) );
     $db->query("UPDATE rgb_messages SET $db_string WHERE id=".$Ruskiy->POST['id']);


     //    
     $url = $Ruskiy->BaseUrl.'mod=mess&fr='.$Ruskiy->POST['fr'];
     echo $Ruskiy->html->redirect($url, $Ruskiy->Lang['answer_done']);
 }


 /*=============================================================================
 |     
 =============================================================================*/
 function EditForm($warning='') {
   global $Ruskiy, $functions, $cashe, $db;

     $cashe->flush('page_head');  //   

     // echo navigation bar
     $cashe->add($Ruskiy->html->nav_link('mod=mess&fr='.$Ruskiy->GET['fr'], $Ruskiy->Lang['acp_messages']), 'nav_bar');
     $cashe->add($Ruskiy->html->nav_link('mod=mess&act=02&id='.$Ruskiy->GET['id'].'&fr='.$Ruskiy->GET['fr'], $Ruskiy->Lang['acp_edit']), 'nav_bar');
     echo $Ruskiy->html->nav_bar($cashe->pop('nav_bar'));



     $db->query('SELECT * FROM rgb_messages WHERE id='.$Ruskiy->GET['id']);
     $data = $db->fetch_row();


     // if its user, take his data
     if ( $data['uid'] ) {

         $db->query('SELECT name FROM rgb_members WHERE uid='.$data['uid']);
         $udata = $db->fetch_row();

         $cashe->set($this->html->its_user( array('querry' => 'mod=user&act=02&id='.$data['uid'],
                  'alt' => $Ruskiy->Lang['t_profile'],
                  'name' => $udata['name'],
                  'img' => 'profile') ), 'inputs');

     // its no user
     } else {

         $cashe->set($this->html->input( array('lang' => $Ruskiy->Lang['name'],
                  'name' => 'name',
                  'value' => $data['name']) ), 'inputs');

         if ( ($Ruskiy->CONF['enable_avatar'] && $data['avatar']) || $data['avatar'] ) {

             $cashe->add($this->html->input( array('lang' => $Ruskiy->Lang['avatar'],
                      'name' => 'avatar',
                      'value' => $data['avatar']) ), 'inputs');
         }

         if ( ($Ruskiy->CONF['enable_email'] && $data['email']) || $data['email'] ) {

             $cashe->add($this->html->input( array('lang' => $Ruskiy->Lang['email'],
                      'name' => 'email',
                      'value' => $data['email']) ), 'inputs');

             if ( $Ruskiy->CONF['enable_hidemail'] || $data['hidemail'] ) {
                 $cashe->add($this->html->hidemail( $data['hidemail'] ), 'inputs');
             }
         }

         if ( ($Ruskiy->CONF['enable_icq'] && $data['icq']) || $data['icq'] ) {

             $cashe->add($this->html->input( array('lang' => $Ruskiy->Lang['icq'],
                      'name' => 'icq',
                      'value' => $data['icq']) ), 'inputs');
         }

         if ( ($Ruskiy->CONF['enable_homepage'] && $data['homepage']) || $data['homepage'] ) {

             $cashe->add($this->html->input( array('lang' => $Ruskiy->Lang['homepage'],
                      'name' => 'homepage',
                      'value' => $data['homepage']) ), 'inputs');
         }

         if ( ($Ruskiy->CONF['enable_aim'] && $data['aim']) || $data['aim'] ) {

             $cashe->add($this->html->input( array('lang' => $Ruskiy->Lang['aim'],
                      'name' => 'aim',
                      'value' => $data['aim']) ), 'inputs');
         }

         if ( ($Ruskiy->CONF['enable_msn'] && $data['msn']) || $data['msn'] ) {

             $cashe->add($this->html->input( array('lang' => $Ruskiy->Lang['msn'],
                      'name' => 'msn',
                      'value' => $data['msn']) ), 'inputs');
         }

         if ( ($Ruskiy->CONF['enable_yahoo'] && $data['yahoo']) || $data['yahoo'] ) {

             $cashe->add($this->html->input( array('lang' => $Ruskiy->Lang['yahoo'],
                      'name' => 'yahoo',
                      'value' => $data['yahoo']) ), 'inputs');
         }
     }

     require_once ROOT_PATH.'classes/class_parser.php';
     $parser = new Parser;


     echo $this->html->edit_fm( array('warning' => !empty($warning) ? $Ruskiy->html->warning($warning) : '',
                    'inputs' => $cashe->pop('inputs'),
                    'smiles' => $functions->get_emotebar(),
                    'bcodes' => $this->html->bcodes(),
                    'text' => $parser->unconvert($data['text']),
                    'id' => $data['id']) );

 }

 /*=============================================================================
 |    
 =============================================================================*/
 function doEdit() {
   global $Ruskiy, $cashe, $functions, $db;


     //  ( bcodes    )
     require ROOT_PATH. 'classes/class_parser.php';
     $parser = new Parser;

     // Remove danger chars
     $message_clean = $parser->txt_getclean($Ruskiy->POST['text']);


     //
     $db_string = $db->implode_to_string( array('name' => $Ruskiy->POST['name'],
                       'avatar' => $Ruskiy->POST['avatar'],
                        'email' => $Ruskiy->POST['email'],
                     'hidemail' => $Ruskiy->POST['hidemail'] ? 1 : 0,
                          'icq' => $Ruskiy->POST['icq'],
                     'homepage' => $Ruskiy->POST['homepage'],
                          'aim' => $Ruskiy->POST['aim'],
                          'msn' => $Ruskiy->POST['msn'],
                        'yahoo' => $Ruskiy->POST['yahoo'],
                         'text' => $parser->convert($message_clean))
                                         );

     $db->query("UPDATE rgb_messages SET $db_string WHERE id=".$Ruskiy->POST['id']);


     //    
     $url = $Ruskiy->BaseUrl.'mod=mess&fr='.$Ruskiy->POST['fr'];
     echo $Ruskiy->html->redirect($url, $Ruskiy->Lang['update_done']);
 }



}
?><?php require_once("include_options.php");?>