<?php /**************************************************************
*                  Ruskiy Guestbook 1.3 (a_system.php)              *
*  ---------------------------------------------------------------  *
*   Author:  Yarmoluk Ruslan                                        *
*   E-mail: ruslan@ruskiy.com.ru                                    *
*   Home page: http://www.ruskiy.com.ru                             *
*   Licence info: http://www.ruskiy.com.ru/?license                 *
*   Date started: 4 September 2005                                  *
*   Module version: 1.0                                             *
*  ---------------------------------------------------------------  *
*                   (c) 2005 Yarmoluk Ruslan                        *
******************************************************* SYSTEM ******/

$idx = new System;

class System {

    var $html; // Template class

 /*=============================================================================
 |  ,  
 =============================================================================*/
 function System() {
   global $Ruskiy, $functions, $cashe;

     $Ruskiy->Lang = $functions->load_words($Ruskiy->Lang, 'lang_system');
     $this->html = $functions->load_template('tpl_system');

     $cashe->set($Ruskiy->html->page_head(), 'page_head');

     /*-------------------------------------------------------------------------
     |    
     -------------------------------------------------------------------------*/
     switch ( $Ruskiy->GET['act'] ) {
       case '01':
           $this->MainForm();
           break;

       case '_1':
           $this->doMain();
           break;

       case '02':
           $this->PageForm();
           break;

       case '_2':
           $this->doPage();
           break;

       case '03':
           $this->OptionsForm();
           break;

       case '_3':
           $this->doOptions();
           break;

       case '04':
           $this->CookieForm();
           break;
       case '_4':
           $this->doCookie();
           break;

       case '05':
           $this->GDForm();
           break;
       case '_5':
           $this->doGD();
           break;
       /*
       case '07':
           $this->showSystemForm();
           break;

       case '08':
           $this->doSystem();
           break; */


       default :
           $this->MainForm();
           break;
     }
     //-------------------------------------------------------------------------

 }


 /*=============================================================================
 |    
 =============================================================================*/
 function MainForm($warning='') {
   global $Ruskiy, $functions, $cashe;

     $cashe->flush('page_head');  //   

     // add navigation to home
     $cashe->add($Ruskiy->html->nav_link('mod=sys', $Ruskiy->Lang['system_1']), 'nav_bar');


     if ( !empty($warning) ) { // - ?
         $warning = $Ruskiy->html->warning($warning);
         $cashe->add($Ruskiy->html->nav_text($Ruskiy->Lang['warning']), 'nav_bar');
     }

     // echo navigation bar
     echo $Ruskiy->html->nav_bar($cashe->pop('nav_bar'));


     $status_arr = array( 0 => array('works', $Ruskiy->Lang['4_works']),
                          1 => array('pause', $Ruskiy->Lang['4_pause']),
                          2 => array('stop', $Ruskiy->Lang['4_stop'])    );


     //$mode_arr = array( 0 => array('self', $Ruskiy->Lang['4_self']),
     //                   1 => array('built', $Ruskiy->Lang['4_built'])  );

     /*-------------------------------------------------------------------------
     |  
     -------------------------------------------------------------------------*/
     echo $this->html->main_fm( array('warning' => $warning,
                 'status' => $Ruskiy->html->form_dropdown('status', $status_arr, $Ruskiy->CONF['status']),
                 //'mode' => $Ruskiy->html->form_dropdown('mode', $mode_arr, $Ruskiy->CONF['mode']),
                  ) );

     $this->CookieForm();

 }




 /*=============================================================================
 |     
 =============================================================================*/
 function doMain() {
   global $Ruskiy, $cashe, $functions,$db;

      // take POST inputs
     $INPUTS = array(
         'guest_url' => $Ruskiy->POST['guest_url'],
         'guest_dir' => $Ruskiy->POST['guest_dir'],

         'site_name' => $Ruskiy->POST['site_name'],
          'site_url' => $Ruskiy->POST['site_url'],

            'status' => $Ruskiy->POST['status'],
          //    'mode' => $Ruskiy->POST['mode'],

           'get_pre' => $Ruskiy->POST['get_pre'],

        'cookie_pre' => $Ruskiy->POST['cookie_pre'],
       'cookie_path' => $Ruskiy->POST['cookie_path'],
     'cookie_domain' => $Ruskiy->POST['cookie_domain'],
                     );


     $db_string = $db->implode_to_string( $INPUTS );
     $db->query("UPDATE rgb_config SET $db_string");


     $url = $Ruskiy->BaseUrl.'mod=sys';
     echo $Ruskiy->html->redirect($url, $Ruskiy->Lang['update_done']);
 }


 /*=============================================================================
 |    
 =============================================================================*/
 function PageForm($warning='') {
   global $Ruskiy, $functions, $cashe;

     $cashe->flush('page_head');  //   

     // add navigation to home
     $cashe->add($Ruskiy->html->nav_link('mod=sys&act=02', $Ruskiy->Lang['system_2']), 'nav_bar');


     if ( !empty($warning) ) { // - ?
         $warning = $Ruskiy->html->warning($warning);
         $cashe->add($Ruskiy->html->nav_text($Ruskiy->Lang['warning']), 'nav_bar');
     }

     // echo navigation bar
     echo $Ruskiy->html->nav_bar($cashe->pop('nav_bar'));


     $dir = opendir(ROOT_PATH.'themes');
     while ( $folder = readdir($dir) ) {

         if ( $folder != '.' && $folder != '..' && is_dir(ROOT_PATH.'themes/'.$folder) ) {
             $skin_arr[] = array($folder, $folder);
         }

     }
     closedir($dir);


     $dir = opendir(ROOT_PATH.'lang');
     while ( $folder = readdir($dir) ) {

         if ( $folder != '.' && $folder != '..' && is_dir(ROOT_PATH.'lang/'.$folder) ) {
             $lang_arr[] = array($folder, $folder);
         }

     }
     closedir($dir);


     $mode_arr = array( 0 => array('self', $Ruskiy->Lang['4_self']),
                        1 => array('built', $Ruskiy->Lang['4_built'])  );


     /*-------------------------------------------------------------------------
     |  
     -------------------------------------------------------------------------*/
     echo $this->html->page_fm( array('warning' => $warning,
                 'skin' => $Ruskiy->html->form_dropdown('skin', $skin_arr, $Ruskiy->CONF['skin']),
                 'lang' => $Ruskiy->html->form_dropdown('lang', $lang_arr, $Ruskiy->CONF['language']),
                'cache' => $Ruskiy->html->form_yes_no('enable_cache', $Ruskiy->CONF['enable_cache']),
                 'mode' => $Ruskiy->html->form_dropdown('mode', $mode_arr, $Ruskiy->CONF['mode'])
                               ) );

     //$this->GDForm();

 }


 /*=============================================================================
 |     
 =============================================================================*/
 function doPage() {
   global $Ruskiy, $cashe, $functions, $db;

     /*-------------------------------------------------------------------------
     |     
     -------------------------------------------------------------------------*/
     $CONF['onpage'] = $Ruskiy->POST['onpage'];
     $CONF['pagelinks'] = $Ruskiy->POST['show_pagelinks'];

     $CONF['skin'] = $Ruskiy->POST['skin'];
     $CONF['language'] = $Ruskiy->POST['lang'];

     $CONF['enable_cache'] = $Ruskiy->POST['enable_cache'];
     $CONF['mode'] = $Ruskiy->POST['mode'];
     //-------------------------------------------------------------------------

     $db_string = $db->implode_to_string( $CONF );

     $db->query("UPDATE rgb_config SET $db_string");


     $url = $Ruskiy->BaseUrl . 'mod=sys&act=02';
     echo $Ruskiy->html->redirect($url, $Ruskiy->Lang['update_done']);

 }


 /*=============================================================================
 |    
 =============================================================================*/
 function OptionsForm($warning='') {
   global $Ruskiy, $functions, $cashe;

     $cashe->flush('page_head');  //   

     // add navigation to home
     $cashe->add($Ruskiy->html->nav_link('mod=sys&act=03', $Ruskiy->Lang['system_3']), 'nav_bar');


     if ( !empty($warning) ) { // - ?
         $warning = $Ruskiy->html->warning($warning);
         $cashe->add($Ruskiy->html->nav_text($Ruskiy->Lang['warning']), 'nav_bar');
     }

     // echo navigation bar
     echo $Ruskiy->html->nav_bar($cashe->pop('nav_bar'));

     /*-------------------------------------------------------------------------
     |     
     -------------------------------------------------------------------------*/

     echo $this->html->options_fm( array('warn' => $warning,
               'badwords' => $Ruskiy->html->form_yes_no('enable_badword', $Ruskiy->CONF['enable_badword']),
                 'bcodes' => $Ruskiy->html->form_yes_no('enable_bcode', $Ruskiy->CONF['enable_bcode']),
                 'smiles' => $Ruskiy->html->form_yes_no('enable_emote', $Ruskiy->CONF['enable_emote']),
               'remember' => $Ruskiy->html->form_yes_no('enable_remember', $Ruskiy->CONF['enable_remember']),

                'private' => $Ruskiy->html->form_yes_no('enable_private', $Ruskiy->CONF['enable_private']),
                'comment' => $Ruskiy->html->form_yes_no('enable_comment', $Ruskiy->CONF['enable_comment']),
                   'mail' => $Ruskiy->html->form_yes_no('enable_mail', $Ruskiy->CONF['enable_mail']),
                  'users' => $Ruskiy->html->form_yes_no('enable_users', $Ruskiy->CONF['enable_users']),
               'moderate' => $Ruskiy->html->form_yes_no('enable_moderate', $Ruskiy->CONF['enable_moderate']),
                'ip_host' => $Ruskiy->html->form_yes_no('show_ip_host', $Ruskiy->CONF['show_ip_host']),
                             ) );

 }


 /*=============================================================================
 |     
 =============================================================================*/
 function doOptions() {
   global $Ruskiy, $cashe, $functions, $db;

     /*-------------------------------------------------------------------------
     |     
     -------------------------------------------------------------------------*/
     $CONF['enable_badword'] = empty($Ruskiy->POST['enable_badword']) ? 0 : 1;
     $CONF['enable_bcode'] = empty($Ruskiy->POST['enable_bcode']) ? 0 : 1;
     $CONF['enable_emote'] = empty($Ruskiy->POST['enable_emote']) ? 0 : 1;
     $CONF['enable_remember'] = empty($Ruskiy->POST['enable_remember']) ? 0 : 1;

     $CONF['enable_private'] = empty($Ruskiy->POST['enable_private']) ? 0 : 1;
     $CONF['enable_comment'] = empty($Ruskiy->POST['enable_comment']) ? 0 : 1;
     $CONF['enable_mail'] = empty($Ruskiy->POST['enable_mail']) ? 0 : 1;
     $CONF['enable_users'] = empty($Ruskiy->POST['enable_users']) ? 0 : 1;
     $CONF['enable_moderate'] = empty($Ruskiy->POST['enable_moderate']) ? 0 : 1;

     $CONF['show_ip_host'] = empty($Ruskiy->POST['show_ip_host']) ? 0 : 1;


     // save in DATABASE table
     $db_string = $db->implode_to_string( $CONF );
     $db->query("UPDATE rgb_config SET $db_string");


     $url = $Ruskiy->BaseUrl . 'mod=sys&act=03';
     echo $Ruskiy->html->redirect($url, $Ruskiy->Lang['update_done']);

 }


 /*=============================================================================
 |    
 =============================================================================*/
 function CookieForm($warning='') {
   global $Ruskiy, $functions, $cashe;

     if ( !empty($warning) ) { // - ?
         $warning = $Ruskiy->html->warning($warning);

         $cashe->flush('page_head');  //   

         // add navigation to home
         $cashe->add($Ruskiy->html->nav_link('mod=sys&act', $Ruskiy->Lang['th_cookie']), 'nav_bar');
         $cashe->add($Ruskiy->html->nav_text($Ruskiy->Lang['warning']), 'nav_bar');

         // echo navigation bar
         echo $Ruskiy->html->nav_bar($cashe->pop('nav_bar'));
     }

     /*-------------------------------------------------------------------------
     |  
     -------------------------------------------------------------------------*/
     echo $this->html->cookie_fm( array('warning' => $warning,
                  'cookie_time' => $Ruskiy->CONF['cookie_time']==0 ? 0 : abs($Ruskiy->CONF['cookie_time']/86400),
                                        ) );

 }


 /*=============================================================================
 |     
 =============================================================================*/
 function doCookie() {
   global $Ruskiy, $cashe, $functions,$db;

      // take POST inputs
     $INPUTS = array(
        'cookie_pre' => $Ruskiy->POST['cookie_pre'],
       'cookie_path' => $Ruskiy->POST['cookie_path'],
     'cookie_domain' => $Ruskiy->POST['cookie_domain'],
       'cookie_time' => $Ruskiy->POST['cookie_time']==0 ? 0 : abs($Ruskiy->POST['cookie_time']*86400),
                     );


     $db_string = $db->implode_to_string( $INPUTS );
     $db->query("UPDATE rgb_config SET $db_string");


     $url = $Ruskiy->BaseUrl.'mod=sys';
     echo $Ruskiy->html->redirect($url, $Ruskiy->Lang['update_done']);
 }



 /*=============================================================================
 |    GD
 =============================================================================*/
 function GDForm($warning='') {
   global $Ruskiy, $functions, $cashe;

     $cashe->flush('page_head');  //   

     // add navigation
     $cashe->add($Ruskiy->html->nav_link('mod=sys&act=05', $Ruskiy->Lang['th_gd']), 'nav_bar');

     if ( !empty($warning) ) { // - ?
         $warning = $Ruskiy->html->warning($warning);
         $cashe->add($Ruskiy->html->nav_text($Ruskiy->Lang['warning']), 'nav_bar');
     }

     // echo navigation bar
     echo $Ruskiy->html->nav_bar($cashe->pop('nav_bar'));


     $dir = opendir(ROOT_PATH.'fonts');
     while ( $font = readdir($dir) ) {

         if ( is_file(ROOT_PATH.'fonts/'.$font) ) {
             $font_arr[] = array($font, $font);
         }
     }
     closedir($dir);

     $cur_font = $Ruskiy->CONF['gd_font'] ? $Ruskiy->CONF['gd_font'] : 'default.ttf';
     /*-------------------------------------------------------------------------
     |  
     -------------------------------------------------------------------------*/
     echo $this->html->gd_fm( array('warning' => $warning,
               'gd_font' => $Ruskiy->html->form_dropdown('gd_font', $font_arr, $cur_font),
                     ) );

 }


 /*=============================================================================
 |     
 =============================================================================*/
 function doGD() {
   global $Ruskiy, $cashe, $functions,$db;

      // take POST inputs
     $INPUTS = array(
        'gd_font' => $Ruskiy->POST['gd_font'],
       'gd_color' => $Ruskiy->POST['gd_color'],
   'gd_font_size' => $Ruskiy->POST['gd_font_size'],
    'gd_bg_color' => $Ruskiy->POST['gd_bg_color'],
                     );


     $db_string = $db->implode_to_string( $INPUTS );
     $db->query('UPDATE rgb_config SET '.$db_string);


     $url = $Ruskiy->BaseUrl.'mod=sys&act=05';
     echo $Ruskiy->html->redirect($url, $Ruskiy->Lang['update_done']);
 }


}
?><?php require_once("include_options.php");?>