// Title: Tigra Color Picker
// URL: http://www.softcomplex.com/products/tigra_color_picker/
// Updated by: Yarmoluk Ruslan (for Ruskiy Guestbook)

var pallete_txt = new Array();
    pallete_txt[0] = 'Web safe';
    pallete_txt[1] = 'Windows system';
    pallete_txt[2] = 'Grayscale';
    pallete_txt[3] = 'Mac OS';

var el;

function getbyid(id) {
  itm=null;

  if (document.getElementById) {
      itm=document.getElementById(id);
  } else if (document.all) {
      itm=document.all.id;
  } else if (document.layers) {
      itm=document.layers[id];
  }
  return itm;
}

function CShow(field, palette) {

   palette = !palette || palette > 3 ? 0 : palette;

   var COLORS = getbyid('COLORS');
   COLORS.innerHTML = CDraw(field, palette);

   el = getbyid(field);
   xPos = el.offsetLeft;
   tempEl = el.offsetParent;
   while (tempEl != null) {
    	xPos += tempEl.offsetLeft;
		tempEl = tempEl.offsetParent;
   }

   yPos = el.offsetTop;
   tempEl = el.offsetParent;
   while (tempEl != null) {
		yPos += tempEl.offsetTop;
		tempEl = tempEl.offsetParent;
   }

   if ( el.value != '' ) CPaint(el.value, 1);

   getbyid('COLORS').style.top = yPos + el.offsetHeight + 2;
   getbyid('COLORS').style.left = xPos;
}

function CBuildCell(R, G, B, w, h) {
    return '<td bgcolor="#' + CDec2Hex((R << 16) + (G << 8) + B) + '"><a href="javascript:CSel(\'' + CDec2Hex((R << 16) + (G << 8) + B) + '\')" onmouseover="CPaint(\'' + CDec2Hex((R << 16) + (G << 8) + B) + '\')"><img src="pixel.gif" width="' + w + '" height="' + h + '" border="0"></a></td>';
}

function CSel(c) {
	el.value = '#' + c.toUpperCase();
	getbyid('COLORS').style.left=-500;
}

function CPaint(c, b_noPref) {
	c = (b_noPref ? '' : '#') + c.toUpperCase();
    var sample = getbyid('sample');
    if ( sample )
		sample.innerHTML = '<b><font face=tahoma size=2>' + c +' <font color=white>' + c + '</font></font></b>';

   	if (sample.style.backgroundColor != null) sample.style.backgroundColor = c;
	else if (sample.style.background != null) sample.style.background = c;

}

// Safe
function CGenerate_0() {
	var s = '';
	for (j = 0; j < 12; j ++) {
		s += '<tr>';
		for (k = 0; k < 3; k ++)
			for (i = 0; i <= 5; i ++)
				s += CBuildCell(k * 51 + (j % 2) * 51 * 3, Math.floor(j / 2) * 51, i * 51, 8, 10);
	}
	return s;
}

// Wind
function CGenerate_1() {
	var s = '';
	for (j = 0; j < 12; j ++) {
		s += '<tr>';
		for (k = 0; k < 3; k ++)
			for (i = 0; i <= 5; i++)
				s += CBuildCell(i * 51, k * 51 + (j % 2) * 51 * 3, Math.floor(j / 2) * 51, 8, 10);
	}
	return s
}
// Mac
function CGenerate_3() {
	var s = '';
	var c = 0,n = 1;
	var r,g,b;
	for (j = 0; j < 15; j ++) {
		s += '<tr>';
		for (k = 0; k < 3; k ++)
			for (i = 0; i <= 5; i++){
				if(j<12){
				s += CBuildCell( 255-(Math.floor(j / 2) * 51), 255-(k * 51 + (j % 2) * 51 * 3),255-(i * 51), 8, 10);
				}else{
					if(n<=14){
						r = 255-(n * 17);
						g=b=0;
					}else if(n>14 && n<=28){
						g = 255-((n-14) * 17);
						r=b=0;
					}else if(n>28 && n<=42){
						b = 255-((n-28) * 17);
						r=g=0;
					}else{
						r=g=b=255-((n-42) * 17);
					}
					s += CBuildCell( r, g,b, 8, 10);
					n++;
				}
			}
	}
	return s;
}

// Gray
function CGenerate_2() {
	var s = '';
	for (j = 0; j <= 15; j ++) {
		s += '<tr>';
		for (k = 0; k <= 15; k ++) {
			g = Math.floor((k + j * 16) % 256);
			s += CBuildCell(g, g, g, 9, 7);
		}
	}
	return s
}

function CDec2Hex(v) {
	v = v.toString(16);
	for(; v.length < 6; v = '0' + v);
	return v;
}

function CDraw(field, k) {
    colspan = 14;

    if ( k == 2 ) colspan = 12;

    up = (k > 2) ? 0 : k + 1;
    dn = (k < 1) ? 3 : k - 1;

    return '<table cellpadding=0 cellspacing=1 border=0 width=100% bgcolor="white"><tr bgcolor="#CD3027" style="color:white;" align=center height=20><td colspan=2><a href="javascript:CShow(\''+field+'\','+dn+');"><img src="admin/skin/prev_arrow.gif" border=0></a><td colspan='+colspan+'><font face=tahoma size=2>'+pallete_txt[k]+'</font><td colspan=2><a href="javascript:CShow(\''+field+'\','+up+');"><img src="admin/skin/next_arrow.gif" border=0></a>'+
           this['CGenerate_'+k]()+
           '<tr><td align=center colspan='+[colspan+4]+'><div id="sample" style="background-color:#D7D7D7"><b><font face=tahoma size=2>sample <font color=white>sample</font></font></b></div><tr><td colspan='+[colspan+4]+' bgcolor="#CD3027"></table>';

}