//--------------------------------------------
// Set up our simple tag open values
//--------------------------------------------

var uagent    = navigator.userAgent.toLowerCase();
var is_safari = ( (uagent.indexOf('safari') != -1) || (navigator.vendor == "Apple Computer, Inc.") );
var is_ie     = ( (uagent.indexOf('msie') != -1) && (!is_opera) && (!is_safari) && (!is_webtv) );
var is_ie4    = ( (is_ie) && (uagent.indexOf("msie 4.") != -1) );
var is_moz    = (navigator.product == 'Gecko');
var is_ns     = ( (uagent.indexOf('compatible') == -1) && (uagent.indexOf('mozilla') != -1) && (!is_opera) && (!is_webtv) && (!is_safari) );
var is_ns4    = ( (is_ns) && (parseInt(navigator.appVersion) == 4) );
var is_opera  = (uagent.indexOf('opera') != -1);
var is_kon    = (uagent.indexOf('konqueror') != -1);
var is_webtv  = (uagent.indexOf('webtv') != -1);

var is_win    =  ( (uagent.indexOf("win") != -1) || (uagent.indexOf("16bit") !=- 1) );
var is_mac    = ( (uagent.indexOf("mac") != -1) || (navigator.vendor == "Apple Computer, Inc.") );
var ua_vers   = parseInt(navigator.appVersion);

var B_open = 0;
var I_open = 0;
var U_open = 0;
var QUOTE_open = 0;
var CODE_open = 0;
var SQL_open = 0;
var HTML_open = 0;

var bbtags   = new Array();
var fombj    = document.MESSAGE;


//==========================================
// show or hide emoticon bar
//==========================================
function emotbar_show_hide() {
  window.focus();

  if (is_ie) {
	 if(document.all.SmilesBar.style.display=="none") {
		  document.all.SmilesBar.style.display='';
	 } else {
	      document.all.SmilesBar.style.display='none';
	 }
  } else if(is_ns) {
	 if(document.getElementById("SmilesBar").style.display=="none") {
	   	  document.getElementById("SmilesBar").style.display='';
	 } else {
	      document.getElementById("SmilesBar").style.display='none';
	 }
  }
}


//==========================================
// prep and set up
//==========================================

//prep_mode();

//==========================================
// get element by id
//==========================================
function getbyid(id) {
 itm=null;

  if (document.all) {
      itm=document.all.id;
  } else if (document.getElementById) {
      itm=document.getElementById(id);
  } else if (document.layers) {
      itm=document.layers[id];
  }

  return itm;
}


//==========================================
// Array: Get stack size
//==========================================
function stacksize(thearray) {
	for (i=0; i<thearray.length; i++) {
		if ( (thearray[i] == "") || (thearray[i] == null) || (thearray == 'undefined') ) {
			return i;
		}
	}

	return thearray.length;
}

//==========================================
// Array: Push stack
//==========================================
function pushstack(thearray, newval) {
	arraysize = stacksize(thearray);
	thearray[arraysize] = newval;
}

//==========================================
// Array: Pop stack
//==========================================
function popstack(thearray) {
	arraysize = stacksize(thearray);
	theval = thearray[arraysize - 1];
	delete thearray[arraysize - 1];
	return theval;
}


function prep_mode() {
	cvalue = my_getcookie( "bbmode" );

	if (cvalue == 'ezmode')
	{
		fombj.bbmode[0].checked = true;
	}
	else
	{
		fombj.bbmode[1].checked = true;
	}
}

//==========================================
// Set BBCode mode
//==========================================
function setmode(mVal) {
	my_setcookie( 'bbmode', mVal, 1 );
}


function get_easy_mode_state() {
	//--------------------------------------------
	// Returns true if we've chosen easy mode
	//--------------------------------------------

	//if ( fombj.bbmode[0].checked )
	//{
		return true;
	//}
	//else
	//{
		return false;
   //	}
}

//==========================================
// Set the number of tags open box
//==========================================
function cstat()
{
	var c = stacksize(bbtags);

	if ( (c < 1) || (c == null) ) {
		c = 0;
	}

	if ( ! bbtags[0] ) {
		c = 0;
	}

	fombj.tagcount.value = c;
}


//==========================================
// Close all tags
//==========================================

function closeall() {
	if (bbtags[0]) {
		while (bbtags[0]) {
			tagRemove = popstack(bbtags)
			fombj.text.value += '[/' + tagRemove + ']';

			//--------------------------------------------
			// Change the button status
			// buttons don't exist, they are select lists instead.
			//--------------------------------------------
            eval('document.all.' + tagRemove + '.style.background="#CFD6DB"');
			eval(tagRemove + "_open = 0");
		}
	}

	//fombj.tagcount.value = 0;
	bbtags = new Array();
	fombj.text.focus();
}

//==========================================
// EMOTICONS
//==========================================
function emoticon(theSmilie) {
	doInsert(" " + theSmilie + " ", "", false);
}

//==========================================
// ADD CODE
//==========================================
function add_code(NewCode)
{
    fombj.message.value += NewCode;
    fombj.message.focus();
}



//==========================================
// SIMPLE TAGS (such as B, I U, etc)
//==========================================
function simpletag(thetag) {
   var tagOpen = eval(thetag + "_open");

    if (tagOpen == 0) {
		if ( doInsert("[" + thetag + "]", "[/" + thetag + "]", true) )	{
			eval(thetag + "_open = 1");
            eval('document.all.' + thetag + '.style.background="#C0C0C0"');
			pushstack(bbtags, thetag);
		}
	} else {
		//--------------------------------------------
		// Find the last occurance of the opened tag
		//--------------------------------------------
		lastindex = 0;

		for (i=0; i<bbtags.length; i++)	{
			if ( bbtags[i] == thetag ) {
				lastindex = i;
			}
	   	}

		//--------------------------------------------
		// Close all tags opened up to that tag was opened
		//--------------------------------------------

		while (bbtags[lastindex]) {
			tagRemove = popstack(bbtags);
			doInsert('[/' + tagRemove + ']', '', false);

			//--------------------------------------------
			// Change the button status
			//--------------------------------------------
            eval('document.all.' + thetag + '.style.background="#CFD6DB"');
            eval(tagRemove + "_open = 0");
		}
	}
}


//==========================================
// URL tag
//==========================================
function tag_url() {
    var FoundErrors = '';
    var enterURL   = prompt(site_url, "http://");
    var enterTITLE = prompt(site_name, "My Webpage");

    if (!enterURL) {
        FoundErrors += " " + error_no_url;
    }
    if (!enterTITLE) {
        FoundErrors += " " + error_no_title;
    }

    if (FoundErrors) {
        alert("Error!"+FoundErrors);
        return;
    }

	doInsert("[URL="+enterURL+"]"+enterTITLE+"[/URL]", "", false);
}

//==========================================
// Insert attachment tag
//==========================================

function insert_attach_to_textarea(aid)
{
	doInsert( "[attachmentid="+aid+"]" );
}

//==========================================
// Image tag
//==========================================

function tag_image()
{
    var FoundErrors = '';
    var enterURL   = prompt(text_enter_image, "http://");

    if (!enterURL) {
        FoundErrors += " " + error_no_url;
    }

    if (FoundErrors) {
        alert("Error!"+FoundErrors);
        return;
    }

	doInsert("[IMG]"+enterURL+"[/IMG]", "", false);
}

function tag_email()
{
    var emailAddress = prompt(choose_email, "");

    if (!emailAddress) {
		alert(error_no_email);
		return;
	}

	doInsert("[EMAIL]"+emailAddress+"[/EMAIL]", "", false);
}



function doInsert(ibTag, ibClsTag, isSingle)
{
	var isClose = false;
	var obj_ta = fombj.text;

	//----------------------------------------
	// It's IE!
	//----------------------------------------
	if ( (ua_vers >= 4) && is_ie && is_win)
	{
		if (obj_ta.isTextEdit)
		{
			obj_ta.focus();
			var sel = document.selection;
			var rng = sel.createRange();
			rng.colapse;
			if((sel.type == "Text" || sel.type == "None") && rng != null)
			{
				if(ibClsTag != "" && rng.text.length > 0)
					ibTag += rng.text + ibClsTag;
				else if(isSingle)
					isClose = true;

				rng.text = ibTag;
			}
		}
		else
		{
			if(isSingle)
			{
				isClose = true;
			}

			obj_ta.value += ibTag;
		}
	}
	//----------------------------------------
	// It's MOZZY!
	//----------------------------------------

	else if ( obj_ta.selectionEnd )
	{
		var ss = obj_ta.selectionStart;
		var st = obj_ta.scrollTop;
		var es = obj_ta.selectionEnd;

		if (es <= 2)
		{
			es = obj_ta.textLength;
		}

		var start  = (obj_ta.value).substring(0, ss);
		var middle = (obj_ta.value).substring(ss, es);
		var end    = (obj_ta.value).substring(es, obj_ta.textLength);

		//-----------------------------------
		// text range?
		//-----------------------------------

		if (obj_ta.selectionEnd - obj_ta.selectionStart > 0)
		{
			middle = ibTag + middle + ibClsTag;
		}
		else
		{
			middle = ibTag + middle;

			if (isSingle)
			{
				isClose = true;
			}
		}

		obj_ta.value = start + middle + end;

		var cpos = ss + (middle.length);

		obj_ta.selectionStart = cpos;
		obj_ta.selectionEnd   = cpos;
		obj_ta.scrollTop      = st;


	}
	//----------------------------------------
	// It's CRAPPY!
	//----------------------------------------
	else
	{
		if (isSingle)
		{
			isClose = true;
		}

		obj_ta.value += ibTag;
	}

	obj_ta.focus();

	return isClose;
}






