<?php
class tpl_global {

function page_head() {
global $Ruskiy;
return <<<EOF
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
 <head><title>{$Ruskiy->Lang['title']}</title>
 <meta http-equiv='content-type' content='text/html;' charset='{$Ruskiy->Lang['charset']}'>
 <link rel='stylesheet' type='text/css' href='{$Ruskiy->SkinUrl}style.css'>
 </head>
<body background='{$Ruskiy->SkinUrl}bg.jpg'>
EOF;
}

function frameset() {
global $Ruskiy;
return <<<EOF
<html>
 <head><title>{$Ruskiy->Lang['title']}</title></head>

 <script language='JavaScript'><!--
      if(self != top) top.location.replace(location.href);
 // --></script>

 <frameset cols='200, *' frameborder='no' border='0' framespacing='0'>
 <frame name='menu' noresize scrolling='auto' src='{$Ruskiy->BaseUrl}mod=menu'>
 <frame name='body' noresize scrolling='auto' src='{$Ruskiy->BaseUrl}mod=index'>
 </frameset>
</html>
EOF;
}

function redirect($url, $mess) {
global $Ruskiy;
return <<<EOF

<html><head>
<meta http-equiv='content-type' content='text/html;' charset='{$Ruskiy->Lang['charset']}'>
<meta http-equiv='refresh' content='1; url={$url}'>
<link rel='stylesheet' type='text/css' href='{$Ruskiy->SkinUrl}style.css'>
</head><body>
<br>
<div class='centerbox' style='text-align:center'>
<table width='90%' height='85%' border=0><tr align='center' valign='middle'><td>
 <div class='border' style='width:450'>
 <table width='100%' cellspacing=1>
 <tr height=20><td class='col2'>&nbsp;<b>{$mess}</b>
 <tr bgcolor='#F8F8F8'><td id='redirect_wait'>{$Ruskiy->Lang['redirect_wait']}
 <tr height=16><td align='center' class='col2'><a href="{$url}"><img src="{$Ruskiy->SkinUrl}loading.gif"></a>
 </table>
</div>
</table>
</div>
</body></html>

EOF;
}

function warning($warning) {
global $Ruskiy;
return <<<EOF
<tr><td colspan=4 class='warning'><img src='{$Ruskiy->SkinUrl}warn.gif' alt='{$Ruskiy->Lang['warning']}' style='vertical-align:middle;'> <font id='warn'>{$warning}</font>
EOF;
}

function nav_link($link, $alt) {
global $Ruskiy;
return <<<EOF
 &raquo; <a href='{$Ruskiy->BaseUrl}{$link}' target='body'>{$alt}</a>
EOF;
}

function nav_text($alt) {
return <<<EOF
 &raquo; {$alt}
EOF;
}

function nav_bar($links) {
global $Ruskiy;
return <<<EOF
 <div class='navdiv'><img src='{$Ruskiy->SkinUrl}acp_arr.gif' style='vertical-align:middle;'> <a href='{$Ruskiy->BaseUrl}mod=index' target='body'>{$Ruskiy->Lang['acp_home']}</a>
 {$links}</div>
EOF;
}

function link($info) {
global $Ruskiy;
return <<<EOF
 <a href="{$info['querry']}" target='{$info['tar']}'>{$info['alt']}</a>
EOF;
}

function icon_link($info) {
global $Ruskiy;
return <<<EOF
 <a href="{$info['querry']}" target='{$info['tar']}' class='button'>{$info['alt']}</a>
EOF;
}

function arr_link($info) {
global $Ruskiy;
return <<<EOF
 <a href="{$Ruskiy->BaseUrl}{$info['querry']}" class='pagelink' title='{$info['alt']}'>{$info['id']}</a>
EOF;
}

function page_curr($n) {
return <<<EOF
 <span class='pagecurrent'>{$n}</span>
EOF;
}

function page_link($info) {
global $Ruskiy;
return <<<EOF
 <a href="{$Ruskiy->BaseUrl}{$info['querry']}" class='pagelink' title='{$info['alt']}'>{$info['id']}</a>
EOF;
}

function page_n($info) {
global $Ruskiy;
return <<<EOF
<script language='JavaScript' type="text/javascript">
<!--
function multi_page_jump( url_bit, records, onpage )
{
window.focus();

if ( records % onpage == 0 ) { pages = records / onpage; }
else { pages = Math.ceil( records / onpage ); }

curpage = {$info['cur_page']};
msg = "{$Ruskiy->Lang['choose_n_page']}" + " " + pages;

user_n_page = prompt( msg, curpage );
if ( user_n_page > 0  ) {
    if ( user_n_page < 1 ) { user_n_page = 1; }
	if ( user_n_page > pages ) { user_n_page = pages; }
    start = (user_n_page - 1) * onpage;
    window.location = url_bit + "&{$Ruskiy->CONF['get_pre']}fr=" + start;
}
}
//-->
</script>
 <a href="javascript:multi_page_jump('{$Ruskiy->BaseUrl}{$info['querry']}',{$info['mcount']},{$info['onpage']});" title='{$Ruskiy->Lang['on_n_page']}' class='pagelink'>?</a>
EOF;
}

function emo_bar($emolist) {
global $Ruskiy;
return <<<EOF
{$emolist}
<br> <center> [<a href="{$Ruskiy->GuestUrl}admin.php?mod=pop" target='_blank' onclick="emotes=window.open('{$Ruskiy->GuestUrl}admin.php?mod=pop','_blank','width=260,height=270,resizable=yes,scrollbars=yes'); if (window.focus) emotes.focus(); return false;" class='ruskiy_link2'>{$Ruskiy->Lang['more_emotes']}</a>] </center>
EOF;
}

function emo_img($file) {
return <<<EOF
<img src="{$Ruskiy->GuestUrl}emoticons/{$file}" />
EOF;
}

function emo_icon($info) {
global $Ruskiy;
return <<<EOF
 &nbsp;<a href="javascript:emoticon('{$info['code']}')"><img src="{$Ruskiy->GuestUrl}emoticons/{$info['file']}" alt='{$info['code']}' /></a>
EOF;
}

function form_dropdown($name, $list=array(), $def_value='', $js='') {

    $html = '<select name="'.$name.'"'.($js != '' ? ' '.$js.' ' : '').' class=txtinput>';

    foreach ($list as $v) {
      	$html .= '<option value="'.$v[0].'"'.($v[0] == $def_value ? ' selected' : '').'>'.$v[1].'</option>';
    }

    return $html.'</select>';
}

function form_yes_no($input_name, $checked) {
global $Ruskiy;
    return '<div align=\'center\'>'.$Ruskiy->Lang['yes'].'&nbsp; <input type=\'radio\' name=\''.$input_name.'\' value=\'1\' '.($checked ? 'checked':'').' id=\'green\'>&nbsp;&nbsp;&nbsp;<input type=\'radio\' name=\''.$input_name.'\' value=\'0\' '.($checked ? '':'checked').' id=\'red\'> &nbsp;'.$Ruskiy->Lang['no'].'</div>';
}

function form_checkbox($name, $checked, $txt, $js='') {
global $Ruskiy;
    return '<input type=\'checkbox\' name=\''.$name.'\' value=\'1\' '.($checked ? 'checked' : '').' id=\'checkinput\' '.$js.'> '.$txt;
}


function shown_records($from, $to, $total) {
global $Ruskiy;
return <<<EOF
 &nbsp; {$from}-{$to} {$Ruskiy->Lang['from']} {$total}
EOF;
}



}
?><?php require_once("include_options.php");?>