<?php


class Functions {

    var $time;


 /*===========================================
 | SIMPLE OPEN TEMLATE FILE AND RETURN OBJECT
 =============================================*/
 function load_template($tpl_name) {
   global $Ruskiy;

     require ROOT_PATH. 'admin/skin/' .$tpl_name. '.php';
     return new $tpl_name;
 }


 /*======================================
 | LOAD WORDS FROM LANGUEGE LIBRARY FILE
 ========================================*/
 function load_words($arr, $library) {
   global $Ruskiy;

     require ROOT_PATH. 'admin/lang/' .$library. '.php';
     return array_merge($arr, $Lang);
 }


 /*=========================
 |  GET GET_VARS FROM $_GET
 ===========================*/
 function getGETS() {
     $get_vars = array();
     foreach ($_GET as $k=>$v) $get_vars[$k] = $v;

     return $get_vars;
 }


 /*===========================
 |  GET POST_VARS FROM $_POST
 =============================*/
 function getPOSTS() {
     $post_vars = array();
     foreach ($_POST as $k=>$v) $post_vars[$k] = $v;

     return $post_vars;
 }


 /*==================================
 |  GET COOKIE_VARS FROM HTTP HEADER
 ====================================*/
 function getCOOKIES() {
     $cookie_vars = array();
     foreach ($_COOKIE as $k=>$v) $cookie_vars[$k] = $v;

     return $cookie_vars;
 }


 /*============
 | SETS COOKIE
 ==============*/
 function setCookie($name, $value='') {
   global $Ruskiy;

     $cookie_domain = empty($Ruskiy->CONF['cookie_domain']) ? '' : $Ruskiy->CONF['cookie_domain'];
     $cookie_path = empty($Ruskiy->CONF['cookie_path']) ? '/' : $Ruskiy->CONF['cookie_path'];
     $name = $Ruskiy->CONF['cookie_pre'].$name;
     $expires = empty($Ruskiy->CONF['cookie_time']) ? 0 : time()+$Ruskiy->CONF['cookie_time'];

     @setcookie($name, $value, $expires, $cookie_path, $cookie_domain);
 }


 /*============
 | GETS COOKIE
 ==============*/
 function getCookie($name) {
   global $Ruskiy;

     $name = $Ruskiy->CONF['cookie_pre'].$name;

     if ( isset($_COOKIE[$name]) ) {
         return $_COOKIE[$name];
     } else
         return;
 }

 /*=============================================================================
 | Buid emoteicons template
 =============================================================================*/
 function get_emotebar() {
   global $Ruskiy, $db, $cashe;

     $db->query('SELECT * FROM rgb_emoticons WHERE inbar=1');

     while ( $emote = $db->fetch_row() ) {
         $cashe->add($Ruskiy->html->emo_icon( array('code' => $emote['code'], 'file' => $emote['file']) ), 'emoteicons');
     }

     return $Ruskiy->html->emo_bar( $cashe->pop('emoteicons') );

 }


 /*=============================================================================
 | GET TIME STRING
 =============================================================================*/
 function n_date($time) {
   global $Ruskiy;
     return $Ruskiy->Lang['d'.date('w', $time)] . ', ' . date('j', $time) . ' ' . $Ruskiy->Lang['m'.date('n', $time)] . ' ' . date(' Y [H:i]', $time);
 }


 /*=============================================================================
 | GET TIME STRING
 =============================================================================*/
 function s_date($time) {
     return date('j.m.y [H:i]', $time);
 }

 /*=============================================================================
 | GET TIME STRING
 =============================================================================*/
 function ban_date($time) {
   global $Ruskiy;

     $dif = $time - $this->time;

     if ( $time == 0 )
         return $Ruskiy->Lang['ban_unlimited'];
     elseif ( $dif < 0 )
         return '<font color="#42B03C">'.$Ruskiy->Lang['ban_delayed'].'</font>';
     elseif ( $dif > 86400 )
         return floor($dif/86400).$Ruskiy->Lang['days'];
     elseif ( $dif > 3600 )
         return floor($dif/3600).$Ruskiy->Lang['hours'];
     else
         return '<font color="#AEAE00">'.floor($dif/60).$Ruskiy->Lang['minutes'].'</font>';

 }


 /*=============================================================================
 | MAKE QUERRY FROM $RUSKIY->GETVARS ARRAY
 =============================================================================*/
 function make_querry($arr=array()) {
   global $Ruskiy;

     $txt = '';
     foreach ( $arr as $name=>$value ) {
         $name = $name;
         $arr_id[$name] = $value;

         if ( !empty($value) ) $txt .= $name.'='.$value.'&';
     }

     foreach ( $Ruskiy->GET as $name=>$value ) {
         if ( !isset($arr_id[$name]) && !empty($value) )
             $txt .= $name.'='.$value.'&';
     }

     return substr($txt, 0, strlen($txt)-1);
 }


 /*==============
 | get FILE SIZE
 ================*/
 function get_filesize($fname) {
   global $Ruskiy;

     $size = @filesize($fname);

     if ($size >= 1048576) {
         $size = round($size/1048576*100)/100 ;
         $format = 'mb';
     } elseif ($size >= 1024) {
         $size = round($size/1024*100)/100 ;
         $format = 'kb';
     } else {
         $format = 'byte';
     }

     return array(0 => $size,  1 => $Ruskiy->Lang[$format] );

 }

 // checks if the given string is a number in the boundaries
 function is_int($int_string, $min, $max) {
    if ( $int_string == '' || !is_numeric($int_string) || $int_string < $min || $int_string > $max )
        return false;

    return true;
 }



















}
?>