<?php


class Functions {

  //var $ban; // ban data (array)
  var $starttime;


 /*===========================================
 | SIMPLE OPEN TEMLATE FILE AND RETURN OBJECT
 =============================================*/
 function load_template($tpl_name) {
   global $Ruskiy;

     require ROOT_PATH .'themes/'. $Ruskiy->CONF['skin'] .'/'. $tpl_name .'.php';
     return new $tpl_name;
 }


 /*======================================
 | LOAD WORDS FROM LANGUEGE LIBRARY FILE
 ========================================*/
 function load_words($arr, $library) {
   global $Ruskiy;

     require ROOT_PATH .'lang/'. $Ruskiy->CONF['language'] .'/'. $library .'.php';
     return array_merge($arr, $Lang);
 }


 /*=========================
 |  GET GET_VARS FROM $_GET
 ===========================*/
 function getGETS() {
     //$get_vars = array();
     //foreach ($_GET as $k=>$v) $get_vars[$k] = $v;
     return $_GET;
 }


 /*============================
 |  RETURN GET_VAR WITH GET_ID
 ==============================*/
 function getGET($name) {
   global $Ruskiy;

     return $Ruskiy->GET[ $Ruskiy->CONF['get_pre'].$name ];
 }


 /*=========================
 |  SET GET_VAR WITH GET_ID
 ===========================*/
 function setGET($name, $value='') {
   global $Ruskiy;

     $Ruskiy->GET[ $Ruskiy->CONF['get_pre'].$name ] = $value;
 }



 /*===========================
 |  GET POST_VARS FROM $_POST
 =============================*/
 function getPOSTS() {
     $post_vars = array();
     foreach ($_POST as $k=>$v) $post_vars[$k] = $v;

     return $post_vars;
 }


 /*==================================
 |  GET COOKIE_VARS FROM HTTP HEADER
 ====================================*/
 function getCOOKIES() {
     $cookie_vars = array();
     foreach ($_COOKIE as $k=>$v) $cookie_vars[$k] = $v;

     return $cookie_vars;
 }


 /*============
 | SETS COOKIE
 ==============*/
 function setCookie($name, $value='') {
   global $Ruskiy;

     $cookie_domain = empty($Ruskiy->CONF['cookie_domain']) ? '' : $Ruskiy->CONF['cookie_domain'];
     $cookie_path = empty($Ruskiy->CONF['cookie_path']) ? '/' : $Ruskiy->CONF['cookie_path'];
     $name = $Ruskiy->CONF['cookie_pre'] . $name;
     $expires = empty($Ruskiy->CONF['cookie_time']) ? 0 : time()+$Ruskiy->CONF['cookie_time'];

     @setcookie($name, $value, $expires, $cookie_path, $cookie_domain);
 }


 /*============
 | GETS COOKIE
 ==============*/
 function getCookie($name) {
   global $Ruskiy;

     if ( isset($_COOKIE[ $Ruskiy->CONF['cookie_pre'].$name ]) ) {
         return $_COOKIE[ $Ruskiy->CONF['cookie_pre'].$name ];
     } else return FALSE;
 }


 /*=============================================================================
 | MAKE QUERRY FROM $RUSKIY->GETVARS ARRAY
 =============================================================================*/
 function make_querry($arr=array()) {
   global $Ruskiy;

     $txt = '';
     foreach ( $arr as $k => $v ) {
         $k = $Ruskiy->CONF['get_pre'].$k;
         $arr_id[$k] = $v;

         if ( !empty($v) ) $txt .= $k .'='. $v .'&';
     }

     foreach ( $Ruskiy->GET as $k => $v ) {
         if ( !isset($arr_id[$k]) && !empty($v) )
             $txt .= $k .'='. $v .'&';
     }

     return substr($txt, 0, strlen($txt)-1);
 }


 /*=============================================================================
 | GET TIME STRING
 =============================================================================*/
 function n_date($time) {
   global $Ruskiy;
     return $Ruskiy->Lang['d'.date('w', $time)] .', '. date('j', $time) .' '. $Ruskiy->Lang['m'.date('n', $time)] .' '. date(' Y [H:i]', $time);
 }


 /*=============================================================================
 | GET TIME STRING
 =============================================================================*/
 function s_date($time) {
     return date('j.m.y [H:i]', $time);
 }


 /*=============================================================================
 | try to GET User Data return it in array
 =============================================================================*/
 function recollect_user($from_last=1) {
   global $Ruskiy, $functions, $db;


     if ( $Ruskiy->CONF['enable_remember'] ) {

         if ( $Ruskiy->CONF['enable_users'] ) {

             // get registered user data from COOKIE
             $uid = $functions->getCookie('uid');
             $password = $functions->getCookie('password');

             // take registered user data or try to get it
             if ( $uid && $password ) {

                 $db->query("SELECT * FROM rgb_members WHERE uid=$uid AND password='$password'");

                 if ( $user = $db->fetch_row() ) return $user;
             }

         }

         // try to take User Data from his last message
         if ( $from_last && $id = $functions->getCookie('id') ) {

             $db->query("SELECT * FROM rgb_messages WHERE id=$id");

             return $db->fetch_row();
         }
     }
 }


 /*======================================
 | BUILD PAGE and RETURN it TO BROWSER
 ======================================*/
 function buid_page($do_cache=0,$its_cache=0) {
   global $Ruskiy, $cashe, $db;

     /*if ( $Ruskiy->CONF['css_method'] == 'external' ) {
         $css = $Ruskiy->html->css_file();
     } else {
         $css = file_get_contents(ROOT_PATH. 'themes/' .$Ruskiy->CONF['skin']. '/style.css');
     }  */


     // if allow gzip (reduce traffic up to 21%)                            is browser allow gzip?
     if ( $Ruskiy->CONF['enable_gzip'] && $Ruskiy->CONF['mode']!='built' /*&& ereg('gzip, deflate',$_SERVER['HTTP_ACCEPT_ENCODING'])*/ ) {
         $is_gzip = TRUE;
         $html['top'] = ob_get_contents();
         ob_end_clean();
         ob_start('ob_gzhandler');
         echo $html['top'];

     } else $is_gzip = FALSE;


     // make sysinfo BAR
     $html['sysinfo'] = $Ruskiy->html->sysinfo( array(
                        'exe_time' => $this->endTimer(),
                     'query_count' => $db->query_count,
                         'is_gzip' => $is_gzip,
                        'is_cache' => $its_cache,
                            'time' => $Ruskiy->TIME) );

     // is WE have a DATA_CONTENT from Cache File?
     if ( $its_cache ) {
         $html['body'] = str_replace('<~ SYSINFO ~>', $html['sysinfo'], $cashe->pop('body'));
         print $html['body'];
         return;
     }


     $html['css'] = $Ruskiy->html->css();
     $html['copyright'] = $Ruskiy->html->copyrights();

     // choose main template
     if ( $Ruskiy->CONF['mode']=='pop' )
         $tpl_file = 'pop-up';
     elseif ( $Ruskiy->CONF['mode']=='self' )
         $tpl_file = 'separate';
     else
         $tpl_file = 'built-in';

     // LOAD TEMPLATE
     $html['body'] = file_get_contents(ROOT_PATH.'themes/'.$Ruskiy->CONF['skin'].'/'.$tpl_file.'.html');


     $html['body'] = str_replace('<~ CSS ~>'      , $html['css']            , $html['body']);
     $html['body'] = str_replace('<~ TITLE ~>'    , $Ruskiy->Lang['title']  , $html['body']);
     $html['body'] = str_replace('<~ CHARSET ~>'  , $Ruskiy->Lang['charset'], $html['body']);
     $html['body'] = str_replace('<~ MENU ~>'     , $cashe->pop('menu')     , $html['body']);
     $html['body'] = str_replace('<~ BODY ~>'     , $cashe->pop('body')     , $html['body']);
     $html['body'] = str_replace('<~ NAVIGATE ~>' , $cashe->pop('navigate') , $html['body']);
     $html['body'] = str_replace('<~ COPYRIGHT ~>', $html['copyright']      , $html['body']);


     // if enable CACHE save his to FILE
     if ( $Ruskiy->CONF['enable_cache'] && $do_cache ) {
         $this->cache_add($html['body']);
     }

     $html['body'] = str_replace('<~ SYSINFO ~>'  , $html['sysinfo']        , $html['body']);

     $db->close();

     print $html['body'];

     //print $html;

     //echo $Debug->endTimer();

     //exit;
 }


 /*=====================
 | show REDIRECT PAGE
 =====================*/
 function page_redirect($url, $message) {
   global $Ruskiy, $cashe;

     /*-------------------------------------------------------------------------
     |  ,     
     |  ,       
     -------------------------------------------------------------------------*/
     //ob_clean();
     ob_end_clean();

     //    
     echo $Ruskiy->html->redirect($url, $message);

     // 1.    
     ob_flush();

     //ob_end_clean();
     define('OB_CLEAN', 1);
     /*-------------------------------------------------------------------------
     | 2.       (  
     |      )
     -------------------------------------------------------------------------*/

     ob_start();
     //$cashe->is_obclean = TRUE;

 }

 /*=================================================
 | build MENU BAR (seve menu bar in cashe "menu")
 =================================================*/
 function menu_bar() {
   global $Ruskiy, $cashe;

     if ( $Ruskiy->CONF['mode']!='built' ) {
         $cashe->add($Ruskiy->html->menu_link( array('link' => $Ruskiy->CONF['site_url'],
                      'id' => 'home',
                      'alt' => $Ruskiy->CONF['site_name']) ), 'menu_list', 1);
     }

     if ( $Ruskiy->CONF['admin_enter'] ) {
         $cashe->add($Ruskiy->html->menu_link( array(
                      'link' => ROOT_PATH.'admin.php',
                        'id' => 'admin',
                       'alt' => $Ruskiy->Lang['menu_admin']) ), 'menu_list');
     }

     $cashe->set($Ruskiy->html->menu_bar( $cashe->pop('menu_list') ), 'menu');

 }

 /*==============
 | get FILE SIZE
 ================*/
 function get_filesize($fname) {
   global $Ruskiy;

     $size = @filesize($fname);

     if ( $size >= 1048576 ) {
         $size = round($size/1048576*100)/100 ;
         $format = 'mb';
     } elseif ( $size >= 1024 ) {
         $size = round($size/1024*100)/100 ;
         $format = 'kb';
     } else {
         $format = 'byte';
     }

     return array( 0 => $size, 1 => $Ruskiy->Lang[$format] );

 }


 /*==============
 | load BAN by IP
 ================*/
 function load_ban() {
  global $Ruskiy, $db;

    $db->query("SELECT * FROM rgb_ban WHERE time=0 or time>".$Ruskiy->TIME);

    while ( $data = $db->fetch_row() ) {

        $ip = preg_replace("/\*/", '.*', preg_quote($data['ip'], "/"));

	    if ( preg_match("/^$ip/", $Ruskiy->REMOTE_ADDR) ) {
           $this->ban = $data;
           break;
        }
    }
 }

 /*=======================
 | check for specific BAN
 ========================*/
 function check_ban($level=1) {
   global $Ruskiy, $db, $cashe;

     if ( !is_array($this->ban) ) return;


     if ( $this->ban['level'] >= $level ) {

         // increase worked in BAN
         $db->query("UPDATE rgb_ban SET worked=".($this->ban['worked']+1)." WHERE bid=".$this->ban['bid']);

         $cashe->clear_all();

         $cashe->set($Ruskiy->html->ban( array(
              'level' => $this->ban['level'],
               'time' => $this->ban['time'] ? $this->n_date($this->ban['time']) : $Ruskiy->Lang['ban_unlimit'],
             'reason' => empty($this->ban['reason']) ? $Ruskiy->Lang['def_ban_reason'] : $this->ban['reason'],
                                            ) ), 'body');

         $this->buid_page();
     }

 }


 //************ FILE CASHE ********************

 //---- ADD DATA TO CASHE FILE -----
 function cache_add($content) {

     $cached_file = ROOT_PATH .'cache/'. md5($_SERVER['REQUEST_URI']);

     $fhandle = @fopen($cached_file, 'w');
     if ( !$fhandle ) return FALSE;

     fwrite($fhandle, $content, strlen($content));
     fclose($fhandle);

     return TRUE;
 }

 //---- GET DATA FROM CASHE FILE -----
 function cache_get() {

     $cached_file = ROOT_PATH .'cache/'. md5($_SERVER['REQUEST_URI']);

     // is cache file exists?
     if( file_exists($cached_file) )
        return file_get_contents($cached_file);
     else
        return FALSE;
 }

 //---- CLEAR CASHE FILES -----
 function cache_clear($fname='') {

     $cache_dir = ROOT_PATH .'cache';

     // del one of all files
     if ( $fname != '' )
         @unlink($cache_dir.'/'.$fname);

     $dhandle = opendir($cache_dir);

     while ( false !== ($fname = readdir($dhandle)) ) {
       $fname = $cache_dir .'/'. $fname;
       if ( is_file($fname) )
           @unlink($fname);
     }

     closedir($dhandle);

     /* MAYBE, but for PHP5
     $cache_dir = ROOT_PATH .'cache';
     $flist = scandir($cache_dir, 1);

     for ($i=2; $i<count($flist); $i++) {
         @unlink($cache_dir.$flist[$i]);
     }*/
 }

 // *****************************


 // EXECUTION TIMER
 function startTimer() {
     $mtime = explode (' ', microtime());
     $this->starttime = $mtime[1] + $mtime[0];
 }

 function endTimer() {
     $mtime = explode(' ', microtime());
     $endtime = $mtime[1] + $mtime[0];
     $total = round($endtime-$this->starttime, 5);
	 return $total;
 }













}
?>