<?php

class Mailer {

    var $karetka  = "\n";
    var $charset  = '';

    var $header   = '';

    var $from     = '';
    var $name     = '';
    var $to       = '';
	var $subject  = '';
	var $content  = '';

    var $headers   = array(); // email HEADERS

    //var $html; // template for MAIL


 function Mailer() {
   global $Ruskiy, $functions;

     // set MAIL charset
     $this->charset = $Ruskiy->CONF['mail_charset'];

     /* is LOADed template?
     if ( !is_a($this->html, 'tpl_mail') ) {
         $this->html = $functions->load_template('tpl_mail');
     }  */
 }


 function build_headers() {
   global $Ruskiy;

     if ( $this->name )
         $this->headers['From'] = $this->name.' <'.$this->from.'>';
     else
         $this->headers['From'] = $this->from;

     if ( $this->to )
		 $this->headers['To'] = $this->to;


     $this->headers['Subject'] = $this->subject;

     // set headers
     $this->headers['MIME-Version'] = '1.0';
     $this->headers['X-Mailer'] = 'Ruskiy Guestbook Mailer v1.3';
     $this->headers['Content-Type'] = 'text/html; charset='.$this->charset;
     $this->headers['Content-transfer-encoding'] = '8bit';
     //$this->headers['X-Priority'] = '3';
     $this->headers['X-MSMail-Priority'] = 'Normal';

     // implode HEADERS to string
     foreach ( $this->headers as $k => $v ) {
         $this->header .= $k.': '.$v.$this->karetka;
     }
 }


 function send() {

	 $this->to   = preg_replace("/[ \t]+/", "", $this->to  );
	 $this->from = preg_replace("/[ \t]+/", "", $this->from);

	 $this->to   = preg_replace("/,,/", ",", $this->to  );
	 $this->from = preg_replace("/,,/", ",", $this->from);

	 $this->to     = preg_replace("#\#\[\]'\"\(\):;/\$!%\^&\*\{\}#", "", $this->to  );
	 $this->from   = preg_replace("#\#\[\]'\"\(\):;/\$!%\^&\*\{\}#", "", $this->from);


     $this->build_headers();

     if ( !@mail($this->to, $this->htmlconv($this->subject), $this->content, $this->header) )
         return FALSE;
     else
         return TRUE;
 }


 function htmlconv($str='') {

     $str = str_replace('"', '&quot;', $str);
     $str = str_replace('<', '&lt;', $str);
     $str = str_replace('>', '&gt;', $str);
     $str = str_replace("\r\n", "\n", $str);
     $str = str_replace("\r", "\n", $str);
     $str = str_replace("\n", '<br>', $str);
     $str = str_replace("\$", '&#36;', $str);
     $str = eregi_replace("(<br>*){2,}", '<br><br>', $str);
     $str = eregi_replace("[ ]{2,}", ' ', $str);
     $str = trim($str);

     return $str;
 }


}

?>