<?php

class Navigate {

    var $sort_order;

    var $records;
    var $onpage;
    var $cur_record;
    var $to_record;

    var $pages;
    var $cur_page;

    var $top_page;
    var $but_page;


 /*==================================
 | FIND RANGE OF RECORDS FROM ... TO
 ====================================*/
 function records_range() {

     $this->cur_record = $this->cur_record < 0 ? 0 : $this->cur_record;

     if ( $this->cur_record < $this->records ) {
         $this->to_record = $this->records;

         if ( $this->cur_record + $this->onpage < $this->records )
             $this->to_record = $this->cur_record + $this->onpage;
         elseif ( $this->records - $this->onpage < 0 )
             $this->cur_record = 0;

     } else {
          $this->cur_record = 0;
          $this->to_record = $this->records;
     }

 }


 /*================================
 | FIND RANGE OF PAGES FROM ... TO
 ==================================*/
 function pages_range() {
   global $Ruskiy;

     $this->pages = $this->ceil_parts($this->records, $this->onpage);
     $this->cur_page = $this->ceil_parts($this->to_record, $this->onpage);

     $this->top_page = $this->cur_page;
     $this->but_page = $this->cur_page;

     $sw = 1;
     for ($i=1; $i<$Ruskiy->CONF['pagelinks']; $i++) {
         switch ($sw) {
           case 1:
               if ( ($this->but_page) > 1 )
                   $this->but_page--;
               elseif ( ($this->top_page) < $this->pages )
                   $this->top_page++;
               else
                   return;
               $sw = 2;
               break;

           case 2:
               if ( ($this->top_page) < $this->pages )
                   $this->top_page++;
               elseif ( ($this->but_page) > 1 )
                   $this->but_page--;
               else
                   return;
               $sw = 1;
               break;
         }
     }

 }


 /*=================================================
 | BREAK VALUE TO PARTS (NEED FOR FIND PAGES COUNT)
 ===================================================*/
 function ceil_parts($whole, $part) {
     if ( empty($whole) || empty($part) ) return 1;

     return ceil($whole/$part);
 }


 /*=============================
 | GET FULL NAVIGATIONS BUTTONS
 ===============================*/
 function get_bar() {
   global $Ruskiy, $cashe, $functions;

     $this->pages_range();

     $srt = ($this->sort_order == 'desc') ? '' : $this->sort_order;

     if ( $this->cur_record > 0 ) {
         $cashe->set($Ruskiy->html->arr_link(
                  array('querry' => $functions->make_querry(array('fr'=>'', 'srt'=>$srt)),
                           'alt' => $Ruskiy->Lang['on_top_page'],
                           'img' => 'arr_top',
                            'id' => $Ruskiy->Lang['id_top_page'])
                                              ), 'navigate');

         $cashe->add($Ruskiy->html->arr_link(
                  array('querry' => $functions->make_querry(array('fr'=>($this->cur_record-$this->onpage < 0) ? 0 : $this->cur_record-$this->onpage, 'srt'=>$srt)),
                           'alt' => $Ruskiy->Lang['on_prev_page'],
                           'img' => 'arr_left',
                            'id' => $Ruskiy->Lang['id_prev_page'])
                                              ), 'navigate');
     }

     // show go on N Page
     if ( $Ruskiy->CONF['pagelinks'] < $this->pages ) {
         $cashe->add($Ruskiy->html->page_n(
                  array('querry' => $functions->make_querry(array('fr'=>'', 'act'=>'', 'srt'=>$srt)),
                        'mcount' => $this->records,
                        'onpage' => $this->onpage,
                      'cur_page' => $this->cur_page)
                                       ), 'navigate');
     }


     for ( $i=$this->but_page; $i<=$this->top_page; $i++ ) {
         if ( $i != $this->cur_page ) {
             $cashe->add($Ruskiy->html->page_link(
                  array('querry' => $functions->make_querry(array('fr'=>($i-1)*$this->onpage, 'srt'=>$srt)),
                           'alt' => $Ruskiy->Lang['page'].' '.$i,
                            'id' => $i) ), 'navigate');
         } else
             $cashe->add($Ruskiy->html->page_curr($i), 'navigate');
     }

     if ( $this->cur_record + $this->onpage < $this->records ) {
         $cashe->add($Ruskiy->html->arr_link(
                  array('querry' => $functions->make_querry(array('fr'=>$this->cur_record+$this->onpage, 'srt'=>$srt)),
                           'alt' => $Ruskiy->Lang['on_next_page'],
                           'img' => 'arr_right',
                            'id' => $Ruskiy->Lang['id_next_page'])
                                              ), 'navigate');

         $cashe->add($Ruskiy->html->arr_link(
                  array('querry' => $functions->make_querry(array('fr'=>($this->records-$this->onpage < 0) ? 0 : $this->records-$this->onpage, 'srt'=>$srt)),
                           'alt' => $Ruskiy->Lang['on_but_page'],
                           'img' => 'arr_bot',
                            'id' => $Ruskiy->Lang['id_but_page'])
                                              ), 'navigate');
     }

     return $cashe->pop('pages_bar');
 }




}
?>