<?php

$TABLE[] = "CREATE TABLE rgb_badwords (
  wid smallint(3) NOT NULL auto_increment,
  bad varchar(250) NOT NULL default '',
  good varchar(250) default NULL,
  method tinyint(1) default '0',
  PRIMARY KEY  (wid)
) TYPE=MyISAM;";

$TABLE[] = "CREATE TABLE rgb_ban (
  bid int(6) NOT NULL auto_increment,
  time int(10) default NULL,
  ip varchar(16) NOT NULL default '',
  reason text,
  level tinyint(1) NOT NULL default '0',
  worked int(10) NOT NULL default '0',
  PRIMARY KEY  (bid)
) TYPE=MyISAM;";

$TABLE[] = "CREATE TABLE rgb_comments (
  cid mediumint(10) NOT NULL auto_increment,
  mid mediumint(10) NOT NULL default '0',
  uid mediumint(8) NOT NULL default '0',
  ip varchar(16) NOT NULL default '',
  name varchar(32) NOT NULL default '',
  email varchar(64) NOT NULL default '',
  text text NOT NULL,
  time int(10) default NULL,
  hidemail tinyint(1) unsigned default '0',
  PRIMARY KEY  (cid)
) TYPE=MyISAM;";

$TABLE[] = "CREATE TABLE rgb_emoticons (
  eid smallint(3) NOT NULL auto_increment,
  code varchar(32) NOT NULL default '',
  file varchar(128) NOT NULL default '',
  inbar tinyint(1) default '0',
  PRIMARY KEY  (eid)
) TYPE=MyISAM;";

$TABLE[] = "CREATE TABLE rgb_config (
  enable_gzip tinyint(1) NOT NULL default '0',
  mode varchar(32) NOT NULL default '',
  status varchar(32) NOT NULL default '',
  skin varchar(127) NOT NULL default '',
  language varchar(10) NOT NULL default '',
  site_name varchar(127) NOT NULL default '',
  site_url varchar(127) NOT NULL default '',
  guest_url varchar(127) NOT NULL default '',
  guest_dir varchar(127) NOT NULL default '',
  store_messages int(10) NOT NULL default '0',
  onpage smallint(3) NOT NULL default '0',
  pagelinks smallint(3) NOT NULL default '0',
  get_pre varchar(10) NOT NULL default '',
  cookie_domain varchar(127) NOT NULL default '',
  cookie_path varchar(127) NOT NULL default '',
  cookie_pre varchar(10) NOT NULL default '',
  cookie_time int(10) NOT NULL default '0',
  flood_timer int(10) NOT NULL default '0',
  flood_depth int(3) NOT NULL default '0',
  stored smallint(7) NOT NULL default '0',
  delete_older smallint(4) NOT NULL default '0',
  wordwrap smallint(3) NOT NULL default '0',
  av_w_max smallint(3) NOT NULL default '0',
  av_h_max smallint(3) NOT NULL default '0',
  av_s_max smallint(3) NOT NULL default '0',
  av_ext varchar(100) NOT NULL default '',
  maxlen_name smallint(3) NOT NULL default '0',
  maxlen_email smallint(3) NOT NULL default '0',
  maxlen_icq smallint(3) NOT NULL default '0',
  maxlen_homepage int(3) NOT NULL default '0',
  maxlen_aim smallint(3) NOT NULL default '0',
  maxlen_msn smallint(3) NOT NULL default '0',
  maxlen_yahoo smallint(3) NOT NULL default '0',
  maxlen_text smallint(6) NOT NULL default '0',
  enable_remember tinyint(1) NOT NULL default '0',
  enable_email tinyint(1) NOT NULL default '0',
  enable_icq tinyint(1) NOT NULL default '0',
  enable_homepage tinyint(1) NOT NULL default '0',
  enable_aim tinyint(1) NOT NULL default '0',
  enable_msn tinyint(1) NOT NULL default '0',
  enable_yahoo tinyint(1) NOT NULL default '0',
  enable_avatar tinyint(1) NOT NULL default '0',
  enable_country tinyint(1) NOT NULL default '0',
  enable_emote tinyint(1) NOT NULL default '0',
  enable_bcode tinyint(1) NOT NULL default '0',
  enable_private tinyint(1) NOT NULL default '0',
  enable_comment tinyint(1) NOT NULL default '0',
  enable_mail tinyint(1) NOT NULL default '0',
  need_email tinyint(1) unsigned default '0',
  enable_users tinyint(1) unsigned default NULL,
  admin_enter tinyint(1) unsigned default '0',
  enable_hidemail tinyint(1) unsigned default '0',
  enable_badword tinyint(1) unsigned default '0',
  gd_font varchar(128) default NULL,
  gd_font_size smallint(2) default NULL,
  gd_color varchar(20) default NULL,
  gd_bg_color varchar(20) default NULL,
  enable_notice tinyint(1) unsigned NOT NULL default '0',
  notice_to varchar(60) NOT NULL default '',
  notice_from varchar(60) NOT NULL default '',
  mail_charset varchar(32) NOT NULL default '',
  enable_moderate tinyint(1) unsigned zerofill NOT NULL default '0',
  show_ip_host tinyint(1) unsigned default '0'
) TYPE=MyISAM;";

$TABLE[] = "CREATE TABLE rgb_mailed (
  sid mediumint(10) NOT NULL auto_increment,
  ip varchar(16) NOT NULL default '',
  m_from varchar(60) NOT NULL default '',
  m_to varchar(60) NOT NULL default '',
  subject text NOT NULL,
  text text NOT NULL,
  time int(10) default NULL,
  PRIMARY KEY  (sid)
) TYPE=MyISAM;";

$TABLE[] = "CREATE TABLE rgb_members (
  uid int(10) NOT NULL auto_increment,
  name varchar(50) NOT NULL default '',
  password varchar(32) NOT NULL default '',
  ip varchar(16) NOT NULL default '',
  country smallint(3) default NULL,
  email varchar(60) NOT NULL default '',
  homepage varchar(70) default NULL,
  icq varchar(40) default NULL,
  aim varchar(40) default NULL,
  msn varchar(64) default NULL,
  yahoo varchar(32) default NULL,
  avatar varchar(32) default NULL,
  hidemail tinyint(1) NOT NULL default '0',
  lastvisit int(10) default '0',
  registered int(10) default '0',
  PRIMARY KEY  (uid)
) TYPE=MyISAM;";

$TABLE[] = "CREATE TABLE rgb_messages (
  id int(10) NOT NULL auto_increment,
  uid int(8) NOT NULL default '0',
  time int(10) default NULL,
  ip varchar(16) NOT NULL default '',
  host varchar(128) NOT NULL default '',
  name varchar(32) NOT NULL default '',
  country smallint(3) default NULL,
  email varchar(64) NOT NULL default '',
  homepage varchar(70) default NULL,
  icq varchar(40) default NULL,
  aim varchar(40) default NULL,
  msn varchar(64) default NULL,
  yahoo varchar(32) default NULL,
  hidemail tinyint(1) NOT NULL default '0',
  avatar varchar(32) default NULL,
  text text NOT NULL,
  answer text,
  private tinyint(1) NOT NULL default '0',
  moderated tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (id),
  KEY uid (uid)
) TYPE=MyISAM;";

?>