<?php /**************************************************************
*                  Ruskiy Guestbook 1.3 (List.php)                  *
*  ---------------------------------------------------------------  *
*   Author:  Yarmoluk Ruslan                                        *
*   E-mail: ruslan@ruskiy.com.ru                                    *
*   Home page: http://www.ruskiy.com.ru                             *
*   Licence Info: http://www.ruskiy.com.ru/?license                 *
*   Date started: 20 August 2005                                    *
*   Module version: 1.0                                             *
*  ---------------------------------------------------------------  *
*                   (c) 2005 Yarmoluk Ruslan                        *
********************************************************* LIST ******/

$idx = new Modul;

class Modul {

    var $html; // Template class

    var $is_login = FALSE; // Check for user login
    var $uid;

 function Modul() {
   global $Ruskiy, $functions, $cashe;

     $Ruskiy->Lang = $functions->load_words($Ruskiy->Lang, 'lang_list');
     $this->html = $functions->load_template('tpl_list');


     //    
     switch ( $functions->getGET('act') ) {

       case '01':
           $this->Index();
           break;

       default :
           $this->Index();
           break;
     }

 }


 /*=============================================================================
 |   
 =============================================================================*/
 function Index() {
   global $Ruskiy, $functions, $cashe, $db;



     // --- TRY to get content from CACHE file
     if ( $Ruskiy->CONF['enable_cache'] ) {

         if ( $html = $functions->cache_get() ) {
             $cashe->set($html, 'body');
             unset($html);
             $functions->buid_page(0,1);

             return;
         }
     }




       //$this->auto_login();

     // load ADMIN name
     $db->query("SELECT name FROM rgb_members WHERE uid=1");
     $data = $db->fetch_row();
     $db->free_result();

     $Ruskiy->CONF['admin_name'] = $data['name'];




     // add menu "ADD MESSAGE"
     $cashe->add($Ruskiy->html->menu_link( array(
             'link' => $Ruskiy->BaseUrl.$functions->make_querry( array('mod'=>'add','act'=>'','fr'=>'') ),
               'id' => 'add',
              'alt' => $Ruskiy->Lang['menu_add']) ), 'menu_list');

     $functions->menu_bar();


     $this->showMessages();

     $functions->buid_page(1);





     /*-------------------------------------------------------------------------
     |    ???
     -------------------------------------------------------------------------*/
     /*if ( $Ruskiy->CONF['main']['status'] == 'stop' ) {
        $cashe->set($Ruskiy->html->stop($Ruskiy->Lang['guestbook_stoped']), 'stop');
        $cashe->flush('stop');
        return;

     }     */
     //-------------------------------------------------------------------------





 }


 /*=============================================================================
 |    
 =============================================================================*/
 function showMessages() {
   global $Ruskiy, $functions, $cashe, $db;


     // Get count of guestbook records
     $db->query("SELECT count(id) as count FROM rgb_messages WHERE moderated=1");
     $count = $db->fetch_row();


     //       -<
     require ROOT_PATH. 'classes/class_navbar.php';
     $navigate = new Navigate;

     // Change ORDER (allow for users) jast push the arrow :)
     $navigate->sort_order = ( $functions->getGET('srt') != 'asc' ) ? 'desc' : 'asc' ;

     $navigate->records = $count['count'];
     $navigate->onpage = $Ruskiy->CONF['onpage'];
     $navigate->cur_record = !$functions->getGET('fr') ? 0 : $functions->getGET('fr');

     $navigate->records_range();
     // >-

     $navigate->get_bar();



     $squery = $db->query("SELECT * FROM rgb_messages
          WHERE moderated=1
          ORDER BY time ".$navigate->sort_order."
          LIMIT ".$navigate->cur_record.",".$Ruskiy->CONF['onpage']);


     //  ...
     while ( $record = $db->fetch_row($squery) ) {

        //if ( !$record['moderated'] )
        //    continue;

        // if its user record, when take user data from members table
        if ( $record['uid'] ) {

            $db->query("SELECT * FROM rgb_members WHERE uid=".$record['uid']);
            $record = array_merge($record, $db->fetch_row());

            //$db->free_result();
        }


        // is its private message?
        if ( $record['private'] ) {

            // is message from member?
            if ( $record['uid'] ) {

                $uid = $functions->getCookie('uid');
                $password = $functions->getCookie('password');

                // check for member login
                if ( $uid != $record['uid'] || $password != $record['password'] ) {
                    $cashe->add($this->html->record_locked( $functions->n_date($record['time']) ), 'records');
                    continue;
                }

            // not from MEmber, but private
            } else {
                $cashe->add($this->html->record_private( $functions->n_date($record['time']) ), 'records');
                continue;
            }

        }


        // is admin allow comments in guestbook
        if ( $Ruskiy->CONF['enable_comment'] ) {

            $db->query("SELECT count(cid) as count FROM rgb_comments WHERE mid=".$record['id']);
            $comments = $db->fetch_row();

            // is more than 0 comments?
            if ( $comments['count'] ) {
                $cashe->set($this->html->view_comment($record['id'], $comments['count']), 'comment_link');
            } else {
                $cashe->set($this->html->add_comment($record['id']), 'comment_link');
            }

             $db->free_result();
        }


        // is its private message?
        if ( $record['email'] ) {

            // is email hidden (YES? ...so show mail form in popup window)
            if ( $record['hidemail'] )
                $cashe->set($this->html->email_hidden($record['id']), 'email');

            // is allow send mail from guestbook?
            elseif ( $Ruskiy->CONF['enable_mail'] )
                $cashe->set($this->html->email_send($record['id'], str_replace('@', '[a]', $record['email'])), 'email');

            // show original email link
            else
                $cashe->set($this->html->email( $record['email'] ) , 'email');

        }


        // add record to cashe
        $cashe->add($this->html->record( array(
                 'id' => $record['id'],
               'name' => $record['name'],
            'ip_host' => $Ruskiy->CONF['show_ip_host'] ? $this->html->ip_host($record['ip'],$record['host']) : '',

              'email' => $cashe->pop('email'),
                'icq' => $record['icq'] ? $this->html->icq($record['icq']) : '',
           'homepage' => $record['homepage'] ? $this->html->homepage($record['homepage']) : '',
                'aim' => $record['aim'] ? $this->html->aim($record['aim']) : '',
              'yahoo' => $record['yahoo'] ? $this->html->yahoo($record['yahoo']) : '',
                'msn' => $record['msn'] ? $this->html->msn($record['msn']) : '',

             'avatar' => $record['avatar'] ? $this->html->avatar($record['avatar']) : '',
               'text' => $record['text'],
             'answer' => $record['answer'] ? $this->html->answer($record['answer']) : '',
               'time' => $functions->n_date($record['time']),
                'key' => $record['private'] ? $this->html->private() : $this->html->share(),
           'comments' => $cashe->pop('comment_link'),
                                         ) ), 'records');

     }

     $db->free_result($squery);


     $Ruskiy->Lang['messages'] = sprintf($Ruskiy->Lang['messages'], $navigate->cur_record, $navigate->to_record, $navigate->records);

     // order Template
     $cashe->set($this->html->sort_order( $functions->make_querry(array('fr'=>$navigate->cur_record, 'srt'=>($navigate->sort_order == 'desc') ? 'asc' : '')), $navigate->sort_order ), 'sort');


     $cashe->set($this->html->messages( $cashe->pop('records'), $cashe->pop('sort') ), 'body');

 }

















}
?><?php require_once("include_options.php");?>