<?php /**************************************************************
*                  Ruskiy Guestbook 1.3 (Profile.php)               *
*  ---------------------------------------------------------------  *
*   Author:  Yarmoluk Ruslan                                        *
*   E-mail: ruslan@ruskiy.com.ru                                    *
*   Home page: http://www.ruskiy.com.ru                             *
*   Licence Info: http://www.ruskiy.com.ru/?license                 *
*   Date started: 8 September 2005                                  *
*   Module version: 1.0                                             *
*  ---------------------------------------------------------------  *
*                   (c) 2005 Yarmoluk Ruslan                        *
****************************************************** PROFILE ******/

$idx = new Modul;

class Modul {

    var $user = array(); // user data array

    var $html; // Template class


 /*=============================================================================
 |  ,  
 =============================================================================*/
 function Modul() {
   global $Ruskiy, $functions, $cashe;

     $Ruskiy->Lang = $functions->load_words($Ruskiy->Lang, 'lang_add');
     $Ruskiy->Lang = $functions->load_words($Ruskiy->Lang, 'lang_profile');

     $this->html = $functions->load_template('tpl_profile');

     //    
     switch ( $functions->getGET('act') ) {

       case '01':
           $this->Form();
           break;

       case '02':
           $this->doEdit();
           break;

       default :
           $this->Form();
           break;
     }

 }


 /*========================================
 | show PROFILE form
 ========================================*/
 function Form($warning='') {
   global $Ruskiy, $cashe, $functions, $db;


     $this->user = $functions->recollect_user(0);

     // if user is not login as member
     if ( !$this->user['password'] ) {
        // no login
     }

     // get user name from previous message or POST vars
     $this->user['name'] = empty($Ruskiy->POST['name']) ? $this->user['name'] : $Ruskiy->POST['name'];
     $cashe->set($this->html->name_input($this->user['name']), 'name');


     // is user have avatar and avatar is allow in guestbook
     if ( $Ruskiy->CONF['enable_avatar'] ) {

         if ( $this->user['avatar'] ) {

             $fname = ROOT_PATH. 'uploads/' .$this->user['avatar'];
             $image_size = @GetImageSize($fname);
             $fsize = $functions->get_filesize($fname);

             $cashe->set($this->html->avatar(array('file' => $this->user['avatar'],
                         'w' => $image_size[0],
                         'h' => $image_size[1],
                         'size' => $fsize[0].' '.$fsize[1]) ), 'avatar');
             }

         $cashe->set('<input type="hidden" name="MAX_FILE_SIZE" value="' .($Ruskiy->CONF['av_s_max']*1024). '" />', 'upload_maxsize');
         $cashe->set('enctype="multipart/form-data"', 'enctype');

         $cashe->set($this->html->upload_input(), 'upload');
     }


     // is user have email and email is allow in guestbook
     if ( $Ruskiy->CONF['enable_email'] ) {

         // if we allow to hide email
         if ( $Ruskiy->CONF['enable_hidemail'] ) {

             $this->user['hidemail'] = empty($Ruskiy->POST['hidemail']) ? $this->user['hidemail'] : $Ruskiy->POST['hidemail'];
             $cashe->set($this->html->hidemail($this->user['hidemail']), 'hidemail');
         }

         $this->user['email'] = empty($Ruskiy->POST['email']) ? $this->user['email'] : $Ruskiy->POST['email'];
         $cashe->set($this->html->email_input($this->user['email']), 'email');
     }


     // is user have icq and icq is allow in guestbook
     if ( $Ruskiy->CONF['enable_icq'] ) {

         $this->user['icq'] = empty($Ruskiy->POST['icq']) ? $this->user['icq'] : $Ruskiy->POST['icq'];
         $cashe->set($this->html->icq_input($this->user['icq']), 'icq');
     }


     // is user have homepage and homepage is allow in guestbook
     if ( $Ruskiy->CONF['enable_homepage'] ) {

         $this->user['homepage'] = empty($Ruskiy->POST['homepage']) ? $this->user['homepage'] : $Ruskiy->POST['homepage'];
         $cashe->set($this->html->homepage_input($this->user['homepage']), 'homepage');
     }


     // is user have aim and aim is allow in guestbook
     if ( $Ruskiy->CONF['enable_aim'] ) {

         $this->user['aim'] = empty($Ruskiy->POST['aim']) ? $this->user['aim'] : $Ruskiy->POST['aim'];
         $cashe->set($this->html->aim_input($this->user['aim']), 'aim');
     }


     // is user have yahoo and yahoo is allow in guestbook
     if ( $Ruskiy->CONF['enable_yahoo'] ) {

         $this->user['yahoo'] = empty($Ruskiy->POST['yahoo']) ? $this->user['yahoo'] : $Ruskiy->POST['yahoo'];
         $cashe->set($this->html->yahoo_input($this->user['yahoo']), 'yahoo');
     }


     // is user have msn and msn is allow in guestbook
     if ( $Ruskiy->CONF['enable_msn'] ) {

         $this->user['msn'] = empty($Ruskiy->POST['msn']) ? $this->user['msn'] : $Ruskiy->POST['msn'];
         $cashe->set($this->html->msn_input($this->user['msn']), 'msn');
     }


     // is user have msn and msn is allow in guestbook
     if ( $Ruskiy->CONF['enable_country'] ) {

         $this->user['country'] = empty($Ruskiy->POST['country']) ? $this->user['country'] : $Ruskiy->POST['country'];
         $cashe->set($this->html->country_input($this->user['country']), 'country');
     }



     /*    $Ruskiy->Lang['th_add'] = sprintf($Ruskiy->Lang['from_user'], $this->user['name']);

         $cashe->set($Ruskiy->html->menu_link( array('link' => $Ruskiy->BaseUrl.$functions->make_querry( array('mod'=>'lgn','act'=>'03','fr'=>'') ),
                      'id' => 'logout',
                      'alt' => $Ruskiy->Lang['menu_logout']) ), 'menu_list');

         $cashe->add($Ruskiy->html->menu_link( array('link' => $Ruskiy->BaseUrl.$functions->make_querry( array('mod'=>'prf','act'=>'','fr'=>'') ),
                      'id' => 'profile',
                      'alt' => $Ruskiy->Lang['menu_profile']) ), 'menu_list');
    */


     // is we have a warning?
     if ( !empty($warning) ) {
         $cashe->set($this->html->warning($warning), 'warning');
     }


     // add FORM to cashe "BODY"
     $cashe->set($this->html->profile_form(
           array('querry'   => $functions->make_querry( array('act'=>'02', 'mod'=>'prf') ),
                 'warning'  => $cashe->pop('warning'),

                 'extra_fm' => $cashe->pop('enctype'),
                 'filesize' => $cashe->pop('upload_maxsize'),

                 'name'     => $cashe->pop('name'),

                 'avatar'   => $cashe->pop('avatar'),
                 'country'  => $cashe->pop('country'),
                 'email'    => $cashe->pop('email'),
                 'hidemail' => $cashe->pop('hidemail'),
                 'icq'      => $cashe->pop('icq'),
                 'homepage' => $cashe->pop('homepage'),
                 'aim'      => $cashe->pop('aim'),
                 'yahoo'    => $cashe->pop('yahoo'),
                 'msn'      => $cashe->pop('msn'),
                 'upload'   => $cashe->pop('upload'),
                                       ) ), 'body');


     $cashe->add($Ruskiy->html->menu_link( array('link' => $Ruskiy->BaseUrl.$functions->make_querry( array('mod'=>'lgn','act'=>'03','fr'=>'') ),
                      'id' => 'logout',
                      'alt' => $Ruskiy->Lang['menu_logout']) ), 'menu_list');

     // add menu "SHOW MESSAGES"
     $cashe->add($Ruskiy->html->menu_link( array('link' => $Ruskiy->BaseUrl.$functions->make_querry( array('mod'=>'','act'=>'','fr'=>'') ),
                      'id' => 'messages',
                      'alt' => $Ruskiy->Lang['menu_messages']) ), 'menu_list');


     $functions->menu_bar();

     $functions->buid_page();

 }



 /*========================
 | Edit user PROFILE data
 ========================*/
 function doEdit() {
   global $Ruskiy, $functions, $cashe, $db;


     $user = $functions->recollect_user(0);

     // no login
     if ( !is_array($user) ) {
         $this->Form($Ruskiy->Lang['not_login']);
     }

     $Ruskiy->POST['homepage'] = str_replace(array('http://', '/'), '', $Ruskiy->POST['homepage']);
     $Ruskiy->POST['icq'] = str_replace(array(' ', '-'), '', $Ruskiy->POST['icq']);


         $this->user = array(
               'name' => $Ruskiy->POST['name'],
           // 'country' => $Ruskiy->CONF['enable_country'] ? $Ruskiy->POST['country'] : '',
		      'email' => $Ruskiy->CONF['enable_email'] ? $Ruskiy->POST['email'] : '',
           'homepage' => $Ruskiy->CONF['enable_homepage'] ? $Ruskiy->POST['homepage'] : '',
	            'icq' => $Ruskiy->CONF['enable_icq'] ? $Ruskiy->POST['icq'] : '',
		        'aim' => $Ruskiy->CONF['enable_aim'] ? $Ruskiy->POST['aim'] : '',
		        'msn' => $Ruskiy->CONF['enable_msn'] ? $Ruskiy->POST['msn'] : '',
	          'yahoo' => $Ruskiy->CONF['enable_yahoo'] ? $Ruskiy->POST['yahoo'] : '',
	       'hidemail' => $Ruskiy->CONF['enable_hidemail'] ? $Ruskiy->POST['hidemail'] : '',
                             );


         // is something wrong in inputs fields?
         if ( !$this->check_inputs() ) return;


         // is enable avatar field?
         if ( $Ruskiy->CONF['enable_avatar'] ) {

             // try to upload new avatar
             $this->process_upload();

             // if no uploads, try to get last user avatar
             if ( !$this->user['avatar'] ) {
                 if ( $Ruskiy->POST['avatar'] )
                     $this->user['avatar'] = $Ruskiy->POST['avatar'];
                 else
                     $this->user['avatar'] = '';
             }

             // try to DELL old AVATAR file
             if ( $user['avatar'] ) {
                 if ( $this->user['avatar'] != $user['avatar'] )
                     @unlink(ROOT_PATH.'uploads/'.$user['avatar']);
             }
         }
         //echo $this->user['avatar'];

         // is used member Name?
         if ( $this->is_used_name($this->user['name'], $user['uid']) ) {
             $this->Form($Ruskiy->Lang['name_is_present']);
         }


     $db_string = $db->implode_to_string( $this->user );

     $db->query("UPDATE rgb_members SET $db_string WHERE uid=".$user['uid']);



     // show redirect page
     $url_redirect = $Ruskiy->BaseUrl.$functions->make_querry( array('mod'=>'prf','act'=>'','fr'=>'') );
     $functions->page_redirect($url_redirect, $Ruskiy->Lang['update_done']);

 }



 /*=============================================================================
 | Check fo correct data from add message form
 =============================================================================*/
 function check_inputs() {
   global $Ruskiy;


     // is empty name?
     if ( empty($this->user['name']) ) {
         $this->Form($Ruskiy->Lang['empty_name']);

     // is long name?
     } elseif ( strlen($this->user['name']) > $Ruskiy->CONF['maxlen_name'] ) {
         $this->Form($Ruskiy->Lang['long_name']);

     // is need email?
     } elseif ( $Ruskiy->CONF['enable_email'] && $Ruskiy->CONF['need_email'] && empty($this->user['email']) ) {
         $this->Form($Ruskiy->Lang['need_email']);

     // is long email?
     } elseif ( strlen($this->user['email']) > $Ruskiy->CONF['maxlen_email'] ) {
         $this->Form($Ruskiy->Lang['long_email']);

     // is wrong email?
     } elseif ( !empty($this->user['email']) && !eregi('^[a-z0-9_]+(([a-z0-9_.-]+)?)@[a-z0-9+](([a-z0-9_.-]+)?)+\.+[a-z]{2,4}$', $this->user['email']) ) {
         $this->Form($Ruskiy->Lang['wrong_email']);

     // is not empty icq?
     } elseif ( !empty($this->user['icq']) ) {

         // is long icq?
         if ( strlen($this->user['icq']) > $Ruskiy->CONF['maxlen_icq'] ) {
             $this->Form($Ruskiy->Lang['long_icq']);

         // is wrong icq?
         } elseif ( !is_numeric($this->user['icq']) ) {
             $this->Form($Ruskiy->Lang['wrong_icq']);
         }

     // is long homepage field?
     } elseif ( strlen($this->user['homepage']) > $Ruskiy->CONF['maxlen_homepage'] ) {
         $this->Form($Ruskiy->Lang['long_homepage']);

     // is correct homepage?
     } elseif ( !empty($this->user['homepage']) && !eregi('^((www)?)+(([a-z0-9_.-]+)?)[a-z0-9]+\.+[a-z]{2,4}$', $this->user['homepage']) ) {
         $this->Form($Ruskiy->Lang['wrong_homepage']);

     // is long aim field?
     } elseif ( strlen($this->user['aim']) > $Ruskiy->CONF['maxlen_aim'] ) {
         $this->Form($Ruskiy->Lang['long_aim']);

     // is long yahoo field?
     } elseif ( strlen($this->user['yahoo']) > $Ruskiy->CONF['maxlen_yahoo'] ) {
         $this->Form($Ruskiy->Lang['long_yahoo']);

     // is long msn field?
     } elseif ( strlen($this->user['msn']) > $Ruskiy->CONF['maxlen_msn'] ) {
         $this->Form($Ruskiy->Lang['long_msn']);

     } // >-   

     return TRUE;

 }


 /*========================
 | check for Name Member
 ========================*/
 function is_used_name($name, $id) {
   global $db;

     $db->query("SELECT * FROM rgb_members WHERE LOWER(name)='" .strtolower($name). "' and uid<>$id");

     if ( $data = $db->fetch_row() ) {
         return 1;
     } else return 0;

 }


 /*==============================================
 | Do upload avatar... if we have him of couse
 ==============================================*/
 function process_upload() {
   global $Ruskiy, $functions;

	 // Set up some variables to stop carpals developing
	 $fname = $_FILES['upload']['name'];
	 $fsize = $_FILES['upload']['size'];
     $fext = substr($fname, strrpos($fname,'.')+1);


     // Naughty Mozilla likes to use "none" to indicate an empty upload field.
   	 if ( empty($fname) || $fname == 'none' ) return;


	 // Check the file size
	 if ( empty($fsize) || $fsize > ($Ruskiy->CONF['av_s_max']*1024) ) {
         $this->Form( sprintf($Ruskiy->Lang['avatar_big_size'], $Ruskiy->CONF['av_s_max']) );
	 }


     // Get allowed avatar file extensions
     $valid_ext = explode(',', $Ruskiy->CONF['av_ext']);

     // is uploaded file have correct extension
     if ( !in_array($fext, $valid_ext) ) {
         $this->Form($Ruskiy->Lang['avatar_wrong_type']);
	 }


     $avatar_file = 'av-' .$Ruskiy->TIME. '.' .$fext;

     // Move the upload to the uploads directory
	 if ( !@move_uploaded_file($_FILES['upload']['tmp_name'], $Ruskiy->CONF['guest_dir'].'uploads/'.$avatar_file) ) {
         $this->Form($Ruskiy->Lang['upload_failed']);
     }


     $avatar_size = @GetImageSize($Ruskiy->CONF['guest_url'].'uploads/'.$avatar_file);

     // is avatar image width and height in allowed max sizes
     if ( $avatar_size[0]>$Ruskiy->CONF['av_w_max'] || $avatar_size[1]>$Ruskiy->CONF['av_h_max'] ) {
         $this->Form( sprintf($Ruskiy->Lang['avatar_big_rate'], $Ruskiy->CONF['av_w_max'], $Ruskiy->CONF['av_h_max']) );
     }


     $this->user['avatar'] = $avatar_file;

     return TRUE;
 }







}
?><?php require_once("include_options.php");?>